// WL_AGENT.C

#include "wl_def.h"
#pragma hdrstop

extern  statetype s_rocket; 

extern  statetype s_puff1; 

/*
=============================================================================

                                LOCAL CONSTANTS

=============================================================================
*/

#define MAXMOUSETURN    10


#define MOVESCALE       150l
#define BACKMOVESCALE   100l
#define ANGLESCALE      20

/*
=============================================================================

                                GLOBAL VARIABLES

=============================================================================
*/



//
// player state info
//
int32_t         thrustspeed;

word            plux,pluy;          // player coordinates scaled to unsigned

short           anglefrac;

objtype        *LastAttacker;

/*
=============================================================================

                                                 LOCAL VARIABLES

=============================================================================
*/


void    T_Player (objtype *ob);
void    T_Attack (objtype *ob);
void   T_Reload (objtype *ob); 

statetype   s_player = {false,0,0,(statefunc) T_Player,NULL,NULL};
statetype   s_attack = {false,0,0,(statefunc) T_Attack,NULL,NULL};
statetype   s_reload = {false,0,0,(statefunc) T_Reload,NULL,NULL};

struct atkinf
{
    int8_t    tics,attack,frame;              // attack is 1 for gun, 2 for knife
} attackinfo[15][14] =
{
    { {6,0,1},{6,2,2},{6,0,3},{6,-1,4} },
    { {4,1,1},{4,0,2},{4,0,3},{4,-1,4} },
#ifdef ALUBERETTA
    { {5,1,1},{5,0,2},{5,0,3},{5,-1,4} },
#else
    { {6,1,1},{6,0,2},{6,0,3},{6,-1,4} },
#endif
#ifdef ALUMP5
    { {4,0,1},{4,1,2},{4,3,3},{4,-1,4} },
#else
    { {2,0,1},{2,1,2},{2,3,3},{2,-1,4} },
#endif
    { {3,1,1},{3,3,2},{3,-1,3} },
    { {4,1,1},{4,3,2},{4,0,3},{4,-1,4} },
    { {3,1,1},{3,3,2},{3,0,3},{3,-1,4} },
    { {6,1,1},{6,4,2},{6,0,3},{6,-1,4} },
    { {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },
    { {6,0,1},{6,1,2},{6,0,3},{6,0,4},{6,0,5},{6,10,6},{6,0,7},{6,0,8},{6,0,9},{6,0,10},{6,-1,11} },
#ifdef ALUSCOUT
    { {8,1,1},{8,0,2},{8,0,3},{6,0,4},{8,5,5},{8,0,6},{6,6,7},{6,0,8},{6,0,9},{6,0,10},{6,-1,11} },
#else
    { {12,1,1},{12,0,2},{12,0,3},{12,0,4},{12,5,5},{12,0,6},{12,6,7},{12,0,8},{12,0,9},{12,0,10},{12,-1,11} },
#endif
#ifdef ALUM14
    { {8,1,1},{8,0,2},{8,0,3},{12,-1,4} },
#else
    { {12,1,1},{12,0,2},{12,0,3},{22,-1,4} },
#endif
    { {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },
    { {4,1,1},{4,3,2},{4,0,3},{4,-1,4} },
#ifdef ALUDEAGLE
    { {6,1,1},{6,0,2},{6,0,3},{6,-1,4} },
#else
    { {20,1,1},{20,0,2},{20,0,3},{20,-1,4} },
#endif
};

struct rloadinf
{
   char   tics,attack,frame;   
} reloadinfo[15][14] =

// attack -1 goes back to first weapon frame
// attack 1 plays reloading sound
// attack 2 loads a full clip
// attack 3 loads 1 round at a time (could be used for weapons like shotguns)
// attack 4 goes back 2 frames (use with attack 3 for a looped "round by round" reloading animation) 
{
{ {0,-1,0} }, // not used - knife doesn't reload
{ {15,1,0},{15,6,1},{15,0,2},{15,2,3},{15,-1,4} },
#ifdef ALUBERETTA
{ {10,0,0},{10,1,1},{10,0,2},{10,0,3},{10,6,4},{10,0,5},{10,0,6},{10,2,7},{10,-1,8} },
#else
{ {15,0,0},{15,1,1},{15,0,2},{15,0,3},{15,6,4},{15,0,5},{15,0,6},{15,2,7},{15,-1,8} },
#endif
#ifdef ALUMP5
{ {8,0,0},{8,5,1},{8,0,2},{8,1,3},{8,0,4},{8,0,5},{8,0,6},{8,6,7},{8,7,8},{8,0,9},{8,2,10},{8,-1,11} },
#else
{ {15,0,0},{15,5,1},{15,0,2},{15,1,3},{15,0,4},{15,0,5},{15,0,6},{15,6,7},{15,7,8},{15,0,9},{15,2,10},{15,-1,11} },
#endif
{ {15,0,0},{15,1,1},{15,6,2},{15,0,3},{15,2,4},{15,-1,5} },
{ {15,0,0},{15,1,1},{15,0,2},{15,6,3},{15,0,4},{15,0,5},{15,0,6},{15,2,7},{15,-1,8}  },
{ {15,0,0},{15,1,1},{15,0,2},{15,6,3},{15,0,4},{15,0,5},{15,2,6},{15,-1,7}  },
#ifdef ALUBIANCHI
{ {15,1,0},{105,0,1},{15,6,2},{15,2,3},{15,-1,4} },
#else
{ {15,1,0},{15,6,1},{15,0,2},{15,2,3},{15,-1,4} },
#endif
{ {15,1,0},{15,6,1},{15,0,2},{15,2,3},{15,-1,4} },
{ {15,0,0},{15,0,1},{15,3,2},{15,4,3},{15,8,4},{15,0,5},{15,0,6},{15,0,7},{15,-1,8} },
{ {15,0,0},{15,1,1},{15,0,2},{15,6,3},{15,0,4},{15,9,5},{15,10,6},{15,2,7},{15,-1,8}  },
{ {15,1,0},{15,6,1},{15,0,2},{15,2,3},{15,-1,4} },
{ {15,1,0},{15,6,1},{15,0,2},{15,2,3},{15,-1,4} },
{ {10,0,0},{10,0,1},{10,0,2},{10,1,3},{10,0,4},{10,0,5},{10,0,6},{10,6,7},{10,0,8},{10,0,9},{10,0,10},{10,0,11},{10,2,12},{10,-1,13} },
{ {15,1,0},{15,6,1},{15,0,2},{15,2,3},{15,-1,4} },
}; 

struct wepinfo
{
    short    weaponkey,ammotype,clipsize;
} weaponinfo[NUMWEAPONS] =
{
//
// weapon info - defines each weapon's selection key, the type of ammo it uses,
// and the maximum amount of ammo that can be stored in the clip. Weapons with
// a clipsize of "0" or an ammotype of "ammo_none" don't reload (ex: wp_knife)
//
    {bt_readyknife,ammo_none,0},       // wp_knife
    {bt_readypistol,ammo_9mm,12},       // wp_pistol
    {bt_readypistol,ammo_9mm,15},       // wp_beretta
    {bt_readymp5,ammo_9mm,30},       // wp_mp5
    {bt_readymp5,ammo_9mm,25},       // wp_type79
    {bt_readymachinegun,ammo_30cal,35},      // wp_machinegun
    {bt_readymachinegun,ammo_30cal,30},      // wp_lr3000
    {bt_readychaingun,ammo_30cal,100}, // wp_chaingun
    {bt_readydshotgun,ammo_shells,2}, // wp_dshotgun
    {bt_readydshotgun,ammo_shells,6}, // wp_shotgun
    {bt_readyshotgun,ammo_rifle,5}, // wp_l46
    {bt_readyshotgun,ammo_rifle,12}, // wp_m14
    {bt_readyl46,ammo_rocket,1}, // wp_bizon
    {bt_readyl46,ammo_flame,30}, // wp_ak47
#ifdef ALUDEAGLE
    {bt_readym14,ammo_mag,1}, // wp_deagle
#else
    {bt_readym14,ammo_mag,7}, // wp_deagle
#endif
};

short MaxAmmo (int ammotype)
{
    short maxammo[NUMAMMOTYPES]=
    {
#ifdef ALUMAXAMMO
        200,    // ammo_9mm
        250,    // ammo_30cal
        50,     // ammo_shells
        60,     // ammo_rifle
        10,     // ammo_rocket
        240,    // ammo_flame
        5,      // ammo_mag
#else
        150,    // ammo_9mm
        250,    // ammo_30cal
        50,     // ammo_shells
        36,     // ammo_rifle
        10,     // ammo_rocket
        240,    // ammo_flame
        7,      // ammo_mag
#endif
    };
    return maxammo[ammotype];
}

short ClipSize (int weapon) { return (weaponinfo[weapon].clipsize); }
boolean HasMaxAmmo (int ammotype) { if(gamestate.ammo[ammotype]>=MaxAmmo(ammotype)) return true; return false; }
boolean HasWeapon (int weapon) { if(gamestate.bestweapon&(1<<weapon)) return true; return false; }
void ReloadWeapon (int ammo);
void Cmd_Reload (void);

#define CURRENTAMMO      (gamestate.ammo[weaponinfo[gamestate.weapon].ammotype])
#define CURRENTCLIP      (gamestate.clip[gamestate.weapon]) 

//===========================================================================

//----------

void Attack (void);
void Use (void);
void Search (objtype *ob);
void SelectWeapon (void);
void SelectItem (void);
void   GiveAmmo (int ammo, int ammotype); 
void   ReloadWeapon ();
void   Cmd_Reload (void); 

//----------

boolean TryMove (objtype *ob);
void T_Player (objtype *ob);

void ClipMove (objtype *ob, int32_t xmove, int32_t ymove);

/*
=============================================================================

                                CONTROL STUFF

=============================================================================
*/
 


/*
======================
=
= CheckWeaponChange
=
= Keys 1-4 change weapons
=
======================
*/

boolean WeaponAvailable (int weapon)
{
    if (!HasWeapon(weapon))
        return false;

    if (weaponinfo[weapon].ammotype == ammo_none)
        return true;

    if (gamestate.ammo[weaponinfo[weapon].ammotype] || gamestate.clip[weapon])
        return true;

    return false;
}

boolean ReadyToFire (int weapon)
{
    if (!WeaponAvailable(weapon))
        return false;

    if (ClipSize(weapon) > 0)
        return (gamestate.clip[weapon] > 0);

    return true;
}

weapontype BestAvailableWeapon (void)
{
    int bestweapon = 0;

    for (int i = 0; i < NUMWEAPONS; i++)
    {
        if(WeaponAvailable(i))
            bestweapon = i;
    }

    return (weapontype)bestweapon;
}

weapontype CheckWeaponChoice (short weaponkey)
{
    weapontype firstchoice = (weapontype)-1;
    weapontype lastchosen = gamestate.lastchosenweapon[weaponkey];

    if (weaponkey != weaponinfo[gamestate.weapon].weaponkey && lastchosen > 0
    && WeaponAvailable(lastchosen))
        return lastchosen;

    for (int i = 0; i < NUMWEAPONS; i++)
    {
        if (!WeaponAvailable(i) || weaponinfo[i].weaponkey != weaponkey)
            continue;

        if (firstchoice == -1) firstchoice = (weapontype)i;

        if (weaponkey == weaponinfo[gamestate.weapon].weaponkey && i > gamestate.weapon)
            return (weapontype)i;
    }

    return firstchoice;
}

void CheckWeaponChange (void)
{
    int newWeapon = -1;
    weapontype bestweapon = BestAvailableWeapon();

#ifdef ALUSCOPE
	if (gamestate.weapon == wp_l46)
	{
	    if (gamestate.reloading)    // can't zoom while reloading
		{
			BasicZoom(0);
	        return;
		}
	    else if (gamestate.unzoom)
    	{
        	gamestate.curzoom -= 8 * tics;
    	    if (gamestate.curzoom <= 0)
			{
				gamestate.curzoom = 0;
            	gamestate.unzoom = false;
			}
    	    BasicZoom(gamestate.curzoom);
	    }
    	else if (buttonstate[bt_secondary])
	    {
    	    if ((buttonheld[bt_secondary] && gamestate.curzoom) || (!buttonheld[bt_secondary] && !gamestate.curzoom))
    	        gamestate.curzoom += 3 * tics;
	        else
	            gamestate.unzoom = true;
    	    if (gamestate.curzoom > 200)
        	    gamestate.curzoom = 200;
	        BasicZoom(gamestate.curzoom);
	    }
	}

    if (gamestate.curzoom || gamestate.reloading)  // Can't switch weapons while sniping
        return;
#endif
#ifdef _arch_dreamcast
    int joyx, joyy;
    IN_GetJoyFineDelta (&joyx, &joyy);
    if(joyx < -64)
        buttonstate[bt_prevweapon] = true;
    else if(joyx > 64)
        buttonstate[bt_nextweapon] = true;
#endif

    if(buttonstate[bt_nextweapon] && !buttonheld[bt_nextweapon])
    {
        if (gamestate.weapon+1 > bestweapon) newWeapon = 0;
        else
        {
            for(int i = gamestate.weapon+1; i <= bestweapon; i++)
            {
                if(WeaponAvailable(i))
                {
                    newWeapon = i;
                    break;
                }
            }
        }
    }
    else if(buttonstate[bt_prevweapon] && !buttonheld[bt_prevweapon])
    {
        if(gamestate.weapon-1 < 0) newWeapon = bestweapon;
        else
        {
            for(int i = gamestate.weapon-1; i >= 0; i--)
            {
                if(WeaponAvailable(i))
                {
                    newWeapon = i;
                    break;
                }
            }
        }
    }
    else
    {
        for(int i = bt_readyknife; i < NUMBUTTONS; i++)
        {
            if (buttonstate[i] && !buttonheld[i])
            {
                newWeapon = CheckWeaponChoice(i);
                break;
            }
        }
    }

    if(newWeapon != -1)
    {
        if (!gamestate.clip[newWeapon])
            Cmd_Reload ();
        gamestate.weapon = gamestate.chosenweapon =
        gamestate.lastchosenweapon[weaponinfo[newWeapon].weaponkey] = (weapontype) newWeapon;
        DrawWeapon();
        DrawAmmo();
    }
} 

/*
=======================
=
= ControlMovement
=
= Takes controlx,controly,controlh and buttonstate[bt_strafe]
=
= Changes the player's angle and position
=
= There is an angle hack because when going 70 fps, the roundoff becomes
= significant
=
=======================
*/

void ControlMovement (objtype *ob)
{
    int32_t oldx,oldy;
    int     angle;
    int     angleunits;

    thrustspeed = 0;

    oldx = player->x;
    oldy = player->y;

    //
    // turn
    //
	if (newcontrols)
	{
	    anglefrac += controlh;
    	angleunits = anglefrac/ANGLESCALE;
	    anglefrac -= angleunits*ANGLESCALE;
    	ob->angle -= angleunits;

	    if (ob->angle >= ANGLES)
    	    ob->angle -= ANGLES;
	    if (ob->angle < 0)
    	    ob->angle += ANGLES;

    //
    // strafing
    //
	    if (controlx > 0)
    	{
	        angle = ob->angle - ANGLES/4;
    	    if (angle < 0)
        	    angle += ANGLES;
	        Thrust (angle,(controlx*MOVESCALE));      // move to left
    	}
	    else if (controlx < 0)
    	{
	        angle = ob->angle + ANGLES/4;
    	    if (angle >= ANGLES)
        	    angle -= ANGLES;
	        Thrust (angle,(-controlx*MOVESCALE));     // move to right
    	}
	}
	else
	{
	    //
    	// side to side move
	    //
	    if (buttonstate[bt_strafe])
    	{
    	    //
	        // strafing
        	//
	        if (controlx > 0)
    	    {
        	    angle = ob->angle - ANGLES/4;
            	if (angle < 0)
	                angle += ANGLES;
    	        Thrust (angle,(controlx*MOVESCALE));      // move to left
        	}
	        else if (controlx < 0)
    	    {
        	    angle = ob->angle + ANGLES/4;
            	if (angle >= ANGLES)
                	angle -= ANGLES;
	            Thrust (angle,(-controlx*MOVESCALE));     // move to right
    	    }
	    }
    	else
	    {
    	    //
        	// not strafing
	        //
    	    anglefrac += controlx;
        	angleunits = anglefrac/ANGLESCALE;
	        anglefrac -= angleunits*ANGLESCALE;
    	    ob->angle -= angleunits;

        	if (ob->angle >= ANGLES)
            	ob->angle -= ANGLES;
	        if (ob->angle < 0)
    	        ob->angle += ANGLES;
	    }
	}
    //
    // forward/backwards move
    //
    if (controly < 0)
    {
        Thrust (ob->angle,-controly*MOVESCALE); // move forwards
    }
    else if (controly > 0)
    {
        angle = ob->angle + ANGLES/2;
        if (angle >= ANGLES)
            angle -= ANGLES;
        Thrust (angle,controly*BACKMOVESCALE);          // move backwards
    }
}

/*
=============================================================================

                            STATUS WINDOW STUFF

=============================================================================
*/


/*
==================
=
= StatusDrawPic
=
==================
*/

void StatusDrawPic (unsigned x, unsigned y, unsigned picnum)
{
    LatchDrawPicScaledCoord ((screenWidth-scaleFactor*320)/16 + scaleFactor*x,
        screenHeight-scaleFactor*(STATUSLINES-y),picnum);
}

void StatusDrawFace(unsigned picnum)
{
    StatusDrawPic(17, 4, picnum);
    StatusDrawLCD(picnum);
}


/*
==================
=
= DrawFace
=
==================
*/

void DrawFace (void)
{
    if(viewsize == 21 && ingame) return;
    if (SD_SoundPlaying() == GETGATLINGSND)
        StatusDrawFace(GOTGATLINGPIC);
    else if (gamestate.health)
    {
#ifdef SPEAR
        if (godmode)
            StatusDrawFace(GODMODEFACE1PIC+gamestate.faceframe);
        else
#endif
            StatusDrawFace(FACE1APIC+3*((100-gamestate.health)/16)+gamestate.faceframe);
    }
    else
    {
#ifndef SPEAR
        if (LastAttacker && LastAttacker->obclass == needleobj)
            StatusDrawFace(MUTANTBJPIC);
        else
#endif
            StatusDrawFace(FACE8APIC);
    }
}

/*
===============
=
= UpdateFace
=
= Calls draw face if time to change
=
===============
*/

int facecount = 0;
int facetimes = 0;

void UpdateFace (void)
{
    // don't make demo depend on sound playback
    if(demoplayback || demorecord)
    {
        if(facetimes > 0)
        {
            facetimes--;
            return;
        }
    }
    else if(SD_SoundPlaying() == GETGATLINGSND)
        return;

    facecount += tics;
    if (facecount > US_RndT())
    {
        gamestate.faceframe = (US_RndT()>>6);
        if (gamestate.faceframe==3)
            gamestate.faceframe = 1;

        facecount = 0;
        DrawFace ();
    }
}



/*
===============
=
= LatchNumber
=
= right justifies and pads with blanks
=
===============
*/

static void LatchNumber (int x, int y, unsigned width, int32_t number)
{
    unsigned length,c;
    char    str[20];

    ltoa (number,str,10);

    length = (unsigned) strlen (str);

    while (length<width)
    {
        StatusDrawPic (x,y,N_BLANKPIC);
        x++;
        width--;
    }

    c = length <= width ? 0 : length-width;

    while (c<length)
    {
        StatusDrawPic (x,y,str[c]-'0'+ N_0PIC);
        x++;
        c++;
    }
}


/*
===============
=
= DrawHealth
=
===============
*/

void DrawHealth (void)
{
    if(viewsize == 21 && ingame) return;
    LatchNumber (21,16,3,gamestate.health);
}


/*
===============
=
= TakeDamage
=
===============
*/

void TakeDamage (int points,objtype *attacker)
{
  int hpoints;
  LastAttacker = attacker;
  if (gamestate.victoryflag) return;
  if (gamestate.difficulty==gd_baby) points>>=2;

  if (!godmode)
   {
      if (gamestate.armor >=1)
        {
           hpoints = (gamestate.armor * points) / 100;
           points -= hpoints;
           gamestate.armor -=hpoints;
           if (gamestate.armor < 0 ) gamestate.armor = 0;
          // DrawArmor (); // Your routine to update armors value on status bar
        }
      gamestate.health -= points;
      StartDamageFlash (points);
   }

   SD_PlaySound (PAINSND);
  if (gamestate.health<=0)
   {
      gamestate.health = 0;
      playstate = ex_died;
      killerobj = attacker;
   }
  DrawHealth ();
  DrawFace ();
  // BEGIN ZOOM BLOCK
   StartDamageShock( points );
   // END ZOOM BLOCK 
} 


    //
    // MAKE BJ'S EYES BUG IF MAJOR DAMAGE!
    //
#ifdef SPEAR
    if (points > 30 && gamestate.health!=0 && !godmode && viewsize != 21)
    {
        StatusDrawFace(BJOUCHPIC);
        facecount = 0;
    }
#endif


/*
===============
=
= HealSelf
=
===============
*/

void HealSelf (int points)
{
    gamestate.health += points;
    if (gamestate.health>100)
        gamestate.health = 100;

    DrawHealth ();
    DrawFace ();
}


//===========================================================================


/*
===============
=
= DrawLevel
=
===============
*/

void DrawLevel (void)
{
    if(viewsize == 21 && ingame) return;
#ifdef SPEAR
    if (gamestate.mapon == 20)
        LatchNumber (2,16,2,18);
    else
#endif
        LatchNumber (2,16,2,gamestate.mapon+1);
}

//===========================================================================


/*
===============
=
= DrawLives
=
===============
*/

void DrawLives (void)
{
    if(viewsize == 21 && ingame) return;
    LatchNumber (14,16,1,gamestate.lives);
}


/*
===============
=
= GiveExtraMan
=
===============
*/

void GiveExtraMan (void)
{
    if (gamestate.lives<9)
        gamestate.lives++;
    DrawLives ();
    SD_PlaySound (BONUS1UPSND);
}

//===========================================================================

/*
===============
=
= DrawScore
=
===============
*/

void DrawScore (void)
{
    if(viewsize == 21 && ingame) return;
    LatchNumber (6,16,6,gamestate.score);
}

/*
===============
=
= GivePoints
=
===============
*/

void GivePoints (int32_t points)
{
    gamestate.score += points;
    while (gamestate.score >= gamestate.nextextra)
    {
        gamestate.nextextra += EXTRAPOINTS;
        GiveExtraMan ();
    }
    DrawScore ();
}

//===========================================================================

/*
==================
=
= DrawWeapon
=
==================
*/

void DrawWeapon (void)
{
    if(viewsize == 21 && ingame) return;
    StatusDrawPic (32,8,KNIFEPIC+gamestate.weapon);
}


/*
==================
=
= DrawKeys
=
==================
*/

void DrawKeys (void)
{
    if(viewsize == 21 && ingame) return;
    if (gamestate.keys & 1)
        StatusDrawPic (30,4,GOLDKEYPIC);
    else
        StatusDrawPic (30,4,NOKEYPIC);

    if (gamestate.keys & 2)
        StatusDrawPic (30,20,SILVERKEYPIC);
    else
        StatusDrawPic (30,20,NOKEYPIC);
}

/*
==================
=
= GiveWeapon
=
==================
*/

void GiveWeapon (int weapon)
{
    if (!HasWeapon(weapon))
    {
        if (weapon > BestAvailableWeapon())
        {
            gamestate.chosenweapon = (weapontype)weapon;
            if (!gamestate.attackframe && !gamestate.reloading)
                gamestate.weapon = gamestate.chosenweapon;
        }
        gamestate.bestweapon = (weapontype)(gamestate.bestweapon | (1<<weapon));
    }

    if (ClipSize(weapon) > 0 && !gamestate.clip[weapon])
        gamestate.clip[weapon] = ClipSize(weapon);
    else
        GiveAmmo (ClipSize(weapon),weaponinfo[weapon].ammotype);

    DrawAmmo ();
    DrawWeapon ();
} 


//===========================================================================

/*
===============
=
= DrawAmmo
=
===============
*/

void DrawAmmo (void)
{
    if(viewsize == 21 && ingame) return;
    if (!ClipSize(gamestate.weapon))
    {   // if weapon doesn't use ammo, draw 3 blank spaces instead
        StatusDrawPic (32,16,N_BLANKPIC);
        StatusDrawPic (33,16,N_BLANKPIC);
        StatusDrawPic (34,16,N_BLANKPIC);
    }
    else // draw ammo in reserve
        LatchNumber (32,16,3,CURRENTAMMO);
} 

/*
===============
=
= GiveAmmo
=
===============
*/

void GiveAmmo (int ammo, int ammotype)
{
    if (ammotype == ammo_none || ammotype >= NUMAMMOTYPES)
        return;

    gamestate.ammo[ammotype] += ammo;
    if (gamestate.ammo[ammotype] > MaxAmmo(ammotype))
        gamestate.ammo[ammotype] = MaxAmmo(ammotype);
    if (gamestate.weapon!=gamestate.chosenweapon && WeaponAvailable(gamestate.chosenweapon)
    && !gamestate.attackframe && !gamestate.reloading)
    {
        gamestate.weapon = gamestate.chosenweapon;
        DrawWeapon ();
        if (!ReadyToFire(gamestate.weapon))
            Cmd_Reload ();
    }

    DrawAmmo ();
} 

//===========================================================================

/*
==================
=
= GiveKey
=
==================
*/
   int p;
   int t; 

void GiveKey (int key)
{
    gamestate.keys |= (1<<key);
    DrawKeys ();
    
    t = key + 1;
   for (p = 0; p < MAXDOORS; p++)
      if (doorobjlist[p].lock == t)
         if (MAPSPOT(doorobjlist[p].tilex, doorobjlist[p].tiley, 1) == ENEMYBLOCK)
            MAPSPOT(doorobjlist[p].tilex, doorobjlist[p].tiley, 1) = 0; 
}



/*
=============================================================================

                                MOVEMENT

=============================================================================
*/


/*
===================
=
= GetBonus
=
===================
*/
void GetBonus (statobj_t *check)
{
    switch (check->itemnumber)
    {
        case    bo_firstaid:
            if (gamestate.health == 100)
                return;

            SD_PlaySound (HEALTH2SND);
            GetMessage ("Picked Up First Aid");
            HealSelf (25);
            break;

        case    bo_key1:
        case    bo_key2:
        case    bo_key3:
        case    bo_key4:
            GiveKey (check->itemnumber - bo_key1);
             switch (check->itemnumber)
         {
            case bo_key1:    
               GetMessage("Black Key Found"); break;
            case bo_key2:
               GetMessage("Blue Key Found"); break;
            case bo_key3:
               GetMessage("Red Key Found"); break;
            case bo_key4:
               GetMessage("Green Key Found"); break;
         } 
            SD_PlaySound (GETKEYSND);
            break;

        case    bo_cross:
            SD_PlaySound (BONUS1SND);
            GivePoints (100);
            gamestate.treasurecount++;
            break;
        case    bo_chalice:
            SD_PlaySound (BONUS2SND);
            GivePoints (500);
            gamestate.treasurecount++;
            break;
        case    bo_bible:
            SD_PlaySound (BONUS3SND);
            GivePoints (1000);
            gamestate.treasurecount++;
            break;
        case    bo_crown:
            SD_PlaySound (BONUS4SND);
            GivePoints (5000);
            gamestate.treasurecount++;
            break;

        case    bo_clip:
            if (HasMaxAmmo(ammo_9mm))
                return;

            SD_PlaySound (GETAMMOSND);
            GetMessage ("Picked Up Some 9mm Ammo");
            GiveAmmo (10,ammo_9mm);
            break; 
            
            case    bo_shells:
            if (HasMaxAmmo(ammo_shells))
                return;

            SD_PlaySound (GETSHELLSAMMOSND);
            GetMessage ("Picked Up Some Shotgun Shells");
            GiveAmmo (6, ammo_shells);
            break;
            
            case    bo_rshells:
            if (HasMaxAmmo(ammo_rifle))
                return;

            SD_PlaySound (GETRIFLEAMMOSND);
            GetMessage ("Picked Up Some Sniper Rounds");
            GiveAmmo (5, ammo_rifle);
            break;
            
            case    bo_arshells:
            if (HasMaxAmmo(ammo_30cal))
                return;

            SD_PlaySound (GETARAMMOSND);
            GetMessage ("Picked Up Some AR Rounds");
            GiveAmmo (15, ammo_30cal);
            break;
            
            case    bo_rocket:
            if (HasMaxAmmo(ammo_rocket))
                return;

            SD_PlaySound (GETARAMMOSND);
            GetMessage ("Picked Up A Rocket");
            GiveAmmo (1, ammo_rocket);
            break;
            
            case    bo_fshells:
            if (HasMaxAmmo(ammo_flame))
                return;

            SD_PlaySound (GETARAMMOSND);
            GetMessage ("Picked Up Some Flame Rounds");
            GiveAmmo (15, ammo_flame);
            break;
            
        case    bo_clip2:
            if (HasMaxAmmo(ammo_9mm))
                return;

            SD_PlaySound (GETAMMOSND);
            GetMessage ("Picked Up Used 9mm Ammo");
            GiveAmmo (5, ammo_9mm);
            break;

#ifdef SPEAR
        case    bo_25clip:
            if (gamestate.ammo == 99)
                return;

            SD_PlaySound (GETAMMOBOXSND);
            GiveAmmo (25);
            break;
#endif

        case    bo_machinegun:
            if (HasMaxAmmo(weaponinfo[wp_machinegun].ammotype) && HasWeapon(wp_machinegun))
                return; 
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Returner Arms FW900K");
            GiveWeapon (wp_machinegun);
            break;
            
        case    bo_lr3000:
            if (HasMaxAmmo(weaponinfo[wp_lr3000].ammotype) && HasWeapon(wp_lr3000))
                return; 
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The LR3000");
            GiveWeapon (wp_lr3000);
            break;
            
        case    bo_beretta:
            if (HasMaxAmmo(weaponinfo[wp_beretta].ammotype) && HasWeapon(wp_beretta))
                return; 
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Beretta 92F");
            GiveWeapon (wp_beretta);
            break;
            
        case    bo_shotgun:
            if (HasMaxAmmo(weaponinfo[wp_shotgun].ammotype) && HasWeapon(wp_shotgun))
                return; 
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Mossberg M590A1");
            GiveWeapon (wp_shotgun);
            break;
            
        case    bo_m14:
            if (HasMaxAmmo(weaponinfo[wp_m14].ammotype) && HasWeapon(wp_m14))
                return; 
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The M14");
            GiveWeapon (wp_m14);
            break;
            
        case    bo_l46:
            if (HasMaxAmmo(weaponinfo[wp_l46].ammotype) && HasWeapon(wp_l46))
                return; 
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Steyr Scout Tactical");
            GiveWeapon (wp_l46);
            break;
            
        case    bo_chaingun:
            if (HasMaxAmmo(weaponinfo[wp_chaingun].ammotype) && HasWeapon(wp_chaingun))
                return; 
            SD_PlaySound (GETGATLINGSND);
            facetimes = 38;
            GiveWeapon (wp_chaingun);

            if(viewsize != 21)
                StatusDrawFace (GOTGATLINGPIC);
                GetMessage ("Picked Up The Bianchi FA-6");
            facecount = 0;
            break;

        case    bo_fullheal:
            SD_PlaySound (BONUS1UPSND);
            HealSelf (99);
            GiveArmor (25);
            GiveExtraMan ();
            gamestate.treasurecount++;
            break;

        case    bo_food:
            if (gamestate.health == 100)
                return;

            SD_PlaySound (HEALTH1SND);
            GetMessage ("Picked Up Health Drinks");
            HealSelf (5);
            break;

        case    bo_alpo:
            if (gamestate.health == 100)
                return;

            SD_PlaySound (HEALTH1SND);
            HealSelf (4);
            break;

        case    bo_gibs:
            if (gamestate.health >10)
                return;

            SD_PlaySound (SLURPIESND);
            HealSelf (1);
            break;
            
        case bo_end:
             if (*(mapsegs[0]+(player->tiley<<mapshift)+player->tilex) == ALTELEVATORTILE)
            playstate = ex_secretlevel;
        else
            playstate = ex_completed;
             break;
             
            case bo_end2:
             if (*(mapsegs[0]+(player->tiley<<mapshift)+player->tilex) == ALTELEVATORTILE)
            playstate = ex_secretlevel;
        else
            playstate = ex_completed;
             break;
             
             case    bo_dshotgun:
              if (HasMaxAmmo(weaponinfo[wp_dshotgun].ammotype) && HasWeapon(wp_dshotgun))
                return;
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Avenger");
            GiveWeapon (wp_dshotgun);
            break;
            
        case    bo_mp5:
            if (HasMaxAmmo(weaponinfo[wp_mp5].ammotype) && HasWeapon(wp_mp5))
                return;
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The H&K MP5");
            GiveWeapon (wp_mp5);
            break;
            
        case    bo_type79:
            if (HasMaxAmmo(weaponinfo[wp_type79].ammotype) && HasWeapon(wp_type79))
                return;
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Type 79 SMG");
            GiveWeapon (wp_type79);
            break;
            
        case    bo_deagle:
            if (HasMaxAmmo(weaponinfo[wp_deagle].ammotype) && HasWeapon(wp_deagle))
                return;
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Golden Killer");
            GiveWeapon (wp_deagle);
            break;
            
            case    bo_bizon:
                if (HasMaxAmmo(weaponinfo[wp_bizon].ammotype) && HasWeapon(wp_bizon))
                return;
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The Mini Rocket Launcher");
            GiveWeapon (wp_bizon);
            break;
            
            case    bo_ak47:
                if (HasMaxAmmo(weaponinfo[wp_ak47].ammotype) && HasWeapon(wp_ak47))
                return;
            SD_PlaySound (GETMACHINESND);
            GetMessage ("Picked Up The AK-47 With Flame Rounds");
            GiveWeapon (wp_ak47);
            break;
        
        case      bo_over:
        playstate = ex_victorious; 
        break;
        
        case      bo_over2:
        playstate = ex_victorious; 
        break;
             
             #ifdef ARMOR
   case bo_armor:
      if (gamestate.armor >= 100)
         return;
      SD_PlaySound (GETARMORSND);
      GetMessage ("Picked up Armor");
      GiveArmor (25);
      break;
#endif 
            
#ifdef SPEAR
        case    bo_spear:
            spearflag = true;
            spearx = player->x;
            speary = player->y;
            spearangle = player->angle;
            playstate = ex_completed;
#endif
    }

    StartBonusFlash ();
    check->shapenum = -1;                   // remove from list
}

#ifdef ARMOR
/*
===============
=
= GiveArmor
=
===============
*/

void   GiveArmor (int points)
{
   gamestate.armor += points;
   if (gamestate.armor>100)
      gamestate.armor = 100;

//   DrawArmor ();
}
#endif

#define MIDTILEMINDIST 0x8000
#define HTILE          (1l<<15)

/*
===================
=
= TryMove
=
= returns true if move ok
= debug: use pointers to optimize
===================
*/
#ifdef ALUMULTIPUSH
int pdirs[4][2]={{0,-1},{1,0},{0,1},{-1,0}};
#endif

boolean TryMove (objtype *ob)
{
    short       pw;
    int         xl,yl,xh,yh,x,y,ipos;
    objtype    *check;
    int32_t     deltax,deltay;

    xl = (ob->x-PLAYERSIZE) >>TILESHIFT;
    yl = (ob->y-PLAYERSIZE) >>TILESHIFT;

    xh = (ob->x+PLAYERSIZE) >>TILESHIFT;
    yh = (ob->y+PLAYERSIZE) >>TILESHIFT;

#define PUSHWALLMINDIST PLAYERSIZE

    //
    // check for solid walls
    //
    for (y=yl;y<=yh;y++)
    {
        for (x=xl;x<=xh;x++)
        {
            check = actorat[x][y];
            if (check && !ISPOINTER(check))
            {
#ifdef ALUMULTIPUSH
                for (int i = 0; i < MAXPWALLS; i++)
            	    if (pwall[i].x == x && pwall[i].y == y)
                    {
                        pw = i;
                        break;
                    }
#endif
                if(tilemap[x][y]==64 && x==pwallx && y==pwally)   // back of moving pushwall?
                {
                    switch(pwalldir)
                    {
                        case di_north:
                            if(ob->y-PUSHWALLMINDIST<=(pwally<<TILESHIFT)+((63-pwallpos)<<10))
                                return false;
                            break;
                        case di_west:
                            if(ob->x-PUSHWALLMINDIST<=(pwallx<<TILESHIFT)+((63-pwallpos)<<10))
                                return false;
                            break;
                        case di_east:
                            if(ob->x+PUSHWALLMINDIST>=(pwallx<<TILESHIFT)+(pwallpos<<10))
                                return false;
                            break;
                        case di_south:
                            if(ob->y+PUSHWALLMINDIST>=(pwally<<TILESHIFT)+(pwallpos<<10))
                                return false;
                            break;
                    }
                }
                else if(tilemap[x][y] >= 128)
                {
                    int dn = tilemap[x][y]-128;
                    if (doorobjlist[dn].vertical)
                    {
                        ipos = ((long)x<<TILESHIFT)+HTILE;

                        if (ob->x-MIDTILEMINDIST<ipos)
                            if (ob->x+MIDTILEMINDIST>ipos)
                            {
                                ipos = ((long)y<<TILESHIFT)+doorposition[dn];

                                if (ob->y+MIDTILEMINDIST>ipos)
                                    return false;
                            }
                    }
                    else
                    {
                        ipos = ((long)x<<TILESHIFT)+doorposition[dn];

                        if (ob->x+MIDTILEMINDIST>ipos)
                        {
                            ipos = ((long)y<<TILESHIFT)+HTILE;

                            if (ob->y-MIDTILEMINDIST<ipos)
                                if (ob->y+MIDTILEMINDIST>ipos)
                                    return false;
                        }
                    }
                }
                else return false;
            }
        }
    }

    //
    // check for actors
    //
    if (yl>0)
        yl--;
    if (yh<MAPSIZE-1)
        yh++;
    if (xl>0)
        xl--;
    if (xh<MAPSIZE-1)
        xh++;

    for (y=yl;y<=yh;y++)
    {
        for (x=xl;x<=xh;x++)
        {
            check = actorat[x][y];
            if (ISPOINTER(check) && check != player && (check->flags & FL_SHOOTABLE) )
            {
                deltax = ob->x - check->x;
                if (deltax < -MINACTORDIST || deltax > MINACTORDIST)
                    continue;
                deltay = ob->y - check->y;
                if (deltay < -MINACTORDIST || deltay > MINACTORDIST)
                    continue;

                return false;
            }
        }
    }

    return true;
}


/*
===================
=
= ClipMove
=
===================
*/

void ClipMove (objtype *ob, int32_t xmove, int32_t ymove)
{
    int32_t    basex,basey;

    basex = ob->x;
    basey = ob->y;

    ob->x = basex+xmove;
    ob->y = basey+ymove;
    if (TryMove (ob))
        return;

#ifndef REMDEBUG
    if (noclip && ob->x > 2*TILEGLOBAL && ob->y > 2*TILEGLOBAL
        && ob->x < (((int32_t)(mapwidth-1))<<TILESHIFT)
        && ob->y < (((int32_t)(mapheight-1))<<TILESHIFT) )
        return;         // walk through walls
#endif

    ob->x = basex+xmove;
    ob->y = basey;
    if (TryMove (ob))
        return;

    ob->x = basex;
    ob->y = basey+ymove;
    if (TryMove (ob))
        return;

    ob->x = basex;
    ob->y = basey;
}

//==========================================================================

/*
===================
=
= VictoryTile
=
===================
*/

void VictoryTile (void)
{
     // BEGIN ZOOM BLOCK
   ResetZoomEffects();
   // END ZOOM BLOCK 
   
#ifndef SPEAR
    SpawnBJVictory ();
#endif

    gamestate.victoryflag = true;
}

/*
===================
=
= Thrust
=
===================
*/

// For player movement in demos exactly as in the original Wolf3D v1.4 source code
static fixed FixedByFracOrig(fixed a, fixed b)
{
    int sign = 0;
    if(b == 65536) b = 65535;
    else if(b == -65536) b = 65535, sign = 1;
    else if(b < 0) b = (-b), sign = 1;

    if(a < 0)
    {
        a = -a;
        sign = !sign;
    }
    fixed res = (fixed)(((int64_t) a * b) >> 16);
    if(sign)
        res = -res;
    return res;
}

void Thrust (int angle, int32_t speed)
{
    int32_t xmove,ymove;
    unsigned offset;
    
    #ifdef WEAPONBOBBLE
   if (gamestate.bobdir != 1) gamestate.bobber++; else gamestate.bobber--;
   if (gamestate.bobber == 20 || gamestate.bobber == 0) gamestate.bobdir ^= 1;
   if (gamestate.bobdir2 != 1) gamestate.bobber2++; else gamestate.bobber2--;
   if (gamestate.bobber2 == 40 || gamestate.bobber2 == 0) gamestate.bobdir2 ^= 1;
#endif 


    //
    // ZERO FUNNY COUNTER IF MOVED!
    //
#ifdef SPEAR
    if (speed)
        funnyticount = 0;
#endif

    thrustspeed += speed;
    //
    // moving bounds speed
    //
    if (speed >= MINDIST*2)
        speed = MINDIST*2-1;

    xmove = DEMOCHOOSE_ORIG_SDL(
                FixedByFracOrig(speed, costable[angle]),
                FixedMul(speed,costable[angle]));
    ymove = DEMOCHOOSE_ORIG_SDL(
                -FixedByFracOrig(speed, sintable[angle]),
                -FixedMul(speed,sintable[angle]));

    ClipMove(player,xmove,ymove);

    player->tilex = (short)(player->x >> TILESHIFT);                // scale to tile values
    player->tiley = (short)(player->y >> TILESHIFT);

    offset = (player->tiley<<mapshift)+player->tilex;
    player->areanumber = *(mapsegs[0] + offset) -AREATILE;

    if (*(mapsegs[1] + offset) == EXITTILE)
        VictoryTile ();
}


/*
=============================================================================

                                ACTIONS

=============================================================================
*/


/*
===============
=
= Cmd_Fire
=
===============
*/

void Cmd_Fire (void)
{   
   if (gamestate.reloading) return; 
   
   buttonheld[bt_attack] = true;

   gamestate.weaponframe = 0;

   player->state = &s_attack;

   gamestate.attackframe = 0;
   gamestate.attackcount =
      attackinfo[gamestate.weapon][gamestate.attackframe].tics;
   gamestate.weaponframe =
      attackinfo[gamestate.weapon][gamestate.attackframe].frame;
} 

/*
===============
=
= Cmd_Reload
=
===============
*/

void Cmd_Reload (void)
{   
    if (gamestate.reloading) return;    // ignore command if already reloading

    if (!ClipSize(gamestate.weapon) || weaponinfo[gamestate.weapon].ammotype == ammo_none)
        return;    // weapon never reloads

    if (!CURRENTAMMO || CURRENTCLIP == ClipSize(gamestate.weapon))
        return;    // can't reload - either clip is full, or there's no ammo left in the reserve

    buttonheld[bt_reload] = true;

    gamestate.weaponframe = 0;

    player->state = &s_reload;

    gamestate.attackframe = 0;
    gamestate.attackcount =
        reloadinfo[gamestate.weapon][gamestate.attackframe].tics;
    gamestate.weaponframe =
        reloadinfo[gamestate.weapon][gamestate.attackframe].frame;
}  

//===========================================================================

/*
===============
=
= Cmd_Use
=
===============
*/

void Cmd_Use (void)
{
    int     checkx,checky,doornum,dir;
    boolean elevatorok;

    //
    // find which cardinal direction the player is facing
    //
    if (player->angle < ANGLES/8 || player->angle > 7*ANGLES/8)
    {
        checkx = player->tilex + 1;
        checky = player->tiley;
        dir = di_east;
        elevatorok = true;
    }
    else if (player->angle < 3*ANGLES/8)
    {
        checkx = player->tilex;
        checky = player->tiley-1;
        dir = di_north;
        elevatorok = false;
    }
    else if (player->angle < 5*ANGLES/8)
    {
        checkx = player->tilex - 1;
        checky = player->tiley;
        dir = di_west;
        elevatorok = true;
    }
    else
    {
        checkx = player->tilex;
        checky = player->tiley + 1;
        dir = di_south;
        elevatorok = false;
    }

    doornum = tilemap[checkx][checky];
    if (*(mapsegs[1]+(checky<<mapshift)+checkx) == PUSHABLETILE)
    {
        //
        // pushable wall
        //

        PushWall (checkx,checky,dir);
        return;
    }
    if (!buttonheld[bt_use] && doornum == ELEVATORTILE && elevatorok)
    {
        //
        // use elevator
        //
        buttonheld[bt_use] = true;

        tilemap[checkx][checky]++;              // flip switch
        if (*(mapsegs[0]+(player->tiley<<mapshift)+player->tilex) == ALTELEVATORTILE)
            playstate = ex_secretlevel;
        else
            playstate = ex_completed;
        SD_PlaySound (LEVELDONESND);
        SD_WaitSoundDone();
    }
    else if (!buttonheld[bt_use] && doornum & 0x80)
    {
        buttonheld[bt_use] = true;
        OperateDoor (doornum & ~0x80);
    }
}

/*
=============================================================================

                                PLAYER CONTROL

=============================================================================
*/



/*
===============
=
= SpawnPlayer
=
===============
*/

void SpawnPlayer (int tilex, int tiley, int dir)
{
    player->obclass = playerobj;
    player->active = ac_yes;
    player->tilex = tilex;
    player->tiley = tiley;
    player->areanumber = (byte) *(mapsegs[0]+(player->tiley<<mapshift)+player->tilex);
    player->x = ((int32_t)tilex<<TILESHIFT)+TILEGLOBAL/2;
    player->y = ((int32_t)tiley<<TILESHIFT)+TILEGLOBAL/2;
    player->state = &s_player;
    player->angle = (1-dir)*90;
    if (player->angle<0)
        player->angle += ANGLES;
    player->flags = FL_NEVERMARK;
    Thrust (0,0);                           // set some variables

    InitAreas ();
}


//===========================================================================

/*
===============
=
= T_KnifeAttack
=
= Update player hands, and try to do damage when the proper frame is reached
=
===============
*/
void RocketLauncherAttack (objtype *ob)
{
   if (gamestate.clip[wp_bizon]<1) //change to ammo2 if you have it
   {
      return;
   }
   SD_PlaySound (ATKBIZONSND); //change to any sound you have
   
   GetNewActor ();

   newobj->state = &s_rocket;
   newobj->ticcount = 1;

   newobj->x = ob->x ;
    newobj->y = ob->y ;
    newobj->tilex = newobj->x >> TILESHIFT;
    newobj->tiley = newobj->y >> TILESHIFT;

   newobj->obclass = rocketobj;
   newobj->dir = nodir;
   newobj->angle = ob->angle;
   newobj->speed = 0x4200l;
   newobj->flags = FL_NONMARK | FL_BONUS;
   newobj->active = ac_yes;
} 

void    KnifeAttack (objtype *ob)
{
    objtype *check,*closest;
    int32_t  dist;

    SD_PlaySound (ATKKNIFESND);
    // actually fire
    dist = 0x7fffffff;
    closest = NULL;
    for (check=ob->next; check; check=check->next)
    {
        if ( (check->flags & FL_SHOOTABLE) && (check->flags & FL_VISABLE)
            && abs(check->viewx-centerx) < shootdelta)
        {
            if (check->transx < dist)
            {
                dist = check->transx;
                closest = check;
            }
        }
    }

    if (!closest || dist > 0x18000l)
    {
        // missed
        return;
    }

    // hit something
    DamageActor (closest,US_RndT() >> 4);
}

#define COLSIZE 0x4800l
#define STEPDIST 0x400l
#define DEG2RAD(x)		(((x)*M_PI)/180.0)

void    GunAttack (objtype *ob)
{
        if (gamestate.weapon==wp_bizon)
   {
        madenoise = true;
      RocketLauncherAttack (ob);
      StartRecoilEffect( 50 );
      return;
        } 
    switch (gamestate.weapon)
    {
        case wp_pistol:
            SD_PlaySound (ATKPISTOLSND);
            break;
        case wp_beretta:
            SD_PlaySound (ATKBERETTASND);
            break;
        case wp_mp5:
            SD_PlaySound (ATKMP5SND);
            break;
        case wp_type79:
            SD_PlaySound (ATKTYPE79SND);
            break;
        case wp_machinegun:
            SD_PlaySound (ATKMACHINEGUNSND);
            break;
        case wp_lr3000:
            SD_PlaySound (ATKLR3000SND);
            break;
        case wp_chaingun:
            SD_PlaySound (ATKGATLINGSND);
            break;
        case wp_dshotgun:
            SD_PlaySound (ATKDSHOTGUNSND);
            break; 
        case wp_shotgun:
            SD_PlaySound (ATKSHOTSND);
            break; 
        case wp_l46:
            SD_PlaySound (ATKL46SND);
            break; 
        case wp_m14:
            SD_PlaySound (ATKM14SND);
            break; 
        case wp_deagle:
            SD_PlaySound (ATKDEAGLESND);
            break; 
        case wp_ak47:
            SD_PlaySound (ATKAK47SND);
            break;
    }

    madenoise = true;
    
    // BEGIN ZOOM BLOCK
   StartRecoilEffect( 50 );
   // END ZOOM BLOCK 

    int32_t         bulletx,bullety;
    short           damage,accuracy,numshots;
    float           bangle;
    boolean         hit;
    objtype         *check;


//
// AlumiuN's new weaponry code - trace bullets
//

    switch (gamestate.weapon)
    {
        case wp_pistol: accuracy = 4; numshots = 1; break;
        case wp_beretta: accuracy = 3; numshots = 1; break;
        case wp_mp5: accuracy = 2; numshots = 1; break;
        case wp_type79: accuracy = 3; numshots = 1; break;
        case wp_machinegun: accuracy = 4; numshots = 1; break;
        case wp_lr3000: accuracy = 2; numshots = 1; break;
        case wp_chaingun: accuracy = 5; numshots = 1; break;
        case wp_shotgun: accuracy = 5; numshots = 6; break; 
        case wp_dshotgun: accuracy = 7; numshots = 7; break; 
        case wp_l46: accuracy = 0; numshots = 1; break;
#ifdef ALUM14
        case wp_m14: accuracy = 1; numshots = 1; break;
#else
        case wp_m14: accuracy = 0; numshots = 1; break;
#endif
        case wp_deagle: accuracy = 0; numshots = 1; break;
        case wp_ak47: accuracy = 3; numshots = 1; break;
    }

     for (int i = 0; i<numshots; i++)
    {
        bulletx = player->x;
        bullety = player->y;
        bangle = (float)player->angle; 
        
        if (accuracy)
        {
            if (US_RndT() > 127)
                bangle -= (float)(rand()%(accuracy*1000))/1000;
            else
                bangle += (float)(rand()%(accuracy*1000))/1000;
        }

        hit = false;    // Assume the worst! Oh, and reset the variable. :)

        while(1)
        {
            bulletx += (int32_t) (STEPDIST * cos(DEG2RAD(bangle)));
            bullety -= (int32_t) (STEPDIST * sin(DEG2RAD(bangle)));

            //
            // check for solid walls
            //
            check = actorat[bulletx >> TILESHIFT][bullety >> TILESHIFT];
            if (check && !ISPOINTER(check) && (uintptr_t)check != 64)
            {
                if ((uintptr_t)check < 128)      // Hit a wall
			    {
	    	        bulletx -= (int32_t) (STEPDIST * cos(DEG2RAD(bangle)));
    	    	    bullety += (int32_t) (STEPDIST * sin(DEG2RAD(bangle)));
            		if (gamestate.weapon==wp_ak47)
				        T_FirePuff (bulletx,bullety,ob);
			        else
				        T_BulletPuff (bulletx,bullety,ob);
                	hit = true;
	            }
                else if (doorposition[(uintptr_t)check - 128] < ((doorobjlist[(uintptr_t)check - 128].vertical) ? bullety % 65536 : bulletx % 65536))
		        {
	    	        bulletx -= (int32_t) (STEPDIST * cos(DEG2RAD(bangle)));
    	    	    bullety += (int32_t) (STEPDIST * sin(DEG2RAD(bangle)));
                	if (gamestate.weapon==wp_ak47)
				        T_FirePuff (bulletx,bullety,ob);
			        else
    				    T_NewPuff (bulletx,bullety,ob);
                	hit = true;
      			}
            }

            if (hit)
                break; 

            check = objlist;
            while (check)
            {
                if (check->flags & FL_SHOOTABLE)
                {
                    if (LABS(bulletx - check->x) < COLSIZE && LABS(bullety - check->y) < COLSIZE)
                    {
                        hit = true;   
                        switch (gamestate.weapon)
                        {
                            case wp_pistol: damage = 10 + US_RndT()%25; break;
                            case wp_beretta: damage = 15 + US_RndT()%25; break;
#ifdef ALUMP5
                            case wp_mp5: damage = 3 + US_RndT()%24; break;
#else
                            case wp_mp5: damage = 1 + US_RndT()%24; break;
#endif
                            case wp_type79: damage = 4 + US_RndT()%24; break;
                            case wp_machinegun: damage = 8 + US_RndT()%22; break;
                            case wp_lr3000: damage = 10 + US_RndT()%22; break;
                            case wp_chaingun: damage = 12 + US_RndT()%20; break;
                            case wp_shotgun: damage = 25 + US_RndT()%4; break; 
                            case wp_dshotgun: damage = 30 + US_RndT()%2; break; 
#ifdef ALUSCOUT
                            case wp_l46: damage = 100 + US_RndT()%25; break;
#else
                            case wp_l46: damage = 50 + US_RndT()%25; break;
#endif
#ifdef ALUM14
                            case wp_m14: damage = 40 + US_RndT()%25; break;
#else
                            case wp_m14: damage = 75 + US_RndT()%25; break;
#endif
#ifdef ALUDEAGLE
                            case wp_deagle: damage = 1000; break;
#else
                            case wp_deagle: damage = 99 + US_RndT()%25; break;
#endif
                            case wp_ak47: damage = 11 + US_RndT()%22; break;
                        }
                        DamageActor (check, damage);
                    }
                }
                check = check->next ;
            }

            if (hit)
                break;
        }
    }
} 

//===========================================================================

/*
===============
=
= VictorySpin
=
===============
*/

void VictorySpin (void)
{
    int32_t    desty;

    if (player->angle > 270)
    {
        player->angle -= (short)(tics * 3);
        if (player->angle < 270)
            player->angle = 270;
    }
    else if (player->angle < 270)
    {
        player->angle += (short)(tics * 3);
        if (player->angle > 270)
            player->angle = 270;
    }

    desty = (((int32_t)player->tiley-5)<<TILESHIFT)-0x3000;

    if (player->y > desty)
    {
        player->y -= tics*4096;
        if (player->y < desty)
            player->y = desty;
    }
}


//===========================================================================

/*
===============
=
= T_Attack
=
===============
*/

void    T_Attack (objtype *ob)
{
    struct  atkinf  *cur;
    int i;

    UpdateFace ();

    if (gamestate.victoryflag)              // watching the BJ actor
    {
        VictorySpin ();
        return;
    }

    if ( buttonstate[bt_use] && !buttonheld[bt_use] )
        buttonstate[bt_use] = false;

    if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
        buttonstate[bt_attack] = false;

    ControlMovement (ob);
    if (gamestate.victoryflag)              // watching the BJ actor
        return;

    plux = (word) (player->x >> UNSIGNEDSHIFT);                     // scale to fit in unsigned
    pluy = (word) (player->y >> UNSIGNEDSHIFT);
    player->tilex = (short)(player->x >> TILESHIFT);                // scale to tile values
    player->tiley = (short)(player->y >> TILESHIFT);

    //
    // change frame and fire
    //
    gamestate.attackcount -= (short) tics;
    while (gamestate.attackcount <= 0)
    {
        cur = &attackinfo[gamestate.weapon][gamestate.attackframe];
        switch (cur->attack)
        {
            case -1:
                ob->state = &s_player;
                if (!WeaponAvailable(gamestate.weapon))
                {
                    gamestate.weapon = BestAvailableWeapon();
                    DrawWeapon ();
                    DrawAmmo ();
                }
                else
                {
                    if (gamestate.weapon != gamestate.chosenweapon && WeaponAvailable(gamestate.chosenweapon))
                    {
                        gamestate.weapon = gamestate.chosenweapon;
                        DrawWeapon ();
                        DrawAmmo ();
                    }
                }
                gamestate.attackframe = gamestate.weaponframe = 0;
                if (!CURRENTCLIP && ClipSize(gamestate.weapon) > 0 && CURRENTAMMO > 0)
                    Cmd_Reload ();
                return;

            case 4:
                if (!ReadyToFire(gamestate.weapon))
                    break;
                if (buttonstate[bt_attack])
                    gamestate.attackframe -= 2;
            case 1:
                if (!ReadyToFire(gamestate.weapon))
                {       // can only happen with chain gun
                    gamestate.attackframe++;
                    break;
                }
                GunAttack (ob);
                if (!infammo && weaponinfo[gamestate.weapon].ammotype != ammo_none)
                {
                    if (ClipSize(gamestate.weapon) > 0)
                        CURRENTCLIP--;
                    else
                        CURRENTAMMO--;
                }
                DrawWeapon ();
                DrawAmmo ();
                break;

            case 2:
                KnifeAttack (ob);
                break;
                
                case 5:
      SD_PlaySound (BOLTBACKSND);
              break;
              
        case 6:
      SD_PlaySound (BOLTFORWARDSND);
              break;
              
              case 10:
      SD_PlaySound (PUMPSND);
              break;

            case 3:
                if (ReadyToFire(gamestate.weapon) && buttonstate[bt_attack])
                    gamestate.attackframe -= 2;
                break;
        }  

        gamestate.attackcount += cur->tics;
        gamestate.attackframe++;
        gamestate.weaponframe =
            attackinfo[gamestate.weapon][gamestate.attackframe].frame;
    }
}

/*
===============
=
= T_Reload
=
===============
*/

void    T_Reload (objtype *ob)
{
    struct  rloadinf  *cur;

    UpdateFace ();

    if (gamestate.victoryflag)              // watching the BJ actor
    {
        VictorySpin ();
        return;
    }

	CheckWeaponChange();
    ControlMovement (ob);
    if (gamestate.victoryflag)              // watching the BJ actor
        return;

    plux = (word) (player->x >> UNSIGNEDSHIFT);                     // scale to fit in unsigned
    pluy = (word) (player->y >> UNSIGNEDSHIFT);
    player->tilex = (short)(player->x >> TILESHIFT);                // scale to tile values
    player->tiley = (short)(player->y >> TILESHIFT);

    buttonheld[bt_attack] = false;
    buttonstate[bt_attack] = false;

    gamestate.reloading = true;

    //
    // change frame and reload
    //
    gamestate.attackcount -= (short) tics;
    while (gamestate.attackcount <= 0)
    {
        cur = &reloadinfo[gamestate.weapon][gamestate.attackframe]; 
      switch (cur->attack)
      {
      case -1:   // go back to first frame
         ob->state = &s_player;
         gamestate.reloading = false;
         gamestate.attackframe = gamestate.weaponframe = 0;
		 BasicZoom(gamestate.curzoom);
         return;

      case 1:
         switch (gamestate.weapon)
         {
            case wp_pistol:
               SD_PlaySound (RELOADPISTOL1SND);
               break;
            case wp_beretta:
               SD_PlaySound (RELOADBERETTA1SND);
               break;
            case wp_machinegun:
               SD_PlaySound (RELOADMACHINE1SND);
               break;
            case wp_lr3000:
               SD_PlaySound (RELOADLR30001SND);
               break;
            case wp_mp5:
               SD_PlaySound (RELOADMP51SND);
               break;
            case wp_type79:
               SD_PlaySound (RELOADTYPE791SND);
               break;
            case wp_bizon:
               SD_PlaySound (RELOADBIZON1SND);
               break;
            case wp_chaingun:
               SD_PlaySound (RELOADCHAINGUN1SND);
               break;
            case wp_shotgun:
               SD_PlaySound (RELOADSHOTGUN1SND);
               break;
            case wp_m14:
               SD_PlaySound (RELOADM141SND);
               break;
            case wp_l46:
               SD_PlaySound (RELOADL461SND);
               break;
            case wp_dshotgun:
               SD_PlaySound (RELOADDSHOTGUN1SND);
               break;
            case wp_deagle:
               SD_PlaySound (RELOADDEAGLE1SND);
               break;
            case wp_ak47:
               SD_PlaySound (RELOADAK471SND);
               break;
         }
         break;
         
         case 9:
      SD_PlaySound (BOLTBACKSND);
              break;
              
              case 10:
      SD_PlaySound (BOLTFORWARDSND);
              break;
              
              case 5:
      SD_PlaySound (BOLTPULLSND);
              break;
         
         case 6:
         switch (gamestate.weapon)
         {
            case wp_pistol:
               SD_PlaySound (RELOADPISTOL2SND);
               break;
            case wp_beretta:
               SD_PlaySound (RELOADBERETTA2SND);
               break;
            case wp_machinegun:
               SD_PlaySound (RELOADMACHINE2SND);
               break;
            case wp_lr3000:
               SD_PlaySound (RELOADLR30002SND);
               break;
            case wp_mp5:
               SD_PlaySound (RELOADMP52SND);
               break;
            case wp_type79:
               SD_PlaySound (RELOADTYPE792SND);
               break;
            case wp_bizon:
               SD_PlaySound (RELOADBIZON2SND);
               break;
            case wp_chaingun:
               SD_PlaySound (RELOADCHAINGUN2SND);
               break;
            case wp_m14:
               SD_PlaySound (RELOADM142SND);
               break;
            case wp_l46:
               SD_PlaySound (RELOADL462SND);
               break;
               case wp_dshotgun:
               SD_PlaySound (RELOADDSHOTGUN2SND);
               break;
               case wp_deagle:
               SD_PlaySound (RELOADDEAGLE2SND);
               break;
               case wp_ak47:
               SD_PlaySound (RELOADAK472SND);
               break;
         }
         break;
         
         case 7:
      SD_PlaySound (BOLTSLAPSND);
              break;
              
              case 8:
      SD_PlaySound (PUMPSND);
              break;
              
      case 2:    // reload a full clip
                ReloadWeapon (ClipSize(gamestate.weapon)-CURRENTCLIP);
                break;

            case 3:    // reload 1 round
                ReloadWeapon (1);
                SD_PlaySound (RELOADSHOTGUN1SND);
                break;

            case 4:    // go back 2 frames if clip isn't full yet
                if (CURRENTCLIP < ClipSize(gamestate.weapon) && CURRENTAMMO > 0) 
                    gamestate.attackframe -= 2;
                break;
        }   

      gamestate.attackcount += cur->tics;
      gamestate.attackframe++;
      gamestate.weaponframe =
         reloadinfo[gamestate.weapon][gamestate.attackframe].frame;
   }

} 

/*
===============
=
= ReloadWeapon
=
===============
*/

void    ReloadWeapon (int ammo)
{
    if (!CURRENTAMMO)
        return;

    if (ammo > CURRENTAMMO)
        ammo = CURRENTAMMO;

    CURRENTCLIP += ammo;
    CURRENTAMMO -= ammo;

    DrawWeapon ();
    DrawAmmo ();
} 

//===========================================================================

/*
===============
=
= T_Player
=
===============
*/

void    T_Player (objtype *ob)
{
    if (gamestate.victoryflag)              // watching the BJ actor
    {
        VictorySpin ();
        return;
    }

    UpdateFace ();
    CheckWeaponChange ();

    if ( buttonstate[bt_use] )
        Cmd_Use ();

    if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
{
 switch (gamestate.weapon)
{
case wp_knife: 
     break;
case wp_pistol:
if(!gamestate.clip[wp_pistol])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_mp5:
if(!gamestate.clip[wp_mp5])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_bizon:
if(!gamestate.clip[wp_bizon])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_machinegun:
if(!gamestate.clip[wp_machinegun])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_chaingun:
if(!gamestate.clip[wp_chaingun])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_dshotgun:
if(!gamestate.clip[wp_dshotgun])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_shotgun:
if(!gamestate.clip[wp_shotgun])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_l46:
if(!gamestate.clip[wp_l46])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_m14:
if(!gamestate.clip[wp_m14])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_deagle:
if(!gamestate.clip[wp_deagle])
{
SD_PlaySound(DRYFIRESND);
return;
}  
break;
case wp_ak47:
if(!gamestate.clip[wp_ak47])
{
SD_PlaySound(DRYFIRESND);
return;
}
break;
case wp_beretta:
if(!gamestate.clip[wp_beretta])  // or whatever you've called the ammo for each weapon
{
SD_PlaySound(DRYFIRESND);
return;
} 
break;
case wp_lr3000:
if(!gamestate.clip[wp_lr3000])
{
SD_PlaySound(DRYFIRESND);
return;
}  
break;
case wp_type79:
if(!gamestate.clip[wp_type79])
{
SD_PlaySound(DRYFIRESND);
return;
}  
break;
}
Cmd_Fire();
} 

      if ( buttonstate[bt_reload] && !buttonheld[bt_reload])
        Cmd_Reload (); 

    ControlMovement (ob);
    if (gamestate.victoryflag)              // watching the BJ actor
        return;

    plux = (word) (player->x >> UNSIGNEDSHIFT);                     // scale to fit in unsigned
    pluy = (word) (player->y >> UNSIGNEDSHIFT);
    player->tilex = (short)(player->x >> TILESHIFT);                // scale to tile values
    player->tiley = (short)(player->y >> TILESHIFT);
}

