// WL_ACT2.C

#include <stdio.h>
#include <math.h>
#include "wl_def.h"
#pragma hdrstop


/*
=============================================================================

                               LOCAL CONSTANTS

=============================================================================
*/

#define PROJECTILESIZE  0xc000l

#define BJRUNSPEED      2048
#define BJJUMPSPEED     680
#define BJROCKETSIZE 0x6000l
#define BARRELEXPLSIZE 0x26000l




/*
=============================================================================

                              GLOBAL VARIABLES

=============================================================================
*/



/*
=============================================================================

                              LOCAL VARIABLES

=============================================================================
*/


dirtype dirtable[9] = {northwest,north,northeast,west,nodir,east,
    southwest,south,southeast};

short starthitpoints[4][NUMENEMIES] =
//
// BABY MODE
//
{
    {
        25,   // guards
        50,   // officer
        100,  // SS
        1,    // dogs
        2000,  // Hans
        200,  // Schabbs
        2200,  // fake hitler
        6800,  // mecha hitler
        85,   // mutants
        300,  // space
        150,  // shotgunner
        75,   // cult
        15,   // sniper
        85,   // shadow hunter
        95,   // rocket unit
        80,   // reaper
        60,   // stealth unit
        90,   // soulless
        120,  // slorga
        100,  // striker
        105,  // basic flame unit
        125,  // advance flame unit
        50,   // slave girl
        50,   // Vampire officer
        35,   // eilte guards
        
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts

        3850,  // Gretel
        2850,  // Gift
        5850,  // Fat
        5,    // en_spectre,
        1450, // en_angel,
        850,  // en_trans,
        1050, // en_uber,
        950,  // en_will,
        1250  // en_death
    },
    //
    // DON'T HURT ME MODE
    //
    {
        25,   // guards
        50,   // officer
        100,  // SS
        1,    // dogs
        2050,  // Hans
        200,  // Schabbs
        2300,  // fake hitler
        6950,  // mecha hitler
        95,   // mutants
        300,  // space
        150,  // shotgunner
        75,   // cult
        15,   // sniper
        95,   // shadow hunter
        105,   // rocket unit
        90,   // reaper
        60,   // stealth unit
        90,   // soulless
        120,  // slorga
        100,  // striker
        105,  // basic flame unit
        125,  // advance flame unit
        50,   // slave girl
        50,   // Vampire officer
        35,   // eilte guards
        
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts

        3950,  // Gretel
        2950,  // Gift
        5950,  // Fat
        10,   // en_spectre,
        1550, // en_angel,
        950,  // en_trans,
        1150, // en_uber,
        1050, // en_will,
        1350  // en_death
    },
    //
    // BRING 'EM ON MODE
    //
    {
        25,   // guards
        50,   // officer
        100,  // SS
        1,    // dogs

        2100, // Hans
        200, // Schabbs
        2400,  // fake hitler
        7050, // mecha hitler

        95,   // mutants
        300,  // space
        150,  // shotgunner
        75,   // cult
        15,   // sniper
        95,   // shadow hunter
        105,  // rocket unit
        90,   // reaper
        60,   // stealth unit
        90,   // soulless
        120,  // slorga
        100,  // striker
        105,  // basic flame unit
        125,  // advance flame unit
        50,   // slave girl
        50,   // Vampire officer
        35,   // eilte guards
        
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts

        4050, // Gretel
        3050, // Gift
        6050, // Fat
        15,   // en_spectre,
        1650, // en_angel,
        1050, // en_trans,
        1250, // en_uber,
        1150, // en_will,
        1450  // en_death
    },
    //
    // DEATH INCARNATE MODE
    //
    {
        25,   // guards
        50,   // officer
        100,  // SS
        1,    // dogs

        2150, // Hans
        200, // Schabbs
        2500,  // fake hitler
        7200, // mecha hitler

        105,   // mutants
        300,  // space
        150,  // shotgunner
        75,   // cult
        15,   // sniper
        105,   // shadow hunter
        115,   // rocket unit
        100,   // reaper
        60,   // stealth unit
        90,   // soulless
        120,  // slorga
        100,  // striker
        105,  // basic flame unit
        125,  // advance flame unit
        50,   // slave girl
        50,   // Vampire officer
        35,   // eilte guards
        
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts
        25,   // ghosts

        4200, // Gretel
        3200, // Gift
        6200, // Fat
        25,   // en_spectre,
        2000, // en_angel,
        1200, // en_trans,
        1400, // en_uber,
        1300, // en_will,
        1600  // en_death
    }
};


void    A_StartDeathCam (objtype *ob);


void    T_Path (objtype *ob);
void    T_Shoot (objtype *ob);
void    T_GiftThrow (objtype *ob);
void    T_Gasball (objtype *ob);
void    T_Launch (objtype *ob); 
void    T_Bite (objtype *ob);
void    T_DogChase (objtype *ob);
void    T_Chase (objtype *ob);
void    T_HunterChase (objtype *ob);
void    T_DraculaChase (objtype *ob);
void    T_DeathChase (objtype *ob);
void    T_Projectile (objtype *ob);
void    T_Stand (objtype *ob);
void    A_StartAttack (objtype *ob);
void    T_Shadowball (objtype *ob);
void    T_Shadowball2 (objtype *ob);
void    T_Shadowball3 (objtype *ob);
void    T_Ball (objtype *ob);

void A_DeathScream (objtype *ob);

//
// Missale
//

extern  statetype s_rocket;
extern  statetype s_smoke1;
extern  statetype s_smoke2;
extern  statetype s_smoke3;
extern  statetype s_smoke4;
extern  statetype s_boom2;
extern  statetype s_boom3;

void A_Smoke (objtype *ob);

statetype s_rocket              = {true,SPR_ROCKET_1,3,(statefunc)T_Projectile,(statefunc)A_Smoke,&s_rocket};
statetype s_smoke1              = {false,SPR_SMOKE_1,3,NULL,NULL,&s_smoke2};
statetype s_smoke2              = {false,SPR_SMOKE_2,3,NULL,NULL,&s_smoke3};
statetype s_smoke3              = {false,SPR_SMOKE_3,3,NULL,NULL,&s_smoke4};
statetype s_smoke4              = {false,SPR_SMOKE_4,3,NULL,NULL,NULL};

statetype s_boom1               = {false,SPR_BOOM_1,6,NULL,NULL,&s_boom2};
statetype s_boom2               = {false,SPR_BOOM_2,6,NULL,NULL,&s_boom3};
statetype s_boom3               = {false,SPR_BOOM_3,6,NULL,NULL,NULL};

//
// Dream Missale
//

extern  statetype s_drocket;
extern  statetype s_dsmoke1;
extern  statetype s_dsmoke2;
extern  statetype s_dsmoke3;
extern  statetype s_dsmoke4;
extern  statetype s_dboom2;
extern  statetype s_dboom3;

void A_DSmoke (objtype *ob);

statetype s_drocket              = {true,SPR_DROCKET_1,3,(statefunc)T_Projectile,(statefunc)A_DSmoke,&s_drocket};
statetype s_dsmoke1              = {false,SPR_DSMOKE_1,3,NULL,NULL,&s_dsmoke2};
statetype s_dsmoke2              = {false,SPR_DSMOKE_2,3,NULL,NULL,&s_dsmoke3};
statetype s_dsmoke3              = {false,SPR_DSMOKE_3,3,NULL,NULL,&s_dsmoke4};
statetype s_dsmoke4              = {false,SPR_DSMOKE_4,3,NULL,NULL,NULL};

statetype s_dboom1               = {false,SPR_DBOOM_1,6,NULL,NULL,&s_dboom2};
statetype s_dboom2               = {false,SPR_DBOOM_2,6,NULL,NULL,&s_dboom3};
statetype s_dboom3               = {false,SPR_DBOOM_3,6,NULL,NULL,NULL};

//
// Gasball
//

extern  statetype s_gasball;
extern  statetype s_hsmoke21;
extern  statetype s_hsmoke22;
extern  statetype s_hsmoke23;
extern  statetype s_hsmoke24;
extern  statetype s_hsmoke25;
extern  statetype s_hsmoke26;
extern  statetype s_hsmoke27;
extern  statetype s_boom42;
extern  statetype s_boom43;
extern  statetype s_boom44;
extern  statetype s_boom45;
extern  statetype s_boom46;
extern  statetype s_boom47;
extern  statetype s_boom48;
extern  statetype s_boom49;

void A_SmokeGasball (objtype *ob);

statetype s_gasball             = {true,SPR_GASBALL_1,3,(statefunc)T_Projectile,(statefunc)A_SmokeGasball,&s_gasball};
statetype s_hsmoke21             = {false,SPR_HSMOKE_1,3,NULL,NULL,&s_hsmoke22};
statetype s_hsmoke22             = {false,SPR_HSMOKE_2,3,NULL,NULL,&s_hsmoke23};
statetype s_hsmoke23             = {false,SPR_HSMOKE_3,3,NULL,NULL,&s_hsmoke24};
statetype s_hsmoke24             = {false,SPR_HSMOKE_4,3,NULL,NULL,&s_hsmoke25};
statetype s_hsmoke25             = {false,SPR_HSMOKE_5,3,NULL,NULL,&s_hsmoke26};
statetype s_hsmoke26             = {false,SPR_HSMOKE_6,3,NULL,NULL,&s_hsmoke27};
statetype s_hsmoke27             = {false,SPR_HSMOKE_7,3,NULL,NULL,NULL};

statetype s_boom41               = {false,SPR_GASBOOM_1,6,NULL,NULL,&s_boom42};
statetype s_boom42               = {false,SPR_GASBOOM_2,6,NULL,NULL,&s_boom43};
statetype s_boom43               = {false,SPR_GASBOOM_3,6,NULL,NULL,&s_boom44};
statetype s_boom44               = {false,SPR_GASBOOM_4,6,NULL,NULL,&s_boom45};
statetype s_boom45               = {false,SPR_GASBOOM_5,6,NULL,NULL,&s_boom46};
statetype s_boom46               = {false,SPR_GASBOOM_6,6,NULL,NULL,&s_boom47};
statetype s_boom47               = {false,SPR_GASBOOM_7,6,NULL,NULL,&s_boom48};
statetype s_boom48               = {false,SPR_GASBOOM_8,6,NULL,NULL,&s_boom49};
statetype s_boom49               = {false,SPR_GASBOOM_9,6,NULL,NULL,NULL};

//
// Fireball
//

extern  statetype s_hrocket;
extern  statetype s_hsmoke1;
extern  statetype s_hsmoke2;
extern  statetype s_hsmoke3;
extern  statetype s_hsmoke4;
extern  statetype s_hsmoke5;
extern  statetype s_hsmoke6;
extern  statetype s_hsmoke7;
extern  statetype s_hboom2;
extern  statetype s_hboom3;
extern  statetype s_hboom4;
extern  statetype s_hboom5;

void A_Smokeball (objtype *ob);

statetype s_hrocket             = {true,SPR_HROCKET_1,3,(statefunc)T_Projectile,(statefunc)A_Smokeball,&s_hrocket};
statetype s_hsmoke1             = {false,SPR_HSMOKE_1,3,NULL,NULL,&s_hsmoke2};
statetype s_hsmoke2             = {false,SPR_HSMOKE_2,3,NULL,NULL,&s_hsmoke3};
statetype s_hsmoke3             = {false,SPR_HSMOKE_3,3,NULL,NULL,&s_hsmoke4};
statetype s_hsmoke4             = {false,SPR_HSMOKE_4,3,NULL,NULL,&s_hsmoke5};
statetype s_hsmoke5             = {false,SPR_HSMOKE_5,3,NULL,NULL,&s_hsmoke6};
statetype s_hsmoke6             = {false,SPR_HSMOKE_6,3,NULL,NULL,&s_hsmoke7};
statetype s_hsmoke7             = {false,SPR_HSMOKE_7,3,NULL,NULL,NULL};

statetype s_hboom1              = {false,SPR_HBOOM_1,6,NULL,NULL,&s_hboom2};
statetype s_hboom2              = {false,SPR_HBOOM_2,6,NULL,NULL,&s_hboom3};
statetype s_hboom3              = {false,SPR_HBOOM_3,6,NULL,NULL,&s_hboom4};
statetype s_hboom4              = {false,SPR_HBOOM_4,6,NULL,NULL,&s_hboom5};
statetype s_hboom5              = {false,SPR_HBOOM_5,6,NULL,NULL,NULL};


//
// shadowball
//

extern   statetype s_shadowball1;
extern   statetype s_shadowball2;
extern   statetype s_shadowball3;

extern  statetype s_boom12;
extern  statetype s_boom13;
extern  statetype s_boom14;

statetype s_shadowball1    = {false,SPR_NEW1,6,(statefunc)T_Projectile,NULL,&s_shadowball2};
statetype s_shadowball2    = {false,SPR_NEW2,6,(statefunc)T_Projectile,NULL,&s_shadowball3};
statetype s_shadowball3    = {false,SPR_NEW3,6,(statefunc)T_Projectile,NULL,&s_shadowball1}; 

statetype s_boom11               = {false,SPR_BOOM1_1,6,NULL,NULL,&s_boom12};
statetype s_boom12               = {false,SPR_BOOM1_2,6,NULL,NULL,&s_boom13};
statetype s_boom13               = {false,SPR_BOOM1_3,6,NULL,NULL,&s_boom14};
statetype s_boom14               = {false,SPR_BOOM1_4,6,NULL,NULL,NULL};

//
// Ball
//

extern   statetype s_ball1;
extern   statetype s_ball2;
extern   statetype s_ball3;

extern  statetype s_boom52;
extern  statetype s_boom53;
extern  statetype s_boom54;

statetype s_ball1    = {false,SPR_2BALL1,6,(statefunc)T_Projectile,NULL,&s_ball2};
statetype s_ball2    = {false,SPR_2BALL2,6,(statefunc)T_Projectile,NULL,&s_ball3};
statetype s_ball3    = {false,SPR_2BALL3,6,(statefunc)T_Projectile,NULL,&s_ball1}; 

statetype s_boom51               = {false,SPR_BOOM1_1,6,NULL,NULL,&s_boom52};
statetype s_boom52               = {false,SPR_BOOM1_2,6,NULL,NULL,&s_boom53};
statetype s_boom53               = {false,SPR_BOOM1_3,6,NULL,NULL,&s_boom54};
statetype s_boom54               = {false,SPR_BOOM1_4,6,NULL,NULL,NULL};

//
// shadowball2
//

extern   statetype s_2shadowball1;
extern   statetype s_2shadowball2;

extern  statetype s_boom22;
extern  statetype s_boom23;

statetype s_boom21               = {false,SPR_BOOM2_1,6,NULL,NULL,&s_boom22};
statetype s_boom22               = {false,SPR_BOOM2_2,6,NULL,NULL,&s_boom23};
statetype s_boom23               = {false,SPR_BOOM2_3,6,NULL,NULL,NULL};


statetype s_2shadowball1    = {false,SPR_BALL1,6,(statefunc)T_Projectile,NULL,&s_2shadowball2};
statetype s_2shadowball2    = {false,SPR_BALL2,6,(statefunc)T_Projectile,NULL,&s_2shadowball1}; 

//
// shadowball3
//

extern   statetype s_3shadowball1;
extern   statetype s_3shadowball2;

extern  statetype s_boom32;
extern  statetype s_boom33;

statetype s_boom31               = {false,SPR_BOOM3_1,6,NULL,NULL,&s_boom32};
statetype s_boom32               = {false,SPR_BOOM3_2,6,NULL,NULL,&s_boom33};
statetype s_boom33               = {false,SPR_BOOM3_3,6,NULL,NULL,NULL};

statetype s_3shadowball1    = {false,SPR_1BALL1,6,(statefunc)T_Projectile,NULL,&s_3shadowball2};
statetype s_3shadowball2    = {false,SPR_1BALL2,6,(statefunc)T_Projectile,NULL,&s_3shadowball1}; 

/*
===================
= Bullet Puff -puffobj
===================
*/
extern   statetype s_puff11;
extern   statetype s_puff12;
extern   statetype s_puff13;
extern   statetype s_puff14;
extern   statetype s_puff15;

statetype s_puff11 = {false,SPR_HBOOM_1,3,NULL,NULL,&s_puff12};
statetype s_puff12 = {false,SPR_HBOOM_2,3,NULL,NULL,&s_puff13};
statetype s_puff13 = {false,SPR_HBOOM_3,3,NULL,NULL,&s_puff14};
statetype s_puff14 = {false,SPR_HBOOM_4,3,NULL,NULL,&s_puff15};
statetype s_puff15 = {false,SPR_HBOOM_5,3,NULL,NULL,NULL};

void T_FirePuff (int x, int y, objtype *ob)
{
   GetNewActor ();
   newobj->state = &s_puff11;
   newobj->ticcount = 1;

   newobj->tilex = x >> TILESHIFT;
   newobj->tiley = y >> TILESHIFT;
   newobj->x = x;
   newobj->y = y;
   newobj->obclass = firepuffobj;
   newobj->dir = nodir;
   newobj->angle = north;
   newobj->speed = 0;

   newobj-> flags = FL_NEVERMARK;
   newobj->active = ac_yes;
} 

/*
===================
= Bullet Puff -puffobj
===================
*/
extern   statetype s_puff1;
extern   statetype s_puff2;
extern   statetype s_puff3;
extern   statetype s_puff4;
extern   statetype s_puff5;
extern   statetype s_puff6;
extern   statetype s_puff7;
extern   statetype s_puff8;

statetype s_puff1 = {false,SPR_PUFF1,3,NULL,NULL,&s_puff2};
statetype s_puff2 = {false,SPR_PUFF2,3,NULL,NULL,&s_puff3};
statetype s_puff3 = {false,SPR_PUFF3,3,NULL,NULL,&s_puff4};
statetype s_puff4 = {false,SPR_PUFF4,3,NULL,NULL,&s_puff5};
statetype s_puff5 = {false,SPR_PUFF5,3,NULL,NULL,&s_puff6};
statetype s_puff6 = {false,SPR_PUFF6,3,NULL,NULL,&s_puff7};
statetype s_puff7 = {false,SPR_PUFF7,3,NULL,NULL,&s_puff8};
statetype s_puff8 = {false,SPR_PUFF8,3,NULL,NULL,NULL};

void T_BulletPuff (int x, int y, objtype *ob)
{
   GetNewActor ();
   newobj->state = &s_puff1;
   newobj->ticcount = 1;

   newobj->tilex = x >> TILESHIFT;
   newobj->tiley = y >> TILESHIFT;
   newobj->x = x;
   newobj->y = y;
   newobj->obclass = puffobj;
   newobj->dir = nodir;
   newobj->angle = north;
   newobj->speed = 0;

   newobj-> flags = FL_NEVERMARK;
   newobj->active = ac_yes;
} 

/*
===================
= Bullet Puff -puffobj
===================
*/
extern   statetype s_newpuff1;
extern   statetype s_newpuff2;
extern   statetype s_newpuff3;
extern   statetype s_newpuff4;

statetype s_newpuff1 = {false,SPR_NEWPUFF1,3,NULL,NULL,&s_newpuff2};
statetype s_newpuff2 = {false,SPR_NEWPUFF2,3,NULL,NULL,&s_newpuff3};
statetype s_newpuff3 = {false,SPR_NEWPUFF3,3,NULL,NULL,&s_newpuff4};
statetype s_newpuff4 = {false,SPR_NEWPUFF4,3,NULL,NULL,NULL};

void T_NewPuff (int x, int y, objtype *ob)
{
   GetNewActor ();
   newobj->state = &s_newpuff1;
   newobj->ticcount = 1;

   newobj->tilex = x >> TILESHIFT;
   newobj->tiley = y >> TILESHIFT;
   newobj->x = x;
   newobj->y = y;
   newobj->obclass = puff2obj;
   newobj->dir = nodir;
   newobj->angle = north;
   newobj->speed = 0;

   newobj-> flags = FL_NEVERMARK;
   newobj->active = ac_yes;
} 

/*
===================
= Bullet Puff -puffobj
===================
*/
extern   statetype s_blood1;
extern   statetype s_blood2;
extern   statetype s_blood3;
extern   statetype s_blood4;
extern   statetype s_blood5;
extern   statetype s_blood6;
extern   statetype s_blood7;
extern   statetype s_blood8;

statetype s_blood1 = {false,SPR_BLOOD1,3,NULL,NULL,&s_blood2};
statetype s_blood2 = {false,SPR_BLOOD2,3,NULL,NULL,&s_blood3};
statetype s_blood3 = {false,SPR_BLOOD3,3,NULL,NULL,&s_blood4};
statetype s_blood4 = {false,SPR_BLOOD4,3,NULL,NULL,&s_blood5};
statetype s_blood5 = {false,SPR_BLOOD5,3,NULL,NULL,&s_blood6};
statetype s_blood6 = {false,SPR_BLOOD6,3,NULL,NULL,&s_blood7};
statetype s_blood7 = {false,SPR_BLOOD7,3,NULL,NULL,&s_blood8};
statetype s_blood8 = {false,SPR_BLOOD8,3,NULL,NULL,NULL};

void T_Blood (int x, int y, objtype *ob)
{
   GetNewActor ();
   newobj->state = &s_blood1;
   newobj->ticcount = 1;

   newobj->tilex = x >> TILESHIFT;
   newobj->tiley = y >> TILESHIFT;
   newobj->x = ob->x;
   newobj->y = ob->y;
   newobj->obclass = bloodobj;
   newobj->dir = nodir;
   newobj->angle = north;
   newobj->speed = 0;

   newobj-> flags = FL_NONMARK;
   newobj->active = ac_yes;
  }  

void    T_Schabb (objtype *ob);
void    T_SchabbThrow (objtype *ob);
void    T_Fake (objtype *ob);
void    T_Fake1 (objtype *ob);
void    T_Fake2 (objtype *ob);
void    T_FakeFire (objtype *ob);
void    T_Ghosts (objtype *ob);

void A_Burn (objtype *ob);
void A_Slurpie (objtype *ob);
void A_Slurpie2 (objtype *ob);
void A_HitlerMorph (objtype *ob);
void A_MechaSound (objtype *ob);

/*
=================
=
= A_Smokeball
=
=================
*/

void A_Smokeball (objtype *ob)
{
    GetNewActor ();
    
    if (ob->obclass == hrocketobj)
        newobj->state = &s_hsmoke1;
    newobj->ticcount = 7;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = inertobj;
    newobj->active = ac_yes;

    newobj->flags = FL_NEVERMARK;
}

/*
=================
=
= A_SmokeGasball
=
=================
*/

void A_SmokeGasball (objtype *ob)
{
    GetNewActor ();
    
    if (ob->obclass == gasballobj)
        newobj->state = &s_hsmoke21;
    newobj->ticcount = 7;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = inertobj;
    newobj->active = ac_yes;

    newobj->flags = FL_NEVERMARK;
}

/*
=================
=
= A_Smoke
=
=================
*/

void A_Smoke (objtype *ob)
{
    GetNewActor ();
    
    if (ob->obclass == rocketobj)
        newobj->state = &s_smoke1;
    newobj->ticcount = 6;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = inertobj;
    newobj->active = ac_yes;

    newobj->flags = FL_NEVERMARK;
}

/*
=================
=
= A_DSmoke
=
=================
*/

void A_DSmoke (objtype *ob)
{
    GetNewActor ();
    
    if (ob->obclass == drocketobj)
        newobj->state = &s_dsmoke1;
    newobj->ticcount = 6;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = inertobj;
    newobj->active = ac_yes;

    newobj->flags = FL_NEVERMARK;
}



/*
===================
=
= ProjectileTryMove
=
= returns true if move ok
===================
*/

#define PROJSIZE        0x2000

boolean ProjectileTryMove (objtype *ob)
{
    int      xl,yl,xh,yh,x,y;
    objtype *check;

    xl = (ob->x-PROJSIZE) >> TILESHIFT;
    yl = (ob->y-PROJSIZE) >> TILESHIFT;

    xh = (ob->x+PROJSIZE) >> TILESHIFT;
    yh = (ob->y+PROJSIZE) >> TILESHIFT;

    //
    // check for solid walls
    //
    for (y=yl;y<=yh;y++)
        for (x=xl;x<=xh;x++)
        {
            check = actorat[x][y];
            if (check && !ISPOINTER(check))
                return false;
        }

        return true;
}

/*
=================
=
= T_Shadowball
=
=================
*/

void T_Shadowball (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);


   GetNewActor ();
   newobj->state = &s_shadowball1;
   newobj->ticcount = 1;

   newobj->tilex = ob->tilex;
   newobj->tiley = ob->tiley;
   newobj->x = ob->x;
   newobj->y = ob->y;
   newobj->obclass = shadowballobj;
   newobj->dir = nodir;
   newobj->angle = iangle;
   newobj->speed = 0x2000l;

   newobj->flags = FL_NONMARK;
   newobj->active = ac_yes;

   PlaySoundLocActor (SHADOWATTACKSND,newobj);   //Change to the sound you want.
} 

/*
=================
=
= T_Shadowball2
=
=================
*/

void T_Shadowball2 (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);


   GetNewActor ();
   newobj->state = &s_2shadowball1;
   newobj->ticcount = 1;

   newobj->tilex = ob->tilex;
   newobj->tiley = ob->tiley;
   newobj->x = ob->x;
   newobj->y = ob->y;
   newobj->obclass = shadowball1obj;
   newobj->dir = nodir;
   newobj->angle = iangle;
   newobj->speed = 0x2000l;

   newobj->flags = FL_NONMARK;
   newobj->active = ac_yes;

   PlaySoundLocActor (SHADOWATTACKSND,newobj);   //Change to the sound you want.
} 

/*
=================
=
= T_Ball
=
=================
*/

void T_Ball (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);


   GetNewActor ();
   newobj->state = &s_ball1;
   newobj->ticcount = 1;

   newobj->tilex = ob->tilex;
   newobj->tiley = ob->tiley;
   newobj->x = ob->x;
   newobj->y = ob->y;
   newobj->obclass = ballobj;
   newobj->dir = nodir;
   newobj->angle = iangle;
   newobj->speed = 0x2000l;

   newobj->flags = FL_NONMARK;
   newobj->active = ac_yes;

   PlaySoundLocActor (SHADOWATTACKSND,newobj);   //Change to the sound you want.
} 

/*
=================
=
= T_Shadowball3
=
=================
*/

void T_Shadowball3 (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);


   GetNewActor ();
   newobj->state = &s_3shadowball1;
   newobj->ticcount = 1;

   newobj->tilex = ob->tilex;
   newobj->tiley = ob->tiley;
   newobj->x = ob->x;
   newobj->y = ob->y;
   newobj->obclass = shadowball2obj;
   newobj->dir = nodir;
   newobj->angle = iangle;
   newobj->speed = 0x2000l;

   newobj->flags = FL_NONMARK;
   newobj->active = ac_yes;

   PlaySoundLocActor (SHADOWATTACKSND,newobj);   //Change to the sound you want.
} 

/*
===============
=
= T_Launch
=
===============
*/

void T_Launch (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2 ((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);

    GetNewActor ();
    newobj->state = &s_rocket;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = rocketobj;
    switch(ob->obclass)
    {
        case mechahitlerobj:
        case soullessobj:
            newobj->state = &s_hrocket;
            newobj->obclass = hrocketobj;
            PlaySoundLocActor (SOULLESSBALLSND,newobj);
            break;
        default:
            PlaySoundLocActor (MISSILEFIRESND,newobj);
    }

    newobj->dir = nodir;
    newobj->angle = iangle;
    newobj->speed = 0x2000l;
    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;
}


/*
=================
=
= A_StartAttack
=
=================
*/

int Damage (long dx, long dy, long range, int max)
{
 double ddx = (double) dx ;
 double ddy = (double) dy ;
 double drange = (double) range ;
 double dmax = (double) max ;
 double distance = sqrt (ddx * ddx + ddy * ddy) ;

 if (distance > drange)
  return 0 ;
 else
  return (int) (dmax - distance / drange * dmax) ;
}

void A_StartAttack (objtype *ob)
{
//	ob->temp1 = 0;
	long		deltax, deltay;
	objtype	*extracheck;
	int		damage ;
	
	extracheck = objlist ;
	while (extracheck)
	{
		if (extracheck != ob && (extracheck->flags & FL_SHOOTABLE))
		{
			deltax = LABS(ob->x - extracheck->x);
			deltay = LABS(ob->y - extracheck->y);
			if (deltax < BARRELEXPLSIZE * 2 && deltay < BARRELEXPLSIZE * 2) {
				damage = Damage (deltax, deltay, BARRELEXPLSIZE, 300) ;
				if (damage > 0)
					DamageActor (extracheck, damage);
			}
		}
		extracheck = extracheck->next ;
	}
	deltax = LABS(ob->x - player->x);
	deltay = LABS(ob->y - player->y);
	if (deltax < BARRELEXPLSIZE * 2 && deltay < BARRELEXPLSIZE * 2) {
		damage = Damage (deltax, deltay, BARRELEXPLSIZE, 300) ;
		if (damage > 0)
			TakeDamage (damage, ob);
	}
}



/*
=================
=
= T_Projectile
=
=================
*/

void T_Projectile (objtype *ob)
{
   long   deltax,deltay;
   int      damage;
   long   speed;
   objtype *check, *extracheck;

   speed = (long)ob->speed*tics;

   deltax = FixedMul(speed,costable[ob->angle]);
   deltay = -FixedMul(speed,sintable[ob->angle]);

   if (deltax>0x10000l)
      deltax = 0x10000l;
   if (deltay>0x10000l)
      deltay = 0x10000l;

   ob->x += deltax;
   ob->y += deltay;

   if (!ProjectileTryMove (ob))
   {
      if (ob->obclass == rocketobj)
      {
 //        PlaySoundLocActor(MISSILEHITSND,ob);
         A_Slurpie2 (ob);
         ob->state = &s_boom1;
         A_StartAttack (ob);
      }
      else if (ob->obclass == drocketobj)
      {
 //        PlaySoundLocActor(MISSILEHITSND,ob);
         A_Slurpie2 (ob);
         ob->state = &s_dboom1;
         A_StartAttack (ob);
      }
      else if (ob->obclass == hrocketobj)
      {
         PlaySoundLocActor(SOULLESSBALLHITSND,ob);
         ob->state = &s_hboom1;
      }
  else if (ob->obclass == shadowballobj)
      {
         PlaySoundLocActor(SHADOWBALLHITSND,ob);
         ob->state = &s_boom11;
      }
      else if (ob->obclass == ballobj)
      {
         PlaySoundLocActor(SHADOWBALLHITSND,ob);
         ob->state = &s_boom51;
      }
      else if (ob->obclass == shadowball1obj)
      {
         PlaySoundLocActor(SHADOWBALLHITSND,ob);
         ob->state = &s_boom21;
      }
      else if (ob->obclass == shadowball2obj)
      {
         PlaySoundLocActor(SHADOWBALLHITSND,ob);
         ob->state = &s_boom31;
      }
      else if (ob->obclass == gasballobj)
      {
         PlaySoundLocActor(GASBALLHITSND,ob);
         ob->state = &s_boom41;
      }
      else
         ob->state = NULL;      // mark for removal

      return;
   }

      if (ob->obclass == rocketobj && ob->flags & FL_NONMARK && ob->flags & FL_BONUS)
   {
      check = objlist ;
      while (check)
      {
         if (check->flags & FL_SHOOTABLE)
         {
            deltax = LABS(ob->x - check->x);
            deltay = LABS(ob->y - check->y);

            if (deltax < BJROCKETSIZE && deltay < BJROCKETSIZE)
            {
//               if (check->obclass != angelobj)
//               PlaySoundLocActor(MISSILEHITSND,ob);
               A_Slurpie2 (ob) ;
               ob->state = &s_boom1;     
//                DamageActor (check, 150);
                A_StartAttack (ob) ;
                return;    
            }
         }
         check = check->next ;
      }
   }

   else
   {
   {
      // Check if player hit by anything

      deltax = LABS(ob->x - player->x);
      deltay = LABS(ob->y - player->y);

      if (deltax < PROJECTILESIZE && deltay < PROJECTILESIZE)
      {   // hit the player
         switch (ob->obclass)
         {
         case shadowballobj:
            ob->state = &s_boom11;
         case shadowball1obj: 
            ob->state = &s_boom21;
         case needleobj:
            damage = (US_RndT() >>3) + 20;
            break;
         case shadowball2obj:
            ob->state = &s_boom31;
         case gasballobj:
            ob->state = &s_boom41; 
            damage = (US_RndT() >>3) + 30;
            break;
         case drocketobj:
         case rocketobj:
              A_Slurpie2 (ob) ;
              ob->state = &s_boom1;
              A_StartAttack (ob) ;
         case hrocketobj:
             //   case sparkobj:
            damage = (US_RndT() >>3) + 30;
            break;
        case ballobj:
             //   case sparkobj:
            damage = (US_RndT() >>3) + 50;
            break;
         case fireobj:
            damage = (US_RndT() >>3);
            break;
         }

         TakeDamage (damage,ob);
         ob->state = NULL;      // mark for removal
         return;
      }
   }


   ob->tilex = ob->x >> TILESHIFT;
   ob->tiley = ob->y >> TILESHIFT;

}

   } 


/*
=============================================================================

GUARD

=============================================================================
*/

//
// Vampire Officers
//

extern  statetype s_vofcstand;

extern  statetype s_vofcpath1;
extern  statetype s_vofcpath1s;
extern  statetype s_vofcpath2;
extern  statetype s_vofcpath3;
extern  statetype s_vofcpath3s;
extern  statetype s_vofcpath4;

extern  statetype s_vofcpain;
extern  statetype s_vofcpain1;

extern  statetype s_vofcgiveup;

extern  statetype s_vofcshoot1;
extern  statetype s_vofcshoot2;
extern  statetype s_vofcshoot3;
extern  statetype s_vofcshoot4;
extern  statetype s_vofcshoot5;
extern  statetype s_vofcshoot6;
extern  statetype s_vofcshoot7;
extern  statetype s_vofcshoot8;
extern  statetype s_vofcshoot9;
extern  statetype s_vofcshoot10;
extern  statetype s_vofcshoot11;
extern  statetype s_vofcshoot12;
extern  statetype s_vofcshoot13;
extern  statetype s_vofcshoot14;
extern  statetype s_vofcshoot15;

extern  statetype s_vofcchase1;
extern  statetype s_vofcchase1s;
extern  statetype s_vofcchase2;
extern  statetype s_vofcchase3;
extern  statetype s_vofcchase3s;
extern  statetype s_vofcchase4;

extern  statetype s_vofcdie1;
extern  statetype s_vofcdie2;
extern  statetype s_vofcdie3;
extern  statetype s_vofcdie4;
extern  statetype s_vofcdie5;
extern  statetype s_vofcdie6;
extern  statetype s_vofcdie7;
extern  statetype s_vofcdie8;
extern  statetype s_vofcdie9;

extern  statetype s_vofcsplatter1;
extern  statetype s_vofcsplatter1d;
extern  statetype s_vofcsplatter2;
extern  statetype s_vofcsplatter3;
extern  statetype s_vofcsplatter4;
extern  statetype s_vofcsplatter5;
extern  statetype s_vofcsplatter6;
extern  statetype s_vofcsplatter7;
extern  statetype s_vofcsplatter8;

extern  statetype s_vofcburn1;
extern  statetype s_vofcburn1d;
extern  statetype s_vofcburn2;
extern  statetype s_vofcburn3;
extern  statetype s_vofcburn4;
extern  statetype s_vofcburn5;
extern  statetype s_vofcburn6;
extern  statetype s_vofcburn7;
extern  statetype s_vofcburn8;
extern  statetype s_vofcburn9;
extern  statetype s_vofcburn10;
extern  statetype s_vofcburn11;
extern  statetype s_vofcburn12;
extern  statetype s_vofcburn13;
extern  statetype s_vofcburn14;
extern  statetype s_vofcburn15;
extern  statetype s_vofcburn16;
extern  statetype s_vofcburn17;
extern  statetype s_vofcburn18;
extern  statetype s_vofcburn19;
extern  statetype s_vofcburn20;
extern  statetype s_vofcburn21;
extern  statetype s_vofcburn22;

statetype s_vofcburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_vofcburn2};
statetype s_vofcburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_vofcburn3};
statetype s_vofcburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_vofcburn4};
statetype s_vofcburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_vofcburn5};
statetype s_vofcburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_vofcburn6};
statetype s_vofcburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_vofcburn7};
statetype s_vofcburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_vofcburn8};
statetype s_vofcburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_vofcburn9};
statetype s_vofcburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_vofcburn10};
statetype s_vofcburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_vofcburn11};
statetype s_vofcburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_vofcburn12};
statetype s_vofcburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_vofcburn13};
statetype s_vofcburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_vofcburn14};
statetype s_vofcburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_vofcburn15};
statetype s_vofcburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_vofcburn16};
statetype s_vofcburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_vofcburn17};
statetype s_vofcburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_vofcburn18};
statetype s_vofcburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_vofcburn19};
statetype s_vofcburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_vofcburn20};
statetype s_vofcburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_vofcburn21};
statetype s_vofcburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_vofcburn22};
statetype s_vofcburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_vofcburn22};

statetype s_vofcsplatter1 = {false,SPR_SPLAT6_1,9,NULL,(statefunc)A_Slurpie,&s_vofcsplatter2};
statetype s_vofcsplatter2 = {false,SPR_SPLAT6_2,9,NULL,NULL,&s_vofcsplatter3};
statetype s_vofcsplatter3 = {false,SPR_SPLAT6_3,9,NULL,NULL,&s_vofcsplatter4};
statetype s_vofcsplatter4 = {false,SPR_SPLAT6_4,9,NULL,NULL,&s_vofcsplatter5};
statetype s_vofcsplatter5 = {false,SPR_SPLAT6_5,9,NULL,NULL,&s_vofcsplatter6};
statetype s_vofcsplatter6 = {false,SPR_SPLAT6_6,9,NULL,NULL,&s_vofcsplatter7};
statetype s_vofcsplatter7 = {false,SPR_SPLAT6_7,9,NULL,NULL,&s_vofcsplatter8};
statetype s_vofcsplatter8 = {false,SPR_SPLAT6_8,0,NULL,NULL,&s_vofcsplatter8};

statetype s_vofcstand            = {false,SPR_VOFC_S_1,0,(statefunc)T_Stand,NULL,&s_vofcstand};

statetype s_vofcpath1            = {true,SPR_VOFC_W1_1,20,(statefunc)T_Path,NULL,&s_vofcpath1s};
statetype s_vofcpath1s           = {true,SPR_VOFC_W1_1,5,NULL,NULL,&s_vofcpath2};
statetype s_vofcpath2            = {true,SPR_VOFC_W2_1,15,(statefunc)T_Path,NULL,&s_vofcpath3};
statetype s_vofcpath3            = {true,SPR_VOFC_W3_1,20,(statefunc)T_Path,NULL,&s_vofcpath3s};
statetype s_vofcpath3s           = {true,SPR_VOFC_W3_1,5,NULL,NULL,&s_vofcpath4};
statetype s_vofcpath4            = {true,SPR_VOFC_W4_1,15,(statefunc)T_Path,NULL,&s_vofcpath1};

statetype s_vofcpain             = {2,SPR_VOFC_PAIN_1,10,NULL,NULL,&s_vofcchase1};
statetype s_vofcpain1            = {2,SPR_VOFC_PAIN_1,10,NULL,NULL,&s_vofcchase1};

statetype s_vofcshoot1           = {false,SPR_VOFC_SHOOT1,10,NULL,NULL,&s_vofcshoot2};
statetype s_vofcshoot2           = {false,SPR_VOFC_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_vofcshoot3};
statetype s_vofcshoot3           = {false,SPR_VOFC_SHOOT3,5,NULL,NULL,&s_vofcshoot4};
statetype s_vofcshoot4           = {false,SPR_VOFC_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_vofcshoot5};
statetype s_vofcshoot5           = {false,SPR_VOFC_SHOOT3,5,NULL,NULL,&s_vofcshoot6};
statetype s_vofcshoot6           = {false,SPR_VOFC_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_vofcshoot7};
statetype s_vofcshoot7           = {false,SPR_VOFC_SHOOT3,5,NULL,NULL,&s_vofcshoot8};
statetype s_vofcshoot8           = {false,SPR_VOFC_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_vofcshoot9};
statetype s_vofcshoot9           = {false,SPR_VOFC_SHOOT3,5,NULL,NULL,&s_vofcshoot10};
statetype s_vofcshoot10           = {false,SPR_VOFC_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_vofcshoot11};
statetype s_vofcshoot11           = {false,SPR_VOFC_SHOOT3,5,NULL,NULL,&s_vofcshoot12};
statetype s_vofcshoot12           = {false,SPR_VOFC_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_vofcshoot13};
statetype s_vofcshoot13           = {false,SPR_VOFC_SHOOT3,5,NULL,NULL,&s_vofcshoot14};
statetype s_vofcshoot14           = {false,SPR_VOFC_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_vofcshoot15};
statetype s_vofcshoot15           = {false,SPR_VOFC_SHOOT3,5,NULL,NULL,&s_vofcchase1};

statetype s_vofcchase1           = {true,SPR_VOFC_W1_1,10,(statefunc)T_Chase,NULL,&s_vofcchase1s};
statetype s_vofcchase1s          = {true,SPR_VOFC_W1_1,3,NULL,NULL,&s_vofcchase2};
statetype s_vofcchase2           = {true,SPR_VOFC_W2_1,8,(statefunc)T_Chase,NULL,&s_vofcchase3};
statetype s_vofcchase3           = {true,SPR_VOFC_W3_1,10,(statefunc)T_Chase,NULL,&s_vofcchase3s};
statetype s_vofcchase3s          = {true,SPR_VOFC_W3_1,3,NULL,NULL,&s_vofcchase4};
statetype s_vofcchase4           = {true,SPR_VOFC_W4_1,8,(statefunc)T_Chase,NULL,&s_vofcchase1};

statetype s_vofcdie1             = {false,SPR_VOFC_DIE_1,5,NULL,(statefunc)A_DeathScream,&s_vofcdie2};
statetype s_vofcdie2             = {false,SPR_VOFC_DIE_2,5,NULL,NULL,&s_vofcdie3};
statetype s_vofcdie3             = {false,SPR_VOFC_DIE_3,5,NULL,NULL,&s_vofcdie4};
statetype s_vofcdie4             = {false,SPR_VOFC_DIE_4,5,NULL,NULL,&s_vofcdie5};
statetype s_vofcdie5             = {false,SPR_VOFC_DIE_5,5,NULL,NULL,&s_vofcdie6};
statetype s_vofcdie6             = {false,SPR_VOFC_DIE_6,5,NULL,NULL,&s_vofcdie7};
statetype s_vofcdie7             = {false,SPR_VOFC_DIE_7,5,NULL,NULL,&s_vofcdie8};
statetype s_vofcdie8             = {false,SPR_VOFC_DIE_8,5,NULL,NULL,&s_vofcdie9};
statetype s_vofcdie9             = {false,SPR_VOFC_DEAD,0,NULL,NULL,&s_vofcdie9};

//
// Slave Girls
//

extern  statetype s_slvstand;

extern  statetype s_slvpath1;
extern  statetype s_slvpath1s;
extern  statetype s_slvpath2;
extern  statetype s_slvpath3;
extern  statetype s_slvpath3s;
extern  statetype s_slvpath4;

extern  statetype s_slvpain;
extern  statetype s_slvpain1;

extern  statetype s_slvshoot1;
extern  statetype s_slvshoot2;
extern  statetype s_slvshoot3;

extern  statetype s_slvchase1;
extern  statetype s_slvchase1s;
extern  statetype s_slvchase2;
extern  statetype s_slvchase3;
extern  statetype s_slvchase3s;
extern  statetype s_slvchase4;

extern  statetype s_slvdie1;
extern  statetype s_slvdie2;
extern  statetype s_slvdie3;
extern  statetype s_slvdie4;

extern  statetype s_slvsplatter1;
extern  statetype s_slvsplatter2;
extern  statetype s_slvsplatter3;
extern  statetype s_slvsplatter4;
extern  statetype s_slvsplatter5;
extern  statetype s_slvsplatter6;

extern  statetype s_slvsplatter1;
extern  statetype s_slvsplatter1d;
extern  statetype s_slvsplatter2;
extern  statetype s_slvsplatter3;
extern  statetype s_slvsplatter4;
extern  statetype s_slvsplatter5;
extern  statetype s_slvsplatter6;
extern  statetype s_slvsplatter7;
extern  statetype s_slvsplatter8;

statetype s_slvsplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_slvsplatter2};
statetype s_slvsplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_slvsplatter3};
statetype s_slvsplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_slvsplatter4};
statetype s_slvsplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_slvsplatter5};
statetype s_slvsplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_slvsplatter6};
statetype s_slvsplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_slvsplatter7};
statetype s_slvsplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_slvsplatter8};
statetype s_slvsplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_slvsplatter8};

statetype s_slvstand             = {false,SPR_SLV_S_1,0,(statefunc)T_Stand,NULL,&s_slvstand};

statetype s_slvpath1             = {true,SPR_SLV_W1_1,20,(statefunc)T_Path,NULL,&s_slvpath1s};
statetype s_slvpath1s            = {true,SPR_SLV_W1_1,5,NULL,NULL,&s_slvpath2};
statetype s_slvpath2             = {true,SPR_SLV_W2_1,15,(statefunc)T_Path,NULL,&s_slvpath3};
statetype s_slvpath3             = {true,SPR_SLV_W3_1,20,(statefunc)T_Path,NULL,&s_slvpath3s};
statetype s_slvpath3s            = {true,SPR_SLV_W3_1,5,NULL,NULL,&s_slvpath4};
statetype s_slvpath4             = {true,SPR_SLV_W4_1,15,(statefunc)T_Path,NULL,&s_slvpath1};

statetype s_slvpain              = {2,SPR_SLV_PAIN_1,10,NULL,NULL,&s_slvchase1};
statetype s_slvpain1             = {2,SPR_SLV_PAIN_1,10,NULL,NULL,&s_slvchase1};

statetype s_slvshoot1            = {false,SPR_SLV_SHOOT1,10,NULL,NULL,&s_slvshoot2};
statetype s_slvshoot2            = {false,SPR_SLV_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_slvshoot3};
statetype s_slvshoot3            = {false,SPR_SLV_SHOOT3,5,NULL,NULL,&s_slvchase1};

statetype s_slvchase1            = {true,SPR_SLV_W1_1,10,(statefunc)T_Chase,NULL,&s_slvchase1s};
statetype s_slvchase1s           = {true,SPR_SLV_W1_1,3,NULL,NULL,&s_slvchase2};
statetype s_slvchase2            = {true,SPR_SLV_W2_1,8,(statefunc)T_Chase,NULL,&s_slvchase3};
statetype s_slvchase3            = {true,SPR_SLV_W3_1,10,(statefunc)T_Chase,NULL,&s_slvchase3s};
statetype s_slvchase3s           = {true,SPR_SLV_W3_1,3,NULL,NULL,&s_slvchase4};
statetype s_slvchase4            = {true,SPR_SLV_W4_1,8,(statefunc)T_Chase,NULL,&s_slvchase1};

statetype s_slvdie1              = {false,SPR_SLV_DIE_1,8,NULL,(statefunc)A_DeathScream,&s_slvdie2};
statetype s_slvdie2              = {false,SPR_SLV_DIE_2,8,NULL,NULL,&s_slvdie3};
statetype s_slvdie3              = {false,SPR_SLV_DIE_3,8,NULL,NULL,&s_slvdie4};
statetype s_slvdie4              = {false,SPR_SLV_DEAD,0,NULL,NULL,&s_slvdie4};

//
// Advance Flamer unit
//

extern  statetype s_afustand;

extern  statetype s_afupath1;
extern  statetype s_afupath1s;
extern  statetype s_afupath2;
extern  statetype s_afupath3;
extern  statetype s_afupath3s;
extern  statetype s_afupath4;

extern  statetype s_afupain;
extern  statetype s_afupain1;

extern  statetype s_afushoot1;
extern  statetype s_afushoot2;
extern  statetype s_afushoot3;
extern  statetype s_afushoot4;
extern  statetype s_afushoot5;
extern  statetype s_afushoot6;
extern  statetype s_afushoot7;
extern  statetype s_afushoot8;
extern  statetype s_afushoot9;
extern  statetype s_afushoot10;
extern  statetype s_afushoot11;
extern  statetype s_afushoot12;
extern  statetype s_afushoot13;
extern  statetype s_afushoot14;
extern  statetype s_afushoot15;

extern  statetype s_afuchase1;
extern  statetype s_afuchase1s;
extern  statetype s_afuchase2;
extern  statetype s_afuchase3;
extern  statetype s_afuchase3s;
extern  statetype s_afuchase4;

extern  statetype s_afudie1;
extern  statetype s_afudie2;
extern  statetype s_afudie3;
extern  statetype s_afudie4;
extern  statetype s_afudie5;
extern  statetype s_afudie6;
extern  statetype s_afudie7;

extern  statetype s_afusplatter1;
extern  statetype s_afusplatter2;
extern  statetype s_afusplatter3;
extern  statetype s_afusplatter4;
extern  statetype s_afusplatter5;
extern  statetype s_afusplatter6;

statetype s_afusplatter1              = {false,SPR_BFU_DIE_1,5,NULL,(statefunc)A_Slurpie,&s_afusplatter2};
statetype s_afusplatter2              = {false,SPR_BFU_DIE_2,5,NULL,NULL,&s_afusplatter3};
statetype s_afusplatter3              = {false,SPR_BFU_DIE_3,5,NULL,NULL,&s_afusplatter4};
statetype s_afusplatter4              = {false,SPR_BFU_DIE_4,5,NULL,NULL,&s_afusplatter5};
statetype s_afusplatter5              = {false,SPR_BFU_DIE_5,5,NULL,NULL,&s_afusplatter6};
statetype s_afusplatter6              = {false,SPR_BFU_DEAD,0,NULL,NULL,&s_afusplatter6};

statetype s_afustand             = {false,SPR_AFU_S_1,0,(statefunc)T_Stand,NULL,&s_afustand};

statetype s_afupath1             = {true,SPR_AFU_W1_1,20,(statefunc)T_Path,NULL,&s_afupath1s};
statetype s_afupath1s            = {true,SPR_AFU_W1_1,5,NULL,NULL,&s_afupath2};
statetype s_afupath2             = {true,SPR_AFU_W2_1,15,(statefunc)T_Path,NULL,&s_afupath3};
statetype s_afupath3             = {true,SPR_AFU_W3_1,20,(statefunc)T_Path,NULL,&s_afupath3s};
statetype s_afupath3s            = {true,SPR_AFU_W3_1,5,NULL,NULL,&s_afupath4};
statetype s_afupath4             = {true,SPR_AFU_W4_1,15,(statefunc)T_Path,NULL,&s_afupath1};

statetype s_afupain              = {2,SPR_AFU_PAIN_1,10,NULL,NULL,&s_afuchase1};
statetype s_afupain1             = {2,SPR_AFU_PAIN_1,10,NULL,NULL,&s_afuchase1};

statetype s_afushoot1            = {false,SPR_AFU_SHOOT1,10,NULL,NULL,&s_afushoot2};
statetype s_afushoot2            = {false,SPR_AFU_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_afushoot3};
statetype s_afushoot3            = {false,SPR_AFU_SHOOT3,5,NULL,NULL,&s_afushoot4};
statetype s_afushoot4            = {false,SPR_AFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_afushoot5};
statetype s_afushoot5            = {false,SPR_AFU_SHOOT3,5,NULL,NULL,&s_afushoot6};
statetype s_afushoot6            = {false,SPR_AFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_afushoot7};
statetype s_afushoot7            = {false,SPR_AFU_SHOOT3,5,NULL,NULL,&s_afushoot8};
statetype s_afushoot8            = {false,SPR_AFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_afushoot9};
statetype s_afushoot9            = {false,SPR_AFU_SHOOT3,5,NULL,NULL,&s_afushoot10};
statetype s_afushoot10           = {false,SPR_AFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_afushoot11};
statetype s_afushoot11           = {false,SPR_AFU_SHOOT3,5,NULL,NULL,&s_afushoot12};
statetype s_afushoot12           = {false,SPR_AFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_afushoot13};
statetype s_afushoot13           = {false,SPR_AFU_SHOOT3,5,NULL,NULL,&s_afushoot14};
statetype s_afushoot14           = {false,SPR_AFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_afushoot15};
statetype s_afushoot15           = {false,SPR_AFU_SHOOT3,5,NULL,NULL,&s_afuchase1};

statetype s_afuchase1            = {true,SPR_AFU_W1_1,10,(statefunc)T_Chase,NULL,&s_afuchase1s};
statetype s_afuchase1s           = {true,SPR_AFU_W1_1,3,NULL,NULL,&s_afuchase2};
statetype s_afuchase2            = {true,SPR_AFU_W2_1,8,(statefunc)T_Chase,NULL,&s_afuchase3};
statetype s_afuchase3            = {true,SPR_AFU_W3_1,10,(statefunc)T_Chase,NULL,&s_afuchase3s};
statetype s_afuchase3s           = {true,SPR_AFU_W3_1,3,NULL,NULL,&s_afuchase4};
statetype s_afuchase4            = {true,SPR_AFU_W4_1,8,(statefunc)T_Chase,NULL,&s_afuchase1};

statetype s_afudie1              = {false,SPR_AFU_DIE_1,8,NULL,(statefunc)A_DeathScream,&s_afudie2};
statetype s_afudie2              = {false,SPR_AFU_DIE_2,8,NULL,NULL,&s_afudie3};
statetype s_afudie3              = {false,SPR_AFU_DIE_3,8,NULL,NULL,&s_afudie4};
statetype s_afudie4              = {false,SPR_AFU_DIE_4,8,NULL,NULL,&s_afudie5};
statetype s_afudie5              = {false,SPR_AFU_DIE_5,8,NULL,NULL,&s_afudie6};
statetype s_afudie6              = {false,SPR_AFU_DIE_6,8,NULL,NULL,&s_afudie7};
statetype s_afudie7              = {false,SPR_AFU_DEAD,0,NULL,NULL,&s_afudie7};

//
// Basic Flamer unit
//

extern  statetype s_bfustand;

extern  statetype s_bfupath1;
extern  statetype s_bfupath1s;
extern  statetype s_bfupath2;
extern  statetype s_bfupath3;
extern  statetype s_bfupath3s;
extern  statetype s_bfupath4;

extern  statetype s_bfupain;
extern  statetype s_bfupain1;

extern  statetype s_bfushoot1;
extern  statetype s_bfushoot2;
extern  statetype s_bfushoot3;
extern  statetype s_bfushoot4;
extern  statetype s_bfushoot5;
extern  statetype s_bfushoot6;
extern  statetype s_bfushoot7;
extern  statetype s_bfushoot8;
extern  statetype s_bfushoot9;
extern  statetype s_bfushoot10;
extern  statetype s_bfushoot11;
extern  statetype s_bfushoot12;
extern  statetype s_bfushoot13;
extern  statetype s_bfushoot14;
extern  statetype s_bfushoot15;

extern  statetype s_bfuchase1;
extern  statetype s_bfuchase1s;
extern  statetype s_bfuchase2;
extern  statetype s_bfuchase3;
extern  statetype s_bfuchase3s;
extern  statetype s_bfuchase4;

extern  statetype s_bfudie1;
extern  statetype s_bfudie2;
extern  statetype s_bfudie3;
extern  statetype s_bfudie4;
extern  statetype s_bfudie5;
extern  statetype s_bfudie6;

statetype s_bfustand             = {false,SPR_BFU_S_1,0,(statefunc)T_Stand,NULL,&s_bfustand};

statetype s_bfupath1             = {true,SPR_BFU_W1_1,20,(statefunc)T_Path,NULL,&s_bfupath1s};
statetype s_bfupath1s            = {true,SPR_BFU_W1_1,5,NULL,NULL,&s_bfupath2};
statetype s_bfupath2             = {true,SPR_BFU_W2_1,15,(statefunc)T_Path,NULL,&s_bfupath3};
statetype s_bfupath3             = {true,SPR_BFU_W3_1,20,(statefunc)T_Path,NULL,&s_bfupath3s};
statetype s_bfupath3s            = {true,SPR_BFU_W3_1,5,NULL,NULL,&s_bfupath4};
statetype s_bfupath4             = {true,SPR_BFU_W4_1,15,(statefunc)T_Path,NULL,&s_bfupath1};

statetype s_bfupain              = {2,SPR_BFU_PAIN_1,10,NULL,NULL,&s_bfuchase1};
statetype s_bfupain1             = {2,SPR_BFU_PAIN_1,10,NULL,NULL,&s_bfuchase1};

statetype s_bfushoot1            = {false,SPR_BFU_SHOOT1,10,NULL,NULL,&s_bfushoot2};
statetype s_bfushoot2             = {false,SPR_BFU_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_bfushoot3};
statetype s_bfushoot3            = {false,SPR_BFU_SHOOT3,5,NULL,NULL,&s_bfushoot4};
statetype s_bfushoot4            = {false,SPR_BFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_bfushoot5};
statetype s_bfushoot5            = {false,SPR_BFU_SHOOT3,5,NULL,NULL,&s_bfushoot6};
statetype s_bfushoot6            = {false,SPR_BFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_bfushoot7};
statetype s_bfushoot7             = {false,SPR_BFU_SHOOT3,5,NULL,NULL,&s_bfushoot8};
statetype s_bfushoot8             = {false,SPR_BFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_bfushoot9};
statetype s_bfushoot9            = {false,SPR_BFU_SHOOT3,5,NULL,NULL,&s_bfushoot10};
statetype s_bfushoot10           = {false,SPR_BFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_bfushoot11};
statetype s_bfushoot11           = {false,SPR_BFU_SHOOT3,5,NULL,NULL,&s_bfushoot12};
statetype s_bfushoot12           = {false,SPR_BFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_bfushoot13};
statetype s_bfushoot13           = {false,SPR_BFU_SHOOT3,5,NULL,NULL,&s_bfushoot14};
statetype s_bfushoot14           = {false,SPR_BFU_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_bfushoot15};
statetype s_bfushoot15           = {false,SPR_BFU_SHOOT3,5,NULL,NULL,&s_bfuchase1};

statetype s_bfuchase1            = {true,SPR_BFU_W1_1,10,(statefunc)T_Chase,NULL,&s_bfuchase1s};
statetype s_bfuchase1s           = {true,SPR_BFU_W1_1,3,NULL,NULL,&s_bfuchase2};
statetype s_bfuchase2            = {true,SPR_BFU_W2_1,8,(statefunc)T_Chase,NULL,&s_bfuchase3};
statetype s_bfuchase3            = {true,SPR_BFU_W3_1,10,(statefunc)T_Chase,NULL,&s_bfuchase3s};
statetype s_bfuchase3s           = {true,SPR_BFU_W3_1,3,NULL,NULL,&s_bfuchase4};
statetype s_bfuchase4            = {true,SPR_BFU_W4_1,8,(statefunc)T_Chase,NULL,&s_bfuchase1};

statetype s_bfudie1              = {false,SPR_BFU_DIE_1,5,NULL,(statefunc)A_DeathScream,&s_bfudie2};
statetype s_bfudie2              = {false,SPR_BFU_DIE_2,5,NULL,NULL,&s_bfudie3};
statetype s_bfudie3              = {false,SPR_BFU_DIE_3,5,NULL,NULL,&s_bfudie4};
statetype s_bfudie4              = {false,SPR_BFU_DIE_4,5,NULL,NULL,&s_bfudie5};
statetype s_bfudie5              = {false,SPR_BFU_DIE_5,5,NULL,NULL,&s_bfudie6};
statetype s_bfudie6              = {false,SPR_BFU_DEAD,0,NULL,NULL,&s_bfudie6};

//
// Striker
//

extern  statetype s_sksstand;

extern  statetype s_skspath1;
extern  statetype s_skspath1s;
extern  statetype s_skspath2;
extern  statetype s_skspath3;
extern  statetype s_skspath3s;
extern  statetype s_skspath4;

extern  statetype s_skspain;
extern  statetype s_skspain1;

extern  statetype s_sksshoot1;
extern  statetype s_sksshoot2;
extern  statetype s_sksshoot3;
extern  statetype s_sksshoot4;
extern  statetype s_sksshoot5;
extern  statetype s_sksshoot6;
extern  statetype s_sksshoot7;
extern  statetype s_sksshoot8;
extern  statetype s_sksshoot9;
extern  statetype s_sksshoot10;
extern  statetype s_sksshoot11;
extern  statetype s_sksshoot12;
extern  statetype s_sksshoot13;
extern  statetype s_sksshoot14;
extern  statetype s_sksshoot15;

extern  statetype s_skschase1;
extern  statetype s_skschase1s;
extern  statetype s_skschase2;
extern  statetype s_skschase3;
extern  statetype s_skschase3s;
extern  statetype s_skschase4;

extern  statetype s_sksdie1;
extern  statetype s_sksdie2;
extern  statetype s_sksdie3;
extern  statetype s_sksdie4;
extern  statetype s_sksdie5;
extern  statetype s_sksdie6;
extern  statetype s_sksdie7;
extern  statetype s_sksdie8;

extern  statetype s_skssplatter1;
extern  statetype s_skssplatter1d;
extern  statetype s_skssplatter2;
extern  statetype s_skssplatter3;
extern  statetype s_skssplatter4;
extern  statetype s_skssplatter5;
extern  statetype s_skssplatter6;
extern  statetype s_skssplatter7;
extern  statetype s_skssplatter8;

extern  statetype s_sksburn1;
extern  statetype s_sksburn1d;
extern  statetype s_sksburn2;
extern  statetype s_sksburn3;
extern  statetype s_sksburn4;
extern  statetype s_sksburn5;
extern  statetype s_sksburn6;
extern  statetype s_sksburn7;
extern  statetype s_sksburn8;
extern  statetype s_sksburn9;
extern  statetype s_sksburn10;
extern  statetype s_sksburn11;
extern  statetype s_sksburn12;
extern  statetype s_sksburn13;
extern  statetype s_sksburn14;
extern  statetype s_sksburn15;
extern  statetype s_sksburn16;
extern  statetype s_sksburn17;
extern  statetype s_sksburn18;
extern  statetype s_sksburn19;
extern  statetype s_sksburn20;
extern  statetype s_sksburn21;
extern  statetype s_sksburn22;

statetype s_sksburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_sksburn2};
statetype s_sksburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_sksburn3};
statetype s_sksburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_sksburn4};
statetype s_sksburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_sksburn5};
statetype s_sksburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_sksburn6};
statetype s_sksburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_sksburn7};
statetype s_sksburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_sksburn8};
statetype s_sksburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_sksburn9};
statetype s_sksburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_sksburn10};
statetype s_sksburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_sksburn11};
statetype s_sksburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_sksburn12};
statetype s_sksburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_sksburn13};
statetype s_sksburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_sksburn14};
statetype s_sksburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_sksburn15};
statetype s_sksburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_sksburn16};
statetype s_sksburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_sksburn17};
statetype s_sksburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_sksburn18};
statetype s_sksburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_sksburn19};
statetype s_sksburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_sksburn20};
statetype s_sksburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_sksburn21};
statetype s_sksburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_sksburn22};
statetype s_sksburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_sksburn22};

statetype s_skssplatter1 = {false,SPR_SPLAT6_1,9,NULL,(statefunc)A_Slurpie,&s_skssplatter2};
statetype s_skssplatter2 = {false,SPR_SPLAT6_2,9,NULL,NULL,&s_skssplatter3};
statetype s_skssplatter3 = {false,SPR_SPLAT6_3,9,NULL,NULL,&s_skssplatter4};
statetype s_skssplatter4 = {false,SPR_SPLAT6_4,9,NULL,NULL,&s_skssplatter5};
statetype s_skssplatter5 = {false,SPR_SPLAT6_5,9,NULL,NULL,&s_skssplatter6};
statetype s_skssplatter6 = {false,SPR_SPLAT6_6,9,NULL,NULL,&s_skssplatter7};
statetype s_skssplatter7 = {false,SPR_SPLAT6_7,9,NULL,NULL,&s_skssplatter8};
statetype s_skssplatter8 = {false,SPR_SPLAT6_8,0,NULL,NULL,&s_skssplatter8};

statetype s_sksstand             = {false,SPR_SKS_S_1,0,(statefunc)T_Stand,NULL,&s_sksstand};

statetype s_skspath1             = {true,SPR_SKS_W1_1,20,(statefunc)T_Path,NULL,&s_skspath1s};
statetype s_skspath1s            = {true,SPR_SKS_W1_1,5,NULL,NULL,&s_skspath2};
statetype s_skspath2             = {true,SPR_SKS_W2_1,15,(statefunc)T_Path,NULL,&s_skspath3};
statetype s_skspath3             = {true,SPR_SKS_W3_1,20,(statefunc)T_Path,NULL,&s_skspath3s};
statetype s_skspath3s            = {true,SPR_SKS_W3_1,5,NULL,NULL,&s_skspath4};
statetype s_skspath4             = {true,SPR_SKS_W4_1,15,(statefunc)T_Path,NULL,&s_skspath1};

statetype s_skspain              = {2,SPR_SKS_PAIN_1,10,NULL,NULL,&s_skschase1};
statetype s_skspain1             = {2,SPR_SKS_PAIN_1,10,NULL,NULL,&s_skschase1};

statetype s_sksshoot1            = {false,SPR_SKS_SHOOT1,10,NULL,NULL,&s_sksshoot2};
statetype s_sksshoot2            = {false,SPR_SKS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_sksshoot3};
statetype s_sksshoot3            = {false,SPR_SKS_SHOOT3,5,NULL,NULL,&s_sksshoot4};
statetype s_sksshoot4            = {false,SPR_SKS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_sksshoot5};
statetype s_sksshoot5            = {false,SPR_SKS_SHOOT3,5,NULL,NULL,&s_sksshoot6};
statetype s_sksshoot6            = {false,SPR_SKS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_sksshoot7};
statetype s_sksshoot7            = {false,SPR_SKS_SHOOT3,5,NULL,NULL,&s_sksshoot8};
statetype s_sksshoot8            = {false,SPR_SKS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_sksshoot9};
statetype s_sksshoot9            = {false,SPR_SKS_SHOOT3,5,NULL,NULL,&s_sksshoot10};
statetype s_sksshoot10           = {false,SPR_SKS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_sksshoot11};
statetype s_sksshoot11           = {false,SPR_SKS_SHOOT3,5,NULL,NULL,&s_sksshoot12};
statetype s_sksshoot12           = {false,SPR_SKS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_sksshoot13};
statetype s_sksshoot13           = {false,SPR_SKS_SHOOT3,5,NULL,NULL,&s_sksshoot14};
statetype s_sksshoot14           = {false,SPR_SKS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_sksshoot15};
statetype s_sksshoot15           = {false,SPR_SKS_SHOOT3,5,NULL,NULL,&s_skschase1};

statetype s_skschase1            = {true,SPR_SKS_W1_1,10,(statefunc)T_Chase,NULL,&s_skschase1s};
statetype s_skschase1s           = {true,SPR_SKS_W1_1,3,NULL,NULL,&s_skschase2};
statetype s_skschase2            = {true,SPR_SKS_W2_1,8,(statefunc)T_Chase,NULL,&s_skschase3};
statetype s_skschase3            = {true,SPR_SKS_W3_1,10,(statefunc)T_Chase,NULL,&s_skschase3s};
statetype s_skschase3s           = {true,SPR_SKS_W3_1,3,NULL,NULL,&s_skschase4};
statetype s_skschase4            = {true,SPR_SKS_W4_1,8,(statefunc)T_Chase,NULL,&s_skschase1};

statetype s_sksdie1              = {false,SPR_SKS_DIE_1,5,NULL,(statefunc)A_DeathScream,&s_sksdie2};
statetype s_sksdie2              = {false,SPR_SKS_DIE_2,5,NULL,NULL,&s_sksdie3};
statetype s_sksdie3              = {false,SPR_SKS_DIE_3,5,NULL,NULL,&s_sksdie4};
statetype s_sksdie4              = {false,SPR_SKS_DIE_4,5,NULL,NULL,&s_sksdie5};
statetype s_sksdie5              = {false,SPR_SKS_DIE_5,5,NULL,NULL,&s_sksdie6};
statetype s_sksdie6              = {false,SPR_SKS_DIE_6,5,NULL,NULL,&s_sksdie7};
statetype s_sksdie7              = {false,SPR_SKS_DIE_7,5,NULL,NULL,&s_sksdie8};
statetype s_sksdie8              = {false,SPR_SKS_DEAD,0,NULL,NULL,&s_sksdie8};

//
// Slorga
//

extern  statetype s_srastand;

extern  statetype s_srapath1;
extern  statetype s_srapath1s;
extern  statetype s_srapath2;
extern  statetype s_srapath3;
extern  statetype s_srapath3s;
extern  statetype s_srapath4;

extern  statetype s_srapain;
extern  statetype s_srapain1;

extern  statetype s_srashoot1;
extern  statetype s_srashoot2;
extern  statetype s_srashoot3;
extern  statetype s_srashoot4;
extern  statetype s_srashoot5;
extern  statetype s_srashoot6;
extern  statetype s_srashoot7;
extern  statetype s_srashoot8;
extern  statetype s_srashoot9;

extern  statetype s_srachase1;
extern  statetype s_srachase1s;
extern  statetype s_srachase2;
extern  statetype s_srachase3;
extern  statetype s_srachase3s;
extern  statetype s_srachase4;

extern  statetype s_sradie1;
extern  statetype s_sradie2;
extern  statetype s_sradie3;
extern  statetype s_sradie4;
extern  statetype s_sradie5;
extern  statetype s_sradie6;
extern  statetype s_sradie7;
extern  statetype s_sradie8;
extern  statetype s_sradie9;

extern  statetype s_srasplatter1;
extern  statetype s_srasplatter1d;
extern  statetype s_srasplatter2;
extern  statetype s_srasplatter3;
extern  statetype s_srasplatter4;
extern  statetype s_srasplatter5;
extern  statetype s_srasplatter6;

statetype s_srasplatter1 = {false,SPR_SPLAT5_1,9,NULL,(statefunc)A_Slurpie,&s_srasplatter2};
statetype s_srasplatter2 = {false,SPR_SPLAT5_2,9,NULL,NULL,&s_srasplatter3};
statetype s_srasplatter3 = {false,SPR_SPLAT5_3,9,NULL,NULL,&s_srasplatter4};
statetype s_srasplatter4 = {false,SPR_SPLAT5_4,9,NULL,NULL,&s_srasplatter5};
statetype s_srasplatter5 = {false,SPR_SPLAT5_5,9,NULL,NULL,&s_srasplatter6};
statetype s_srasplatter6 = {false,SPR_SPLAT5_6,9,NULL,NULL,&s_srasplatter6};


statetype s_srastand            = {true,SPR_SRA_S_1,0,(statefunc)T_Stand,NULL,&s_srastand};

statetype s_srapath1            = {true,SPR_SRA_W1_1,20,(statefunc)T_Path,NULL,&s_srapath1s};
statetype s_srapath1s           = {true,SPR_SRA_W1_1,5,NULL,NULL,&s_srapath2};
statetype s_srapath2            = {true,SPR_SRA_W2_1,15,(statefunc)T_Path,NULL,&s_srapath3};
statetype s_srapath3            = {true,SPR_SRA_W3_1,20,(statefunc)T_Path,NULL,&s_srapath3s};
statetype s_srapath3s           = {true,SPR_SRA_W3_1,5,NULL,NULL,&s_srapath4};
statetype s_srapath4            = {true,SPR_SRA_W4_1,15,(statefunc)T_Path,NULL,&s_srapath1};

statetype s_srapain             = {2,SPR_SRA_PAIN_1,10,NULL,NULL,&s_srachase1};
statetype s_srapain1            = {2,SPR_SRA_PAIN_1,10,NULL,NULL,&s_srachase1};

statetype s_srashoot1           = {false,SPR_SRA_SHOOT1,15,NULL,NULL,&s_srashoot2};
statetype s_srashoot2           = {false,SPR_SRA_SHOOT2,10,NULL,NULL,&s_srashoot3};
statetype s_srashoot3           = {false,SPR_SRA_SHOOT3,10,NULL,NULL,&s_srashoot4};
statetype s_srashoot4           = {false,SPR_SRA_SHOOT4,15,NULL,NULL,&s_srashoot5};
statetype s_srashoot5           = {false,SPR_SRA_SHOOT5,10,NULL,NULL,&s_srashoot6};
statetype s_srashoot6           = {false,SPR_SRA_SHOOT6,10,NULL,NULL,&s_srashoot7};
statetype s_srashoot7           = {false,SPR_SRA_SHOOT7,15,NULL,NULL,&s_srashoot8};
statetype s_srashoot8           = {false,SPR_SRA_SHOOT8,10,NULL,(statefunc)T_Gasball,&s_srashoot9};
statetype s_srashoot9           = {false,SPR_SRA_SHOOT9,10,NULL,NULL,&s_srachase1};

statetype s_srachase1           = {true,SPR_SRA_W1_1,10,(statefunc)T_Chase,NULL,&s_srachase1s};
statetype s_srachase1s          = {true,SPR_SRA_W1_1,3,NULL,NULL,&s_srachase2};
statetype s_srachase2           = {true,SPR_SRA_W2_1,8,(statefunc)T_Chase,NULL,&s_srachase3};
statetype s_srachase3           = {true,SPR_SRA_W3_1,10,(statefunc)T_Chase,NULL,&s_srachase3s};
statetype s_srachase3s          = {true,SPR_SRA_W3_1,3,NULL,NULL,&s_srachase4};
statetype s_srachase4           = {true,SPR_SRA_W4_1,8,(statefunc)T_Chase,NULL,&s_srachase1};

statetype s_sradie1             = {false,SPR_SRA_DIE_1,9,NULL,(statefunc)A_DeathScream,&s_sradie2};
statetype s_sradie2             = {false,SPR_SRA_DIE_2,9,NULL,NULL,&s_sradie3};
statetype s_sradie3             = {false,SPR_SRA_DIE_3,9,NULL,NULL,&s_sradie4};
statetype s_sradie4             = {false,SPR_SRA_DIE_4,9,NULL,NULL,&s_sradie5};
statetype s_sradie5             = {false,SPR_SRA_DIE_5,9,NULL,NULL,&s_sradie6};
statetype s_sradie6             = {false,SPR_SRA_DIE_6,9,NULL,NULL,&s_sradie7};
statetype s_sradie7             = {false,SPR_SRA_DIE_7,9,NULL,NULL,&s_sradie8};
statetype s_sradie8             = {false,SPR_SRA_DIE_8,9,NULL,NULL,&s_sradie9};
statetype s_sradie9             = {false,SPR_SRA_DEAD,0,NULL,NULL,&s_sradie9};

//
// Soulless
//

extern  statetype s_soustand;

extern  statetype s_soupath1;
extern  statetype s_soupath1s;
extern  statetype s_soupath2;
extern  statetype s_soupath3;
extern  statetype s_soupath3s;
extern  statetype s_soupath4;

extern  statetype s_soupain;
extern  statetype s_soupain1;

extern  statetype s_soushoot1;
extern  statetype s_soushoot2;
extern  statetype s_soushoot3;
extern  statetype s_soushoot4;
extern  statetype s_soushoot5;

extern  statetype s_souchase1;
extern  statetype s_souchase1s;
extern  statetype s_souchase2;
extern  statetype s_souchase3;
extern  statetype s_souchase3s;
extern  statetype s_souchase4;

extern  statetype s_soudie1;
extern  statetype s_soudie2;
extern  statetype s_soudie3;
extern  statetype s_soudie4;
extern  statetype s_soudie5;
extern  statetype s_soudie6;
extern  statetype s_soudie7;

extern  statetype s_sousplatter1;
extern  statetype s_sousplatter1d;
extern  statetype s_sousplatter2;
extern  statetype s_sousplatter3;
extern  statetype s_sousplatter4;
extern  statetype s_sousplatter5;
extern  statetype s_sousplatter6;
extern  statetype s_sousplatter7;
extern  statetype s_sousplatter8;
extern  statetype s_sousplatter9;

statetype s_sousplatter1 = {false,SPR_SPLAT4_1,9,NULL,(statefunc)A_Slurpie,&s_sousplatter2};
statetype s_sousplatter2 = {false,SPR_SPLAT4_2,9,NULL,NULL,&s_sousplatter3};
statetype s_sousplatter3 = {false,SPR_SPLAT4_3,9,NULL,NULL,&s_sousplatter4};
statetype s_sousplatter4 = {false,SPR_SPLAT4_4,9,NULL,NULL,&s_sousplatter5};
statetype s_sousplatter5 = {false,SPR_SPLAT4_5,9,NULL,NULL,&s_sousplatter6};
statetype s_sousplatter6 = {false,SPR_SPLAT4_6,9,NULL,NULL,&s_sousplatter7};
statetype s_sousplatter7 = {false,SPR_SPLAT4_7,9,NULL,NULL,&s_sousplatter8};
statetype s_sousplatter8 = {false,SPR_SPLAT4_8,9,NULL,NULL,&s_sousplatter9};
statetype s_sousplatter9 = {false,SPR_SPLAT4_9,0,NULL,NULL,&s_sousplatter9};

statetype s_soustand            = {true,SPR_SOU_S_1,0,(statefunc)T_Stand,NULL,&s_soustand};

statetype s_soupath1            = {true,SPR_SOU_W1_1,20,(statefunc)T_Path,NULL,&s_soupath1s};
statetype s_soupath1s           = {true,SPR_SOU_W1_1,5,NULL,NULL,&s_soupath2};
statetype s_soupath2            = {true,SPR_SOU_W2_1,15,(statefunc)T_Path,NULL,&s_soupath3};
statetype s_soupath3            = {true,SPR_SOU_W3_1,20,(statefunc)T_Path,NULL,&s_soupath3s};
statetype s_soupath3s           = {true,SPR_SOU_W3_1,5,NULL,NULL,&s_soupath4};
statetype s_soupath4            = {true,SPR_SOU_W4_1,15,(statefunc)T_Path,NULL,&s_soupath1};

statetype s_soupain             = {2,SPR_SOU_PAIN_1,10,NULL,NULL,&s_souchase1};
statetype s_soupain1            = {2,SPR_SOU_PAIN_1,10,NULL,NULL,&s_souchase1};

statetype s_soushoot1           = {false,SPR_SOU_SHOOT1,20,NULL,NULL,&s_soushoot2};
statetype s_soushoot2           = {false,SPR_SOU_SHOOT2,20,NULL,NULL,&s_soushoot3};
statetype s_soushoot3           = {false,SPR_SOU_SHOOT3,10,NULL,(statefunc)T_Launch,&s_soushoot4};
statetype s_soushoot4           = {false,SPR_SOU_SHOOT4,10,NULL,NULL,&s_soushoot5};
statetype s_soushoot5           = {false,SPR_SOU_SHOOT5,10,NULL,NULL,&s_souchase1};

statetype s_souchase1           = {true,SPR_SOU_W1_1,10,(statefunc)T_Chase,NULL,&s_souchase1s};
statetype s_souchase1s          = {true,SPR_SOU_W1_1,3,NULL,NULL,&s_souchase2};
statetype s_souchase2           = {true,SPR_SOU_W2_1,8,(statefunc)T_Chase,NULL,&s_souchase3};
statetype s_souchase3           = {true,SPR_SOU_W3_1,10,(statefunc)T_Chase,NULL,&s_souchase3s};
statetype s_souchase3s          = {true,SPR_SOU_W3_1,3,NULL,NULL,&s_souchase4};
statetype s_souchase4           = {true,SPR_SOU_W4_1,8,(statefunc)T_Chase,NULL,&s_souchase1};

statetype s_soudie1             = {false,SPR_SOU_DIE_1,9,NULL,(statefunc)A_DeathScream,&s_soudie2};
statetype s_soudie2             = {false,SPR_SOU_DIE_2,9,NULL,NULL,&s_soudie3};
statetype s_soudie3             = {false,SPR_SOU_DIE_3,9,NULL,NULL,&s_soudie4};
statetype s_soudie4             = {false,SPR_SOU_DIE_4,9,NULL,NULL,&s_soudie5};
statetype s_soudie5             = {false,SPR_SOU_DIE_5,9,NULL,NULL,&s_soudie6};
statetype s_soudie6             = {false,SPR_SOU_DIE_6,9,NULL,NULL,&s_soudie7};
statetype s_soudie7             = {false,SPR_SOU_DEAD,0,NULL,NULL,&s_soudie7};

//
// Stealth Unit
//

extern  statetype s_sthstand;

extern  statetype s_sthpath1;
extern  statetype s_sthpath1s;
extern  statetype s_sthpath2;
extern  statetype s_sthpath3;
extern  statetype s_sthpath3s;
extern  statetype s_sthpath4;

extern  statetype s_sthpain;
extern  statetype s_sthpain1;

extern  statetype s_sthshoot1;
extern  statetype s_sthshoot2;
extern  statetype s_sthshoot3;
extern  statetype s_sthshoot4;
extern  statetype s_sthshoot5;
extern  statetype s_sthshoot6;
extern  statetype s_sthshoot7;
extern  statetype s_sthshoot8;
extern  statetype s_sthshoot9;

extern  statetype s_sthchase1;
extern  statetype s_sthchase1s;
extern  statetype s_sthchase2;
extern  statetype s_sthchase3;
extern  statetype s_sthchase3s;
extern  statetype s_sthchase4;

extern  statetype s_sthdie1;
extern  statetype s_sthdie2;
extern  statetype s_sthdie3;
extern  statetype s_sthdie4;
extern  statetype s_sthdie5;

extern  statetype s_sthsplatter1;
extern  statetype s_sthsplatter1d;
extern  statetype s_sthsplatter2;
extern  statetype s_sthsplatter3;
extern  statetype s_sthsplatter4;
extern  statetype s_sthsplatter5;
extern  statetype s_sthsplatter6;
extern  statetype s_sthsplatter7;
extern  statetype s_sthsplatter8;

extern  statetype s_sthburn1;
extern  statetype s_sthburn1d;
extern  statetype s_sthburn2;
extern  statetype s_sthburn3;
extern  statetype s_sthburn4;
extern  statetype s_sthburn5;
extern  statetype s_sthburn6;
extern  statetype s_sthburn7;
extern  statetype s_sthburn8;
extern  statetype s_sthburn9;
extern  statetype s_sthburn10;
extern  statetype s_sthburn11;
extern  statetype s_sthburn12;
extern  statetype s_sthburn13;
extern  statetype s_sthburn14;
extern  statetype s_sthburn15;
extern  statetype s_sthburn16;
extern  statetype s_sthburn17;
extern  statetype s_sthburn18;
extern  statetype s_sthburn19;
extern  statetype s_sthburn20;
extern  statetype s_sthburn21;
extern  statetype s_sthburn22;

statetype s_sthburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_sthburn2};
statetype s_sthburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_sthburn3};
statetype s_sthburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_sthburn4};
statetype s_sthburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_sthburn5};
statetype s_sthburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_sthburn6};
statetype s_sthburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_sthburn7};
statetype s_sthburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_sthburn8};
statetype s_sthburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_sthburn9};
statetype s_sthburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_sthburn10};
statetype s_sthburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_sthburn11};
statetype s_sthburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_sthburn12};
statetype s_sthburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_sthburn13};
statetype s_sthburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_sthburn14};
statetype s_sthburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_sthburn15};
statetype s_sthburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_sthburn16};
statetype s_sthburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_sthburn17};
statetype s_sthburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_sthburn18};
statetype s_sthburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_sthburn19};
statetype s_sthburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_sthburn20};
statetype s_sthburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_sthburn21};
statetype s_sthburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_sthburn22};
statetype s_sthburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_sthburn22};

statetype s_sthsplatter1 = {false,SPR_SPLAT3_1,9,NULL,(statefunc)A_Slurpie,&s_sthsplatter2};
statetype s_sthsplatter2 = {false,SPR_SPLAT3_2,9,NULL,NULL,&s_sthsplatter3};
statetype s_sthsplatter3 = {false,SPR_SPLAT3_3,9,NULL,NULL,&s_sthsplatter4};
statetype s_sthsplatter4 = {false,SPR_SPLAT3_4,9,NULL,NULL,&s_sthsplatter5};
statetype s_sthsplatter5 = {false,SPR_SPLAT3_5,9,NULL,NULL,&s_sthsplatter6};
statetype s_sthsplatter6 = {false,SPR_SPLAT3_6,9,NULL,NULL,&s_sthsplatter7};
statetype s_sthsplatter7 = {false,SPR_SPLAT3_7,9,NULL,NULL,&s_sthsplatter8};
statetype s_sthsplatter8 = {false,SPR_SPLAT3_8,0,NULL,NULL,&s_sthsplatter8};

statetype s_sthstand            = {true,SPR_STH_S_1,0,(statefunc)T_Stand,NULL,&s_sthstand};

statetype s_sthpath1            = {true,SPR_STH_W1_1,20,(statefunc)T_Path,NULL,&s_sthpath1s};
statetype s_sthpath1s           = {true,SPR_STH_W1_1,5,NULL,NULL,&s_sthpath2};
statetype s_sthpath2            = {true,SPR_STH_W2_1,15,(statefunc)T_Path,NULL,&s_sthpath3};
statetype s_sthpath3           = {true,SPR_STH_W3_1,20,(statefunc)T_Path,NULL,&s_sthpath3s};
statetype s_sthpath3s           = {true,SPR_STH_W3_1,5,NULL,NULL,&s_sthpath4};
statetype s_sthpath4            = {true,SPR_STH_W4_1,15,(statefunc)T_Path,NULL,&s_sthpath1};

statetype s_sthpain             = {2,SPR_STH_PAIN_1,10,NULL,NULL,&s_sthchase1};
statetype s_sthpain1            = {2,SPR_STH_PAIN_1,10,NULL,NULL,&s_sthchase1};

statetype s_sthshoot1           = {false,SPR_STH_SHOOT1,20,NULL,NULL,&s_sthshoot2};
statetype s_sthshoot2           = {false,SPR_STH_SHOOT2,20,NULL,(statefunc)T_Shoot,&s_sthshoot3};
statetype s_sthshoot3           = {false,SPR_STH_SHOOT3,10,NULL,NULL,&s_sthshoot4};
statetype s_sthshoot4           = {false,SPR_STH_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_sthshoot5};
statetype s_sthshoot5           = {false,SPR_STH_SHOOT3,10,NULL,NULL,&s_sthshoot6};
statetype s_sthshoot6           = {false,SPR_STH_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_sthshoot7};
statetype s_sthshoot7           = {false,SPR_STH_SHOOT3,10,NULL,NULL,&s_sthshoot8};
statetype s_sthshoot8           = {false,SPR_STH_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_sthshoot9};
statetype s_sthshoot9           = {false,SPR_STH_SHOOT3,10,NULL,NULL,&s_sthchase1};

statetype s_sthchase1           = {true,SPR_STH_W1_1,10,(statefunc)T_Chase,NULL,&s_sthchase1s};
statetype s_sthchase1s          = {true,SPR_STH_W1_1,3,NULL,NULL,&s_sthchase2};
statetype s_sthchase2           = {true,SPR_STH_W2_1,8,(statefunc)T_Chase,NULL,&s_sthchase3};
statetype s_sthchase3           = {true,SPR_STH_W3_1,10,(statefunc)T_Chase,NULL,&s_sthchase3s};
statetype s_sthchase3s          = {true,SPR_STH_W3_1,3,NULL,NULL,&s_sthchase4};
statetype s_sthchase4           = {true,SPR_STH_W4_1,8,(statefunc)T_Chase,NULL,&s_sthchase1};

statetype s_sthdie1             = {false,SPR_STH_DIE_1,7,NULL,(statefunc)A_DeathScream,&s_sthdie2};
statetype s_sthdie2             = {false,SPR_STH_DIE_2,7,NULL,NULL,&s_sthdie3};
statetype s_sthdie3             = {false,SPR_STH_DIE_3,7,NULL,NULL,&s_sthdie4};
statetype s_sthdie4             = {false,SPR_STH_DIE_4,7,NULL,NULL,&s_sthdie5};
statetype s_sthdie5             = {false,SPR_STH_DEAD,0,NULL,NULL,&s_sthdie5};

//
// Reaper
//

extern  statetype s_rprstand;

extern  statetype s_rprpath1;
extern  statetype s_rprpath1s;
extern  statetype s_rprpath2;
extern  statetype s_rprpath3;
extern  statetype s_rprpath3s;
extern  statetype s_rprpath4;

extern  statetype s_rprpain;
extern  statetype s_rprpain1;

extern  statetype s_rprshoot1;
extern  statetype s_rprshoot2;
extern  statetype s_rprshoot3;
extern  statetype s_rprshoot4;

extern  statetype s_rprchase1;
extern  statetype s_rprchase1s;
extern  statetype s_rprchase2;
extern  statetype s_rprchase3;
extern  statetype s_rprchase3s;
extern  statetype s_rprchase4;

extern  statetype s_rprdie1;
extern  statetype s_rprdie2;
extern  statetype s_rprdie3;
extern  statetype s_rprdie4;
extern  statetype s_rprdie5;

extern  statetype s_rprsplatter1;
extern  statetype s_rprsplatter1d;
extern  statetype s_rprsplatter2;
extern  statetype s_rprsplatter3;
extern  statetype s_rprsplatter4;
extern  statetype s_rprsplatter5;
extern  statetype s_rprsplatter6;
extern  statetype s_rprsplatter7;
extern  statetype s_rprsplatter8;

statetype s_rprsplatter1 = {false,SPR_SPLAT1_1,9,NULL,(statefunc)A_Slurpie,&s_rprsplatter2};
statetype s_rprsplatter2 = {false,SPR_SPLAT1_2,9,NULL,NULL,&s_rprsplatter3};
statetype s_rprsplatter3 = {false,SPR_SPLAT1_3,9,NULL,NULL,&s_rprsplatter4};
statetype s_rprsplatter4 = {false,SPR_SPLAT1_4,9,NULL,NULL,&s_rprsplatter5};
statetype s_rprsplatter5 = {false,SPR_SPLAT1_5,9,NULL,NULL,&s_rprsplatter6};
statetype s_rprsplatter6 = {false,SPR_SPLAT1_6,9,NULL,NULL,&s_rprsplatter7};
statetype s_rprsplatter7 = {false,SPR_SPLAT1_7,9,NULL,NULL,&s_rprsplatter8};
statetype s_rprsplatter8 = {false,SPR_SPLAT1_8,0,NULL,NULL,&s_rprsplatter8};

statetype s_rprstand            = {true,SPR_RPR_S_1,0,(statefunc)T_Stand,NULL,&s_rprstand};

statetype s_rprpath1            = {true,SPR_RPR_W1_1,20,(statefunc)T_Path,NULL,&s_rprpath1s};
statetype s_rprpath1s           = {true,SPR_RPR_W1_1,5,NULL,NULL,&s_rprpath2};
statetype s_rprpath2            = {true,SPR_RPR_W2_1,15,(statefunc)T_Path,NULL,&s_rprpath3};
statetype s_rprpath3            = {true,SPR_RPR_W3_1,20,(statefunc)T_Path,NULL,&s_rprpath3s};
statetype s_rprpath3s           = {true,SPR_RPR_W3_1,5,NULL,NULL,&s_rprpath4};
statetype s_rprpath4            = {true,SPR_RPR_W4_1,15,(statefunc)T_Path,NULL,&s_rprpath1};

statetype s_rprpain             = {2,SPR_RPR_PAIN_1,10,NULL,NULL,&s_rprchase1};
statetype s_rprpain1            = {2,SPR_RPR_PAIN_1,10,NULL,NULL,&s_rprchase1};

statetype s_rprshoot1           = {false,SPR_RPR_SHOOT1,6,NULL,NULL,&s_rprshoot2};
statetype s_rprshoot2           = {false,SPR_RPR_SHOOT2,20,NULL,(statefunc)T_Shadowball2,&s_rprshoot3};
statetype s_rprshoot3           = {false,SPR_RPR_SHOOT3,10,NULL,NULL,&s_rprshoot4};
statetype s_rprshoot4           = {false,SPR_RPR_SHOOT4,20,NULL,NULL,&s_rprchase1};

statetype s_rprchase1           = {true,SPR_RPR_W1_1,10,(statefunc)T_Chase,NULL,&s_rprchase1s};
statetype s_rprchase1s          = {true,SPR_RPR_W1_1,3,NULL,NULL,&s_rprchase2};
statetype s_rprchase2           = {true,SPR_RPR_W2_1,8,(statefunc)T_Chase,NULL,&s_rprchase3};
statetype s_rprchase3           = {true,SPR_RPR_W3_1,10,(statefunc)T_Chase,NULL,&s_rprchase3s};
statetype s_rprchase3s          = {true,SPR_RPR_W3_1,3,NULL,NULL,&s_rprchase4};
statetype s_rprchase4           = {true,SPR_RPR_W4_1,8,(statefunc)T_Chase,NULL,&s_rprchase1};

statetype s_rprdie1             = {false,SPR_RPR_DIE_1,7,NULL,(statefunc)A_DeathScream,&s_rprdie2};
statetype s_rprdie2             = {false,SPR_RPR_DIE_2,7,NULL,NULL,&s_rprdie3};
statetype s_rprdie3             = {false,SPR_RPR_DIE_3,7,NULL,NULL,&s_rprdie4};
statetype s_rprdie4             = {false,SPR_RPR_DIE_4,7,NULL,NULL,&s_rprdie5};
statetype s_rprdie5             = {false,SPR_RPR_DEAD,0,NULL,NULL,&s_rprdie5};

//
// Rocket Unit
//

extern statetype s_rktstand;

extern statetype s_rktpath1;
extern statetype s_rktpath1s;
extern statetype s_rktpath2;
extern statetype s_rktpath3;
extern statetype s_rktpath3s;
extern statetype s_rktpath4;

extern statetype s_rktpain;
extern statetype s_rktpain1;

extern statetype s_rktshoot1;
extern statetype s_rktshoot2;
extern statetype s_rktshoot3;
extern statetype s_rktshoot4;

extern statetype s_rktchase1;
extern statetype s_rktchase1s;
extern statetype s_rktchase2;
extern statetype s_rktchase3;
extern statetype s_rktchase3s;
extern statetype s_rktchase4;

extern statetype s_rktdie1;
extern statetype s_rktdie1d;
extern statetype s_rktdie2;
extern statetype s_rktdie3;
extern statetype s_rktdie4;
extern statetype s_rktdie5;
extern statetype s_rktdie6;
extern statetype s_rktdie7;

extern  statetype s_rktsplatter1;
extern  statetype s_rktsplatter1d;
extern  statetype s_rktsplatter2;
extern  statetype s_rktsplatter3;
extern  statetype s_rktsplatter4;
extern  statetype s_rktsplatter5;
extern  statetype s_rktsplatter6;
extern  statetype s_rktsplatter7;
extern  statetype s_rktsplatter8;
extern  statetype s_rktsplatter9;

statetype s_rktsplatter1 = {false,SPR_SPLAT2_1,9,NULL,(statefunc)A_Slurpie,&s_rktsplatter2};
statetype s_rktsplatter2 = {false,SPR_SPLAT2_2,9,NULL,NULL,&s_rktsplatter3};
statetype s_rktsplatter3 = {false,SPR_SPLAT2_3,9,NULL,NULL,&s_rktsplatter4};
statetype s_rktsplatter4 = {false,SPR_SPLAT2_4,9,NULL,NULL,&s_rktsplatter5};
statetype s_rktsplatter5 = {false,SPR_SPLAT2_5,9,NULL,NULL,&s_rktsplatter6};
statetype s_rktsplatter6 = {false,SPR_SPLAT2_6,9,NULL,NULL,&s_rktsplatter7};
statetype s_rktsplatter7 = {false,SPR_SPLAT2_7,9,NULL,NULL,&s_rktsplatter8};
statetype s_rktsplatter8 = {false,SPR_SPLAT2_8,9,NULL,NULL,&s_rktsplatter9};
statetype s_rktsplatter9 = {false,SPR_SPLAT2_9,0,NULL,NULL,&s_rktsplatter9};

statetype s_rktstand = {true,SPR_RKT_S_1,0,(statefunc)T_Stand,NULL,&s_rktstand};

statetype s_rktpath1  = {true,SPR_RKT_W1_1,20,(statefunc)T_Path,NULL,&s_rktpath1s};
statetype s_rktpath1s  = {true,SPR_RKT_W1_1,5,NULL,NULL,&s_rktpath2};
statetype s_rktpath2  = {true,SPR_RKT_W2_1,15,(statefunc)T_Path,NULL,&s_rktpath3};
statetype s_rktpath3  = {true,SPR_RKT_W3_1,20,(statefunc)T_Path,NULL,&s_rktpath3s};
statetype s_rktpath3s  = {true,SPR_RKT_W3_1,5,NULL,NULL,&s_rktpath4};
statetype s_rktpath4  = {true,SPR_RKT_W4_1,15,(statefunc)T_Path,NULL,&s_rktpath1};

statetype s_rktpain  = {2,SPR_RKT_PAIN_1,10,NULL,NULL,&s_rktchase1};
statetype s_rktpain1  = {2,SPR_RKT_PAIN_1,10,NULL,NULL,&s_rktchase1};

statetype s_rktshoot1  = {false,SPR_RKT_SHOOT1,20,NULL,NULL,&s_rktshoot2};
statetype s_rktshoot2  = {false,SPR_RKT_SHOOT2,20,NULL,(statefunc)T_GiftThrow,&s_rktshoot3};
statetype s_rktshoot3  = {false,SPR_RKT_SHOOT3,20,NULL,NULL,&s_rktchase1};

statetype s_rktchase1  = {true,SPR_RKT_W1_1,10,(statefunc)T_Chase,(statefunc)A_MechaSound,&s_rktchase1s};
statetype s_rktchase1s  = {true,SPR_RKT_W1_1,3,NULL,NULL,&s_rktchase2};
statetype s_rktchase2  = {true,SPR_RKT_W2_1,8,(statefunc)T_Chase,NULL,&s_rktchase3};
statetype s_rktchase3  = {true,SPR_RKT_W3_1,10,(statefunc)T_Chase,(statefunc)A_MechaSound,&s_rktchase3s};
statetype s_rktchase3s  = {true,SPR_RKT_W3_1,3,NULL,NULL,&s_rktchase4};
statetype s_rktchase4  = {true,SPR_RKT_W4_1,8,(statefunc)T_Chase,NULL,&s_rktchase1};

statetype s_rktdie1 ={false,SPR_RKT_DIE_1,15,NULL,(statefunc)A_DeathScream,&s_rktdie2};
statetype s_rktdie2 = {false,SPR_RKT_DIE_2,15,NULL,NULL,&s_rktdie3};
statetype s_rktdie3 = {false,SPR_RKT_DIE_3,15,NULL,NULL,&s_rktdie4};
statetype s_rktdie4 = {false,SPR_RKT_DIE_4,15,NULL,NULL,&s_rktdie5};
statetype s_rktdie5 = {false,SPR_RKT_DIE_5,15,NULL,NULL,&s_rktdie6};
statetype s_rktdie6 = {false,SPR_RKT_DIE_6,15,NULL,NULL,&s_rktdie7};
statetype s_rktdie7 = {false,SPR_RKT_DEAD,0,NULL,NULL,&s_rktdie7};



//
// Shadow hunter
//

extern  statetype s_shastand;

extern  statetype s_shapath1;
extern  statetype s_shapath1s;
extern  statetype s_shapath2;
extern  statetype s_shapath3;
extern  statetype s_shapath3s;
extern  statetype s_shapath4;

extern  statetype s_shapain;
extern  statetype s_shapain1;

extern  statetype s_shashoot1;
extern  statetype s_shashoot2;
extern  statetype s_shashoot3;
extern  statetype s_shashoot4;

extern  statetype s_shaball1;
extern  statetype s_shaball2;
extern  statetype s_shaball3;
extern  statetype s_shaball4;

extern  statetype s_shachase1;
extern  statetype s_shachase1s;
extern  statetype s_shachase2;
extern  statetype s_shachase3;
extern  statetype s_shachase3s;
extern  statetype s_shachase4;

extern  statetype s_shadie1;
extern  statetype s_shadie2;
extern  statetype s_shadie3;
extern  statetype s_shadie4;
extern  statetype s_shadie5;

extern  statetype s_shasplatter1;
extern  statetype s_shasplatter1d;
extern  statetype s_shasplatter2;
extern  statetype s_shasplatter3;
extern  statetype s_shasplatter4;
extern  statetype s_shasplatter5;
extern  statetype s_shasplatter6;
extern  statetype s_shasplatter7;
extern  statetype s_shasplatter8;

statetype s_shasplatter1 = {false,SPR_SPLAT1_1,9,NULL,(statefunc)A_Slurpie,&s_shasplatter2};
statetype s_shasplatter2 = {false,SPR_SPLAT1_2,9,NULL,NULL,&s_shasplatter3};
statetype s_shasplatter3 = {false,SPR_SPLAT1_3,9,NULL,NULL,&s_shasplatter4};
statetype s_shasplatter4 = {false,SPR_SPLAT1_4,9,NULL,NULL,&s_shasplatter5};
statetype s_shasplatter5 = {false,SPR_SPLAT1_5,9,NULL,NULL,&s_shasplatter6};
statetype s_shasplatter6 = {false,SPR_SPLAT1_6,9,NULL,NULL,&s_shasplatter7};
statetype s_shasplatter7 = {false,SPR_SPLAT1_7,9,NULL,NULL,&s_shasplatter8};
statetype s_shasplatter8 = {false,SPR_SPLAT1_8,0,NULL,NULL,&s_shasplatter8};

statetype s_shastand            = {true,SPR_SHA_S_1,0,(statefunc)T_Stand,NULL,&s_shastand};

statetype s_shapath1            = {true,SPR_SHA_W1_1,20,(statefunc)T_Path,NULL,&s_shapath1s};
statetype s_shapath1s           = {true,SPR_SHA_W1_1,5,NULL,NULL,&s_shapath2};
statetype s_shapath2            = {true,SPR_SHA_W2_1,15,(statefunc)T_Path,NULL,&s_shapath3};
statetype s_shapath3            = {true,SPR_SHA_W3_1,20,(statefunc)T_Path,NULL,&s_shapath3s};
statetype s_shapath3s           = {true,SPR_SHA_W3_1,5,NULL,NULL,&s_shapath4};
statetype s_shapath4            = {true,SPR_SHA_W4_1,15,(statefunc)T_Path,NULL,&s_shapath1};

statetype s_shapain             = {2,SPR_SHA_PAIN_1,10,NULL,NULL,&s_shachase1};
statetype s_shapain1            = {2,SPR_SHA_PAIN_1,10,NULL,NULL,&s_shachase1};

statetype s_shashoot1           = {false,SPR_SHA_SHOOT1,6,NULL,NULL,&s_shashoot2};
statetype s_shashoot2           = {false,SPR_SHA_SHOOT2,20,NULL,(statefunc)T_Shadowball2,&s_shashoot3};
statetype s_shashoot3           = {false,SPR_SHA_SHOOT3,10,NULL,NULL,&s_shashoot4};
statetype s_shashoot4           = {false,SPR_SHA_SHOOT4,20,NULL,NULL,&s_shachase1};

statetype s_shaball1           = {false,SPR_SHA_2SHOOT1,6,NULL,NULL,&s_shaball2};
statetype s_shaball2           = {false,SPR_SHA_2SHOOT2,20,NULL,(statefunc)T_Shadowball3,&s_shaball3};
statetype s_shaball3           = {false,SPR_SHA_2SHOOT3,10,NULL,NULL,&s_shaball4};
statetype s_shaball4           = {false,SPR_SHA_2SHOOT4,20,NULL,NULL,&s_shachase1};

statetype s_shachase1           = {true,SPR_SHA_W1_1,10,(statefunc)T_Chase,NULL,&s_shachase1s};
statetype s_shachase1s          = {true,SPR_SHA_W1_1,3,(statefunc)T_HunterChase,NULL,&s_shachase2};
statetype s_shachase2           = {true,SPR_SHA_W2_1,8,(statefunc)T_Chase,NULL,&s_shachase3};
statetype s_shachase3           = {true,SPR_SHA_W3_1,10,(statefunc)T_HunterChase,NULL,&s_shachase3s};
statetype s_shachase3s          = {true,SPR_SHA_W3_1,3,(statefunc)T_Chase,NULL,&s_shachase4};
statetype s_shachase4           = {true,SPR_SHA_W4_1,8,(statefunc)T_HunterChase,NULL,&s_shachase1};

statetype s_shadie1             = {false,SPR_SHA_DIE_1,7,NULL,(statefunc)A_DeathScream,&s_shadie2};
statetype s_shadie2             = {false,SPR_SHA_DIE_2,7,NULL,NULL,&s_shadie3};
statetype s_shadie3             = {false,SPR_SHA_DIE_3,7,NULL,NULL,&s_shadie4};
statetype s_shadie4             = {false,SPR_SHA_DIE_4,7,NULL,NULL,&s_shadie5};
statetype s_shadie5             = {false,SPR_SHA_DEAD,0,NULL,NULL,&s_shadie5};

//
// Sniper
//

extern statetype s_snistand;

extern statetype s_snipath1;
extern statetype s_snipath1s;
extern statetype s_snipath2;
extern statetype s_snipath3;
extern statetype s_snipath3s;
extern statetype s_snipath4;

extern statetype s_snipain;
extern statetype s_snipain1;

extern statetype s_snishoot1;
extern statetype s_snishoot2;
extern statetype s_snishoot3;

extern statetype s_snichase1;
extern statetype s_snichase1s;
extern statetype s_snichase2;
extern statetype s_snichase3;
extern statetype s_snichase3s;
extern statetype s_snichase4;

extern statetype s_snidie1;
extern statetype s_snidie1d;
extern statetype s_snidie2;
extern statetype s_snidie3;
extern statetype s_snidie4;
extern statetype s_snidie5;

extern  statetype s_snisplatter1;
extern  statetype s_snisplatter1d;
extern  statetype s_snisplatter2;
extern  statetype s_snisplatter3;
extern  statetype s_snisplatter4;
extern  statetype s_snisplatter5;
extern  statetype s_snisplatter6;
extern  statetype s_snisplatter7;
extern  statetype s_snisplatter8;

extern  statetype s_sniburn1;
extern  statetype s_sniburn1d;
extern  statetype s_sniburn2;
extern  statetype s_sniburn3;
extern  statetype s_sniburn4;
extern  statetype s_sniburn5;
extern  statetype s_sniburn6;
extern  statetype s_sniburn7;
extern  statetype s_sniburn8;
extern  statetype s_sniburn9;
extern  statetype s_sniburn10;
extern  statetype s_sniburn11;
extern  statetype s_sniburn12;
extern  statetype s_sniburn13;
extern  statetype s_sniburn14;
extern  statetype s_sniburn15;
extern  statetype s_sniburn16;
extern  statetype s_sniburn17;
extern  statetype s_sniburn18;
extern  statetype s_sniburn19;
extern  statetype s_sniburn20;
extern  statetype s_sniburn21;
extern  statetype s_sniburn22;

statetype s_sniburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_sniburn2};
statetype s_sniburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_sniburn3};
statetype s_sniburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_sniburn4};
statetype s_sniburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_sniburn5};
statetype s_sniburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_sniburn6};
statetype s_sniburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_sniburn7};
statetype s_sniburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_sniburn8};
statetype s_sniburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_sniburn9};
statetype s_sniburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_sniburn10};
statetype s_sniburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_sniburn11};
statetype s_sniburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_sniburn12};
statetype s_sniburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_sniburn13};
statetype s_sniburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_sniburn14};
statetype s_sniburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_sniburn15};
statetype s_sniburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_sniburn16};
statetype s_sniburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_sniburn17};
statetype s_sniburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_sniburn18};
statetype s_sniburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_sniburn19};
statetype s_sniburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_sniburn20};
statetype s_sniburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_sniburn21};
statetype s_sniburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_sniburn22};
statetype s_sniburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_sniburn22};

statetype s_snisplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_snisplatter2};
statetype s_snisplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_snisplatter3};
statetype s_snisplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_snisplatter4};
statetype s_snisplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_snisplatter5};
statetype s_snisplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_snisplatter6};
statetype s_snisplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_snisplatter7};
statetype s_snisplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_snisplatter8};
statetype s_snisplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_snisplatter8};

statetype s_snistand = {true,SPR_SNI_S_1,0,(statefunc)T_Stand,NULL,&s_snistand};

statetype s_snipath1  = {true,SPR_SNI_W1_1,20,(statefunc)T_Path,NULL,&s_snipath1s};
statetype s_snipath1s  = {true,SPR_SNI_W1_1,5,NULL,NULL,&s_snipath2};
statetype s_snipath2  = {true,SPR_SNI_W2_1,15,(statefunc)T_Path,NULL,&s_snipath3};
statetype s_snipath3  = {true,SPR_SNI_W3_1,20,(statefunc)T_Path,NULL,&s_snipath3s};
statetype s_snipath3s  = {true,SPR_SNI_W3_1,5,NULL,NULL,&s_snipath4};
statetype s_snipath4  = {true,SPR_SNI_W4_1,15,(statefunc)T_Path,NULL,&s_snipath1};

statetype s_snipain  = {2,SPR_SNI_PAIN_1,10,NULL,NULL,&s_snichase1};
statetype s_snipain1 = {2,SPR_SNI_PAIN_1,10,NULL,NULL,&s_snichase1};

statetype s_snishoot1  = {false,SPR_SNI_SHOOT1,20,NULL,NULL,&s_snishoot2};
statetype s_snishoot2  = {false,SPR_SNI_SHOOT1,20,NULL,(statefunc)T_Shoot,&s_snishoot3};
statetype s_snishoot3  = {false,SPR_SNI_SHOOT2,20,NULL,NULL,&s_snichase1};

statetype s_snichase1  = {true,SPR_SNI_W1_1,10,(statefunc)T_Chase,NULL,&s_snichase1s};
statetype s_snichase1s  = {true,SPR_SNI_W1_1,3,NULL,NULL,&s_snichase2};
statetype s_snichase2  = {true,SPR_SNI_W2_1,8,(statefunc)T_Chase,NULL,&s_snichase3};
statetype s_snichase3  = {true,SPR_SNI_W3_1,10,(statefunc)T_Chase,NULL,&s_snichase3s};
statetype s_snichase3s  = {true,SPR_SNI_W3_1,3,NULL,NULL,&s_snichase4};
statetype s_snichase4  = {true,SPR_SNI_W4_1,8,(statefunc)T_Chase,NULL,&s_snichase1};

statetype s_snidie1 ={false,SPR_SNI_DIE_1,9,NULL,(statefunc)A_DeathScream,&s_snidie2};
statetype s_snidie2 = {false,SPR_SNI_DIE_2,9,NULL,NULL,&s_snidie3};
statetype s_snidie3 = {false,SPR_SNI_DIE_3,9,NULL,NULL,&s_snidie4};
statetype s_snidie4 = {false,SPR_SNI_DIE_4,9,NULL,NULL,&s_snidie5};
statetype s_snidie5 = {false,SPR_SNI_DEAD,0,NULL,NULL,&s_snidie5};



//
// Cult
//

extern statetype s_culstand;

extern statetype s_culpath1;
extern statetype s_culpath1s;
extern statetype s_culpath2;
extern statetype s_culpath3;
extern statetype s_culpath3s;
extern statetype s_culpath4;

extern statetype s_culpain;
extern statetype s_culpain1;

extern statetype s_culshoot1;
extern statetype s_culshoot2;
extern statetype s_culshoot3;


extern statetype s_culchase1;
extern statetype s_culchase1s;
extern statetype s_culchase2;
extern statetype s_culchase3;
extern statetype s_culchase3s;
extern statetype s_culchase4;

extern statetype s_culdie1;
extern statetype s_culdie1d;
extern statetype s_culdie2;
extern statetype s_culdie3;
extern statetype s_culdie4;
extern statetype s_culdie5;

extern  statetype s_culsplatter1;
extern  statetype s_culsplatter1d;
extern  statetype s_culsplatter2;
extern  statetype s_culsplatter3;
extern  statetype s_culsplatter4;
extern  statetype s_culsplatter5;
extern  statetype s_culsplatter6;
extern  statetype s_culsplatter7;
extern  statetype s_culsplatter8;

extern  statetype s_culburn1;
extern  statetype s_culburn1d;
extern  statetype s_culburn2;
extern  statetype s_culburn3;
extern  statetype s_culburn4;
extern  statetype s_culburn5;
extern  statetype s_culburn6;
extern  statetype s_culburn7;
extern  statetype s_culburn8;
extern  statetype s_culburn9;
extern  statetype s_culburn10;
extern  statetype s_culburn11;
extern  statetype s_culburn12;
extern  statetype s_culburn13;
extern  statetype s_culburn14;
extern  statetype s_culburn15;
extern  statetype s_culburn16;
extern  statetype s_culburn17;
extern  statetype s_culburn18;
extern  statetype s_culburn19;
extern  statetype s_culburn20;
extern  statetype s_culburn21;
extern  statetype s_culburn22;

statetype s_culburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_culburn2};
statetype s_culburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_culburn3};
statetype s_culburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_culburn4};
statetype s_culburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_culburn5};
statetype s_culburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_culburn6};
statetype s_culburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_culburn7};
statetype s_culburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_culburn8};
statetype s_culburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_culburn9};
statetype s_culburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_culburn10};
statetype s_culburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_culburn11};
statetype s_culburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_culburn12};
statetype s_culburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_culburn13};
statetype s_culburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_culburn14};
statetype s_culburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_culburn15};
statetype s_culburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_culburn16};
statetype s_culburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_culburn17};
statetype s_culburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_culburn18};
statetype s_culburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_culburn19};
statetype s_culburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_culburn20};
statetype s_culburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_culburn21};
statetype s_culburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_culburn22};
statetype s_culburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_culburn22};

statetype s_culsplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_culsplatter2};
statetype s_culsplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_culsplatter3};
statetype s_culsplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_culsplatter4};
statetype s_culsplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_culsplatter5};
statetype s_culsplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_culsplatter6};
statetype s_culsplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_culsplatter7};
statetype s_culsplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_culsplatter8};
statetype s_culsplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_culsplatter8};

statetype s_culstand = {true,SPR_CUL_S_1,0,(statefunc)T_Stand,NULL,&s_culstand};

statetype s_culpath1  = {true,SPR_CUL_W1_1,20,(statefunc)T_Path,NULL,&s_culpath1s};
statetype s_culpath1s  = {true,SPR_CUL_W1_1,5,NULL,NULL,&s_culpath2};
statetype s_culpath2  = {true,SPR_CUL_W2_1,15,(statefunc)T_Path,NULL,&s_culpath3};
statetype s_culpath3  = {true,SPR_CUL_W3_1,20,(statefunc)T_Path,NULL,&s_culpath3s};
statetype s_culpath3s  = {true,SPR_CUL_W3_1,5,NULL,NULL,&s_culpath4};
statetype s_culpath4  = {true,SPR_CUL_W4_1,15,(statefunc)T_Path,NULL,&s_culpath1};

statetype s_culpain  = {2,SPR_CUL_PAIN_1,10,NULL,NULL,&s_culchase1};
statetype s_culpain1 = {2,SPR_CUL_PAIN_1,10,NULL,NULL,&s_culchase1};

statetype s_culshoot1  = {false,SPR_CUL_SHOOT1,10,NULL,NULL,&s_culshoot2};
statetype s_culshoot2  = {false,SPR_CUL_SHOOT1,10,NULL,(statefunc)T_Shoot,&s_culshoot3};
statetype s_culshoot3  = {false,SPR_CUL_SHOOT2,10,NULL,NULL,&s_culchase1};

statetype s_culchase1  = {true,SPR_CUL_W1_1,10,(statefunc)T_Chase,NULL,&s_culchase1s};
statetype s_culchase1s  = {true,SPR_CUL_W1_1,3,NULL,NULL,&s_culchase2};
statetype s_culchase2  = {true,SPR_CUL_W2_1,8,(statefunc)T_Chase,NULL,&s_culchase3};
statetype s_culchase3  = {true,SPR_CUL_W3_1,10,(statefunc)T_Chase,NULL,&s_culchase3s};
statetype s_culchase3s  = {true,SPR_CUL_W3_1,3,NULL,NULL,&s_culchase4};
statetype s_culchase4  = {true,SPR_CUL_W4_1,8,(statefunc)T_Chase,NULL,&s_culchase1};

statetype s_culdie1 ={false,SPR_CUL_DIE_1,9,NULL,(statefunc)A_DeathScream,&s_culdie2};
statetype s_culdie2 = {false,SPR_CUL_DIE_2,9,NULL,NULL,&s_culdie3};
statetype s_culdie3 = {false,SPR_CUL_DIE_3,9,NULL,NULL,&s_culdie4};
statetype s_culdie4 = {false,SPR_CUL_DIE_4,9,NULL,NULL,&s_culdie5};
statetype s_culdie5 = {false,SPR_CUL_DEAD,0,NULL,NULL,&s_culdie5};

//
// Shotgunner
//

extern statetype s_shtstand;

extern statetype s_shtpath1;
extern statetype s_shtpath1s;
extern statetype s_shtpath2;
extern statetype s_shtpath3;
extern statetype s_shtpath3s;
extern statetype s_shtpath4;

extern statetype s_shtpain;
extern statetype s_shtpain1;

extern statetype s_shtshoot1;
extern statetype s_shtshoot2;
extern statetype s_shtshoot3;

extern statetype s_shtchase1;
extern statetype s_shtchase1s;
extern statetype s_shtchase2;
extern statetype s_shtchase3;
extern statetype s_shtchase3s;
extern statetype s_shtchase4;

extern statetype s_shtdie1;
extern statetype s_shtdie1d;
extern statetype s_shtdie2;
extern statetype s_shtdie3;
extern statetype s_shtdie4;
extern statetype s_shtdie5;
extern statetype s_shtdie6;
extern statetype s_shtdie7;
extern statetype s_shtdie8;

extern  statetype s_shtsplatter1;
extern  statetype s_shtsplatter1d;
extern  statetype s_shtsplatter2;
extern  statetype s_shtsplatter3;
extern  statetype s_shtsplatter4;
extern  statetype s_shtsplatter5;
extern  statetype s_shtsplatter6;
extern  statetype s_shtsplatter7;
extern  statetype s_shtsplatter8;

extern  statetype s_shtburn1;
extern  statetype s_shtburn1d;
extern  statetype s_shtburn2;
extern  statetype s_shtburn3;
extern  statetype s_shtburn4;
extern  statetype s_shtburn5;
extern  statetype s_shtburn6;
extern  statetype s_shtburn7;
extern  statetype s_shtburn8;
extern  statetype s_shtburn9;
extern  statetype s_shtburn10;
extern  statetype s_shtburn11;
extern  statetype s_shtburn12;
extern  statetype s_shtburn13;
extern  statetype s_shtburn14;
extern  statetype s_shtburn15;
extern  statetype s_shtburn16;
extern  statetype s_shtburn17;
extern  statetype s_shtburn18;
extern  statetype s_shtburn19;
extern  statetype s_shtburn20;
extern  statetype s_shtburn21;
extern  statetype s_shtburn22;

statetype s_shtburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_shtburn2};
statetype s_shtburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_shtburn3};
statetype s_shtburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_shtburn4};
statetype s_shtburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_shtburn5};
statetype s_shtburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_shtburn6};
statetype s_shtburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_shtburn7};
statetype s_shtburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_shtburn8};
statetype s_shtburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_shtburn9};
statetype s_shtburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_shtburn10};
statetype s_shtburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_shtburn11};
statetype s_shtburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_shtburn12};
statetype s_shtburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_shtburn13};
statetype s_shtburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_shtburn14};
statetype s_shtburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_shtburn15};
statetype s_shtburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_shtburn16};
statetype s_shtburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_shtburn17};
statetype s_shtburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_shtburn18};
statetype s_shtburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_shtburn19};
statetype s_shtburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_shtburn20};
statetype s_shtburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_shtburn21};
statetype s_shtburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_shtburn22};
statetype s_shtburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_shtburn22};

statetype s_shtsplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_shtsplatter2};
statetype s_shtsplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_shtsplatter3};
statetype s_shtsplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_shtsplatter4};
statetype s_shtsplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_shtsplatter5};
statetype s_shtsplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_shtsplatter6};
statetype s_shtsplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_shtsplatter7};
statetype s_shtsplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_shtsplatter8};
statetype s_shtsplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_shtsplatter8};


statetype s_shtstand = {true,SPR_SHT_S_1,0,(statefunc)T_Stand,NULL,&s_shtstand};

statetype s_shtpath1  = {true,SPR_SHT_W1_1,20,(statefunc)T_Path,NULL,&s_shtpath1s};
statetype s_shtpath1s  = {true,SPR_SHT_W1_1,5,NULL,NULL,&s_shtpath2};
statetype s_shtpath2  = {true,SPR_SHT_W2_1,15,(statefunc)T_Path,NULL,&s_shtpath3};
statetype s_shtpath3  = {true,SPR_SHT_W3_1,20,(statefunc)T_Path,NULL,&s_shtpath3s};
statetype s_shtpath3s  = {true,SPR_SHT_W3_1,5,NULL,NULL,&s_shtpath4};
statetype s_shtpath4  = {true,SPR_SHT_W4_1,15,(statefunc)T_Path,NULL,&s_shtpath1};

statetype s_shtpain  = {2,SPR_SHT_PAIN_1,10,NULL,NULL,&s_shtchase1};
statetype s_shtpain1 = {2,SPR_SHT_PAIN_1,10,NULL,NULL,&s_shtchase1};

statetype s_shtshoot1  = {false,SPR_SHT_SHOOT1,20,NULL,NULL,&s_shtshoot2};
statetype s_shtshoot2  = {false,SPR_SHT_SHOOT1,20,NULL,(statefunc)T_Shoot,&s_shtshoot3};
statetype s_shtshoot3  = {false,SPR_SHT_SHOOT2,20,NULL,NULL,&s_shtchase1};

statetype s_shtchase1  = {true,SPR_SHT_W1_1,10,(statefunc)T_Chase,NULL,&s_shtchase1s};
statetype s_shtchase1s  = {true,SPR_SHT_W1_1,3,NULL,NULL,&s_shtchase2};
statetype s_shtchase2  = {true,SPR_SHT_W2_1,8,(statefunc)T_Chase,NULL,&s_shtchase3};
statetype s_shtchase3  = {true,SPR_SHT_W3_1,10,(statefunc)T_Chase,NULL,&s_shtchase3s};
statetype s_shtchase3s  = {true,SPR_SHT_W3_1,3,NULL,NULL,&s_shtchase4};
statetype s_shtchase4  = {true,SPR_SHT_W4_1,8,(statefunc)T_Chase,NULL,&s_shtchase1};

statetype s_shtdie1 ={false,SPR_SHT_DIE_1,9,NULL,(statefunc)A_DeathScream,&s_shtdie2};
statetype s_shtdie2 = {false,SPR_SHT_DIE_2,9,NULL,NULL,&s_shtdie3};
statetype s_shtdie3 = {false,SPR_SHT_DIE_3,9,NULL,NULL,&s_shtdie4};
statetype s_shtdie4 = {false,SPR_SHT_DIE_4,9,NULL,NULL,&s_shtdie5};
statetype s_shtdie5 = {false,SPR_SHT_DIE_5,9,NULL,NULL,&s_shtdie6};
statetype s_shtdie6 = {false,SPR_SHT_DIE_6,9,NULL,NULL,&s_shtdie7};
statetype s_shtdie7 = {false,SPR_SHT_DIE_7,9,NULL,NULL,&s_shtdie8};
statetype s_shtdie8 = {false,SPR_SHT_DEAD,0,NULL,NULL,&s_shtdie8};

//
// Heavy Shotgunner
//

extern statetype s_spcstand;

extern statetype s_spcpath1;
extern statetype s_spcpath1s;
extern statetype s_spcpath2;
extern statetype s_spcpath3;
extern statetype s_spcpath3s;
extern statetype s_spcpath4;

extern statetype s_spcpain;
extern statetype s_spcpain1;

extern statetype s_spcshoot1;
extern statetype s_spcshoot2;
extern statetype s_spcshoot3;
extern statetype s_spcshoot4;

extern statetype s_spcchase1;
extern statetype s_spcchase1s;
extern statetype s_spcchase2;
extern statetype s_spcchase3;
extern statetype s_spcchase3s;
extern statetype s_spcchase4;

extern statetype s_spcdie1;
extern statetype s_spcdie1d;
extern statetype s_spcdie2;
extern statetype s_spcdie3;
extern statetype s_spcdie4;
extern statetype s_spcdie5;
extern statetype s_spcdie6;
extern statetype s_spcdie7;

extern  statetype s_spcsplatter1;
extern  statetype s_spcsplatter1d;
extern  statetype s_spcsplatter2;
extern  statetype s_spcsplatter3;
extern  statetype s_spcsplatter4;
extern  statetype s_spcsplatter5;
extern  statetype s_spcsplatter6;
extern  statetype s_spcsplatter7;
extern  statetype s_spcsplatter8;

extern  statetype s_spcburn1;
extern  statetype s_spcburn1d;
extern  statetype s_spcburn2;
extern  statetype s_spcburn3;
extern  statetype s_spcburn4;
extern  statetype s_spcburn5;
extern  statetype s_spcburn6;
extern  statetype s_spcburn7;
extern  statetype s_spcburn8;
extern  statetype s_spcburn9;
extern  statetype s_spcburn10;
extern  statetype s_spcburn11;
extern  statetype s_spcburn12;
extern  statetype s_spcburn13;
extern  statetype s_spcburn14;
extern  statetype s_spcburn15;
extern  statetype s_spcburn16;
extern  statetype s_spcburn17;
extern  statetype s_spcburn18;
extern  statetype s_spcburn19;
extern  statetype s_spcburn20;
extern  statetype s_spcburn21;
extern  statetype s_spcburn22;

statetype s_spcburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_spcburn2};
statetype s_spcburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_spcburn3};
statetype s_spcburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_spcburn4};
statetype s_spcburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_spcburn5};
statetype s_spcburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_spcburn6};
statetype s_spcburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_spcburn7};
statetype s_spcburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_spcburn8};
statetype s_spcburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_spcburn9};
statetype s_spcburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_spcburn10};
statetype s_spcburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_spcburn11};
statetype s_spcburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_spcburn12};
statetype s_spcburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_spcburn13};
statetype s_spcburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_spcburn14};
statetype s_spcburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_spcburn15};
statetype s_spcburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_spcburn16};
statetype s_spcburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_spcburn17};
statetype s_spcburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_spcburn18};
statetype s_spcburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_spcburn19};
statetype s_spcburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_spcburn20};
statetype s_spcburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_spcburn21};
statetype s_spcburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_spcburn22};
statetype s_spcburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_spcburn22};

statetype s_spcsplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_spcsplatter2};
statetype s_spcsplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_spcsplatter3};
statetype s_spcsplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_spcsplatter4};
statetype s_spcsplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_spcsplatter5};
statetype s_spcsplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_spcsplatter6};
statetype s_spcsplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_spcsplatter7};
statetype s_spcsplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_spcsplatter8};
statetype s_spcsplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_spcsplatter8};

statetype s_spcstand = {true,SPR_SPC_S_1,0,(statefunc)T_Stand,NULL,&s_spcstand};

statetype s_spcpath1  = {true,SPR_SPC_W1_1,20,(statefunc)T_Path,NULL,&s_spcpath1s};
statetype s_spcpath1s  = {true,SPR_SPC_W1_1,5,NULL,NULL,&s_spcpath2};
statetype s_spcpath2  = {true,SPR_SPC_W2_1,15,(statefunc)T_Path,NULL,&s_spcpath3};
statetype s_spcpath3  = {true,SPR_SPC_W3_1,20,(statefunc)T_Path,NULL,&s_spcpath3s};
statetype s_spcpath3s  = {true,SPR_SPC_W3_1,5,NULL,NULL,&s_spcpath4};
statetype s_spcpath4  = {true,SPR_SPC_W4_1,15,(statefunc)T_Path,NULL,&s_spcpath1};

statetype s_spcpain  = {2,SPR_SPC_PAIN_1,10,NULL,NULL,&s_spcchase1};
statetype s_spcpain1 = {2,SPR_SPC_PAIN_1,10,NULL,NULL,&s_spcchase1};

statetype s_spcshoot1  = {false,SPR_SPC_SHOOT1,20,NULL,NULL,&s_spcshoot2};
statetype s_spcshoot2  = {false,SPR_SPC_SHOOT2,20,NULL,(statefunc)T_Shoot,&s_spcshoot3};
statetype s_spcshoot3  = {false,SPR_SPC_SHOOT3,20,NULL,NULL,&s_spcchase1};

statetype s_spcchase1  = {true,SPR_SPC_W1_1,10,(statefunc)T_Chase,NULL,&s_spcchase1s};
statetype s_spcchase1s  = {true,SPR_SPC_W1_1,3,NULL,NULL,&s_spcchase2};
statetype s_spcchase2  = {true,SPR_SPC_W2_1,8,(statefunc)T_Chase,NULL,&s_spcchase3};
statetype s_spcchase3  = {true,SPR_SPC_W3_1,10,(statefunc)T_Chase,NULL,&s_spcchase3s};
statetype s_spcchase3s  = {true,SPR_SPC_W3_1,3,NULL,NULL,&s_spcchase4};
statetype s_spcchase4  = {true,SPR_SPC_W4_1,8,(statefunc)T_Chase,NULL,&s_spcchase1};

statetype s_spcdie1 ={false,SPR_SPC_DIE_1,15,NULL,(statefunc)A_DeathScream,&s_spcdie2};
statetype s_spcdie2 = {false,SPR_SPC_DIE_2,15,NULL,NULL,&s_spcdie3};
statetype s_spcdie3 = {false,SPR_SPC_DIE_3,15,NULL,NULL,&s_spcdie4};
statetype s_spcdie4 = {false,SPR_SPC_DIE_4,15,NULL,NULL,&s_spcdie5};
statetype s_spcdie5 = {false,SPR_SPC_DIE_5,15,NULL,NULL,&s_spcdie6};
statetype s_spcdie6 = {false,SPR_SPC_DIE_6,15,NULL,NULL,&s_spcdie7};
statetype s_spcdie7 = {false,SPR_SPC_DEAD,0,NULL,NULL,&s_spcdie7};


//
// guards
//

extern  statetype s_grdstand;

extern  statetype s_grdpath1;
extern  statetype s_grdpath1s;
extern  statetype s_grdpath2;
extern  statetype s_grdpath3;
extern  statetype s_grdpath3s;
extern  statetype s_grdpath4;

extern  statetype s_grdpain;
extern  statetype s_grdpain1;

extern  statetype s_grdgiveup;

extern  statetype s_grdshoot1;
extern  statetype s_grdshoot2;
extern  statetype s_grdshoot3;
extern  statetype s_grdshoot4;
extern  statetype s_grdshoot5;
extern  statetype s_grdshoot6;
extern  statetype s_grdshoot7;
extern  statetype s_grdshoot8;
extern  statetype s_grdshoot9;

extern  statetype s_grdchase1;
extern  statetype s_grdchase1s;
extern  statetype s_grdchase2;
extern  statetype s_grdchase3;
extern  statetype s_grdchase3s;
extern  statetype s_grdchase4;

extern  statetype s_grddie1;
extern  statetype s_grddie1d;
extern  statetype s_grddie2;
extern  statetype s_grddie3;
extern  statetype s_grddie4;

extern  statetype s_grdsplatter1;
extern  statetype s_grdsplatter1d;
extern  statetype s_grdsplatter2;
extern  statetype s_grdsplatter3;
extern  statetype s_grdsplatter4;
extern  statetype s_grdsplatter5;
extern  statetype s_grdsplatter6;
extern  statetype s_grdsplatter7;
extern  statetype s_grdsplatter8;

extern  statetype s_grdburn1;
extern  statetype s_grdburn1d;
extern  statetype s_grdburn2;
extern  statetype s_grdburn3;
extern  statetype s_grdburn4;
extern  statetype s_grdburn5;
extern  statetype s_grdburn6;
extern  statetype s_grdburn7;
extern  statetype s_grdburn8;
extern  statetype s_grdburn9;
extern  statetype s_grdburn10;
extern  statetype s_grdburn11;
extern  statetype s_grdburn12;
extern  statetype s_grdburn13;
extern  statetype s_grdburn14;
extern  statetype s_grdburn15;
extern  statetype s_grdburn16;
extern  statetype s_grdburn17;
extern  statetype s_grdburn18;
extern  statetype s_grdburn19;
extern  statetype s_grdburn20;
extern  statetype s_grdburn21;
extern  statetype s_grdburn22;

statetype s_grdburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_grdburn2};
statetype s_grdburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_grdburn3};
statetype s_grdburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_grdburn4};
statetype s_grdburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_grdburn5};
statetype s_grdburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_grdburn6};
statetype s_grdburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_grdburn7};
statetype s_grdburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_grdburn8};
statetype s_grdburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_grdburn9};
statetype s_grdburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_grdburn10};
statetype s_grdburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_grdburn11};
statetype s_grdburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_grdburn12};
statetype s_grdburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_grdburn13};
statetype s_grdburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_grdburn14};
statetype s_grdburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_grdburn15};
statetype s_grdburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_grdburn16};
statetype s_grdburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_grdburn17};
statetype s_grdburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_grdburn18};
statetype s_grdburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_grdburn19};
statetype s_grdburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_grdburn20};
statetype s_grdburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_grdburn21};
statetype s_grdburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_grdburn22};
statetype s_grdburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_grdburn22};

statetype s_grdsplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_grdsplatter2};
statetype s_grdsplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_grdsplatter3};
statetype s_grdsplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_grdsplatter4};
statetype s_grdsplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_grdsplatter5};
statetype s_grdsplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_grdsplatter6};
statetype s_grdsplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_grdsplatter7};
statetype s_grdsplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_grdsplatter8};
statetype s_grdsplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_grdsplatter8};

statetype s_grdstand            = {true,SPR_GRD_S_1,0,(statefunc)T_Stand,NULL,&s_grdstand};

statetype s_grdpath1            = {true,SPR_GRD_W1_1,20,(statefunc)T_Path,NULL,&s_grdpath1s};
statetype s_grdpath1s           = {true,SPR_GRD_W1_1,5,NULL,NULL,&s_grdpath2};
statetype s_grdpath2            = {true,SPR_GRD_W2_1,15,(statefunc)T_Path,NULL,&s_grdpath3};
statetype s_grdpath3            = {true,SPR_GRD_W3_1,20,(statefunc)T_Path,NULL,&s_grdpath3s};
statetype s_grdpath3s           = {true,SPR_GRD_W3_1,5,NULL,NULL,&s_grdpath4};
statetype s_grdpath4            = {true,SPR_GRD_W4_1,15,(statefunc)T_Path,NULL,&s_grdpath1};

statetype s_grdpain             = {2,SPR_GRD_PAIN_1,10,NULL,NULL,&s_grdchase1};
statetype s_grdpain1            = {2,SPR_GRD_PAIN_2,10,NULL,NULL,&s_grdchase1};

statetype s_grdshoot1           = {false,SPR_GRD_SHOOT1,20,NULL,NULL,&s_grdshoot2};
statetype s_grdshoot2           = {false,SPR_GRD_SHOOT2,20,NULL,(statefunc)T_Shoot,&s_grdshoot3};
statetype s_grdshoot3           = {false,SPR_GRD_SHOOT3,10,NULL,NULL,&s_grdshoot4};
statetype s_grdshoot4           = {false,SPR_GRD_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_grdshoot5};
statetype s_grdshoot5           = {false,SPR_GRD_SHOOT3,10,NULL,NULL,&s_grdshoot6};
statetype s_grdshoot6           = {false,SPR_GRD_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_grdshoot7};
statetype s_grdshoot7           = {false,SPR_GRD_SHOOT3,10,NULL,NULL,&s_grdshoot8};
statetype s_grdshoot8           = {false,SPR_GRD_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_grdshoot9};
statetype s_grdshoot9           = {false,SPR_GRD_SHOOT3,10,NULL,NULL,&s_grdchase1};

statetype s_grdchase1           = {true,SPR_GRD_W1_1,10,(statefunc)T_Chase,NULL,&s_grdchase1s};
statetype s_grdchase1s          = {true,SPR_GRD_W1_1,3,NULL,NULL,&s_grdchase2};
statetype s_grdchase2           = {true,SPR_GRD_W2_1,8,(statefunc)T_Chase,NULL,&s_grdchase3};
statetype s_grdchase3           = {true,SPR_GRD_W3_1,10,(statefunc)T_Chase,NULL,&s_grdchase3s};
statetype s_grdchase3s          = {true,SPR_GRD_W3_1,3,NULL,NULL,&s_grdchase4};
statetype s_grdchase4           = {true,SPR_GRD_W4_1,8,(statefunc)T_Chase,NULL,&s_grdchase1};

statetype s_grddie1             = {false,SPR_GRD_DIE_1,15,NULL,(statefunc)A_DeathScream,&s_grddie2};
statetype s_grddie2             = {false,SPR_GRD_DIE_2,15,NULL,NULL,&s_grddie3};
statetype s_grddie3             = {false,SPR_GRD_DIE_3,15,NULL,NULL,&s_grddie4};
statetype s_grddie4             = {false,SPR_GRD_DEAD,0,NULL,NULL,&s_grddie4};

//
// eilte guards
//

extern  statetype s_grd2stand;

extern  statetype s_grd2path1;
extern  statetype s_grd2path1s;
extern  statetype s_grd2path2;
extern  statetype s_grd2path3;
extern  statetype s_grd2path3s;
extern  statetype s_grd2path4;

extern  statetype s_grd2pain;
extern  statetype s_grd2pain1;

extern  statetype s_grd2giveup;

extern  statetype s_grd2shoot1;
extern  statetype s_grd2shoot2;
extern  statetype s_grd2shoot3;
extern  statetype s_grd2shoot4;
extern  statetype s_grd2shoot5;
extern  statetype s_grd2shoot6;
extern  statetype s_grd2shoot7;
extern  statetype s_grd2shoot8;
extern  statetype s_grd2shoot9;

extern  statetype s_grd2chase1;
extern  statetype s_grd2chase1s;
extern  statetype s_grd2chase2;
extern  statetype s_grd2chase3;
extern  statetype s_grd2chase3s;
extern  statetype s_grd2chase4;

extern  statetype s_grd2die1;
extern  statetype s_grd2die1d;
extern  statetype s_grd2die2;
extern  statetype s_grd2die3;
extern  statetype s_grd2die4;
extern  statetype s_grd2die5;

extern  statetype s_grd2splatter1;
extern  statetype s_grd2splatter1d;
extern  statetype s_grd2splatter2;
extern  statetype s_grd2splatter3;
extern  statetype s_grd2splatter4;
extern  statetype s_grd2splatter5;
extern  statetype s_grd2splatter6;
extern  statetype s_grd2splatter7;
extern  statetype s_grd2splatter8;

extern  statetype s_grd2burn1;
extern  statetype s_grd2burn1d;
extern  statetype s_grd2burn2;
extern  statetype s_grd2burn3;
extern  statetype s_grd2burn4;
extern  statetype s_grd2burn5;
extern  statetype s_grd2burn6;
extern  statetype s_grd2burn7;
extern  statetype s_grd2burn8;
extern  statetype s_grd2burn9;
extern  statetype s_grd2burn10;
extern  statetype s_grd2burn11;
extern  statetype s_grd2burn12;
extern  statetype s_grd2burn13;
extern  statetype s_grd2burn14;
extern  statetype s_grd2burn15;
extern  statetype s_grd2burn16;
extern  statetype s_grd2burn17;
extern  statetype s_grd2burn18;
extern  statetype s_grd2burn19;
extern  statetype s_grd2burn20;
extern  statetype s_grd2burn21;
extern  statetype s_grd2burn22;

statetype s_grd2burn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_grd2burn2};
statetype s_grd2burn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_grd2burn3};
statetype s_grd2burn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_grd2burn4};
statetype s_grd2burn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_grd2burn5};
statetype s_grd2burn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_grd2burn6};
statetype s_grd2burn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_grd2burn7};
statetype s_grd2burn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_grd2burn8};
statetype s_grd2burn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_grd2burn9};
statetype s_grd2burn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_grd2burn10};
statetype s_grd2burn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_grd2burn11};
statetype s_grd2burn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_grd2burn12};
statetype s_grd2burn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_grd2burn13};
statetype s_grd2burn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_grd2burn14};
statetype s_grd2burn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_grd2burn15};
statetype s_grd2burn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_grd2burn16};
statetype s_grd2burn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_grd2burn17};
statetype s_grd2burn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_grd2burn18};
statetype s_grd2burn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_grd2burn19};
statetype s_grd2burn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_grd2burn20};
statetype s_grd2burn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_grd2burn21};
statetype s_grd2burn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_grd2burn22};
statetype s_grd2burn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_grd2burn22};

statetype s_grd2splatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_grd2splatter2};
statetype s_grd2splatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_grd2splatter3};
statetype s_grd2splatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_grd2splatter4};
statetype s_grd2splatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_grd2splatter5};
statetype s_grd2splatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_grd2splatter6};
statetype s_grd2splatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_grd2splatter7};
statetype s_grd2splatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_grd2splatter8};
statetype s_grd2splatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_grd2splatter8};

statetype s_grd2stand            = {false,SPR_VET_S_1,0,(statefunc)T_Stand,NULL,&s_grd2stand};

statetype s_grd2path1            = {true,SPR_VET_W1_1,20,(statefunc)T_Path,NULL,&s_grd2path1s};
statetype s_grd2path1s           = {true,SPR_VET_W1_1,5,NULL,NULL,&s_grd2path2};
statetype s_grd2path2            = {true,SPR_VET_W2_1,15,(statefunc)T_Path,NULL,&s_grd2path3};
statetype s_grd2path3            = {true,SPR_VET_W3_1,20,(statefunc)T_Path,NULL,&s_grd2path3s};
statetype s_grd2path3s           = {true,SPR_VET_W3_1,5,NULL,NULL,&s_grd2path4};
statetype s_grd2path4            = {true,SPR_VET_W4_1,15,(statefunc)T_Path,NULL,&s_grd2path1};

statetype s_grd2pain             = {2,SPR_VET_PAIN_1,10,NULL,NULL,&s_grd2chase1};
statetype s_grd2pain1            = {2,SPR_VET_PAIN_1,10,NULL,NULL,&s_grd2chase1};

statetype s_grd2shoot1           = {false,SPR_VET_SHOOT1,20,NULL,NULL,&s_grd2shoot2};
statetype s_grd2shoot2           = {false,SPR_VET_SHOOT1,20,NULL,(statefunc)T_Shoot,&s_grd2shoot3};
statetype s_grd2shoot3           = {false,SPR_VET_SHOOT2,10,NULL,NULL,&s_grd2shoot4};
statetype s_grd2shoot4           = {false,SPR_VET_SHOOT1,10,NULL,(statefunc)T_Shoot,&s_grd2shoot5};
statetype s_grd2shoot5           = {false,SPR_VET_SHOOT2,10,NULL,NULL,&s_grd2shoot6};
statetype s_grd2shoot6           = {false,SPR_VET_SHOOT1,10,NULL,(statefunc)T_Shoot,&s_grd2shoot7};
statetype s_grd2shoot7           = {false,SPR_VET_SHOOT2,10,NULL,NULL,&s_grd2shoot8};
statetype s_grd2shoot8           = {false,SPR_VET_SHOOT1,10,NULL,(statefunc)T_Shoot,&s_grd2shoot9};
statetype s_grd2shoot9           = {false,SPR_VET_SHOOT2,10,NULL,NULL,&s_grd2chase1};

statetype s_grd2chase1           = {true,SPR_VET_W1_1,10,(statefunc)T_Chase,NULL,&s_grd2chase1s};
statetype s_grd2chase1s          = {true,SPR_VET_W1_1,3,NULL,NULL,&s_grd2chase2};
statetype s_grd2chase2           = {true,SPR_VET_W2_1,8,(statefunc)T_Chase,NULL,&s_grd2chase3};
statetype s_grd2chase3           = {true,SPR_VET_W3_1,10,(statefunc)T_Chase,NULL,&s_grd2chase3s};
statetype s_grd2chase3s          = {true,SPR_VET_W3_1,3,NULL,NULL,&s_grd2chase4};
statetype s_grd2chase4           = {true,SPR_VET_W4_1,8,(statefunc)T_Chase,NULL,&s_grd2chase1};

statetype s_grd2die1             = {false,SPR_VET_DIE_1,15,NULL,(statefunc)A_DeathScream,&s_grd2die2};
statetype s_grd2die2             = {false,SPR_VET_DIE_2,15,NULL,NULL,&s_grd2die3};
statetype s_grd2die3             = {false,SPR_VET_DIE_3,15,NULL,NULL,&s_grd2die4};
statetype s_grd2die4             = {false,SPR_VET_DIE_4,15,NULL,NULL,&s_grd2die5};
statetype s_grd2die5             = {false,SPR_VET_DEAD,0,NULL,NULL,&s_grd2die5};

#ifndef SPEAR
//
// ghosts
//
extern  statetype s_blinkychase1;
extern  statetype s_blinkychase2;
extern  statetype s_inkychase1;
extern  statetype s_inkychase2;
extern  statetype s_pinkychase1;
extern  statetype s_pinkychase2;
extern  statetype s_clydechase1;
extern  statetype s_clydechase2;

statetype s_blinkychase1        = {false,SPR_BLINKY_W1,10,(statefunc)T_Ghosts,NULL,&s_blinkychase2};
statetype s_blinkychase2        = {false,SPR_BLINKY_W2,10,(statefunc)T_Ghosts,NULL,&s_blinkychase1};

statetype s_inkychase1          = {false,SPR_INKY_W1,10,(statefunc)T_Ghosts,NULL,&s_inkychase2};
statetype s_inkychase2          = {false,SPR_INKY_W2,10,(statefunc)T_Ghosts,NULL,&s_inkychase1};

statetype s_pinkychase1         = {false,SPR_PINKY_W1,10,(statefunc)T_Ghosts,NULL,&s_pinkychase2};
statetype s_pinkychase2         = {false,SPR_PINKY_W2,10,(statefunc)T_Ghosts,NULL,&s_pinkychase1};

statetype s_clydechase1         = {false,SPR_CLYDE_W1,10,(statefunc)T_Ghosts,NULL,&s_clydechase2};
statetype s_clydechase2         = {false,SPR_CLYDE_W2,10,(statefunc)T_Ghosts,NULL,&s_clydechase1};
#endif

//
// dogs
//

extern  statetype s_dogpath1;
extern  statetype s_dogpath1s;
extern  statetype s_dogpath2;
extern  statetype s_dogpath3;
extern  statetype s_dogpath3s;
extern  statetype s_dogpath4;

extern  statetype s_dogjump1;
extern  statetype s_dogjump2;
extern  statetype s_dogjump3;
extern  statetype s_dogjump4;
extern  statetype s_dogjump5;

extern  statetype s_dogchase1;
extern  statetype s_dogchase1s;
extern  statetype s_dogchase2;
extern  statetype s_dogchase3;
extern  statetype s_dogchase3s;
extern  statetype s_dogchase4;

extern  statetype s_dogdie1;
extern  statetype s_dogdie1d;
extern  statetype s_dogdie2;
extern  statetype s_dogdie3;
extern  statetype s_dogdead;

statetype s_dogpath1            = {true,SPR_DOG_W1_1,20,(statefunc)T_Path,NULL,&s_dogpath1s};
statetype s_dogpath1s           = {true,SPR_DOG_W1_1,5,NULL,NULL,&s_dogpath2};
statetype s_dogpath2            = {true,SPR_DOG_W2_1,15,(statefunc)T_Path,NULL,&s_dogpath3};
statetype s_dogpath3            = {true,SPR_DOG_W3_1,20,(statefunc)T_Path,NULL,&s_dogpath3s};
statetype s_dogpath3s           = {true,SPR_DOG_W3_1,5,NULL,NULL,&s_dogpath4};
statetype s_dogpath4            = {true,SPR_DOG_W4_1,15,(statefunc)T_Path,NULL,&s_dogpath1};

statetype s_dogjump1            = {false,SPR_DOG_JUMP1,10,NULL,NULL,&s_dogjump2};
statetype s_dogjump2            = {false,SPR_DOG_JUMP2,10,NULL,(statefunc)T_Bite,&s_dogjump3};
statetype s_dogjump3            = {false,SPR_DOG_JUMP3,10,NULL,NULL,&s_dogjump4};
statetype s_dogjump4            = {false,SPR_DOG_JUMP1,10,NULL,NULL,&s_dogjump5};
statetype s_dogjump5            = {false,SPR_DOG_W1_1,10,NULL,NULL,&s_dogchase1};

statetype s_dogchase1           = {true,SPR_DOG_W1_1,10,(statefunc)T_DogChase,NULL,&s_dogchase1s};
statetype s_dogchase1s          = {true,SPR_DOG_W1_1,3,NULL,NULL,&s_dogchase2};
statetype s_dogchase2           = {true,SPR_DOG_W2_1,8,(statefunc)T_DogChase,NULL,&s_dogchase3};
statetype s_dogchase3           = {true,SPR_DOG_W3_1,10,(statefunc)T_DogChase,NULL,&s_dogchase3s};
statetype s_dogchase3s          = {true,SPR_DOG_W3_1,3,NULL,NULL,&s_dogchase4};
statetype s_dogchase4           = {true,SPR_DOG_W4_1,8,(statefunc)T_DogChase,NULL,&s_dogchase1};

statetype s_dogdie1             = {false,SPR_DOG_DIE_1,15,NULL,(statefunc)A_DeathScream,&s_dogdie2};
statetype s_dogdie2             = {false,SPR_DOG_DIE_2,15,NULL,NULL,&s_dogdie3};
statetype s_dogdie3             = {false,SPR_DOG_DIE_3,15,NULL,NULL,&s_dogdead};
statetype s_dogdead             = {false,SPR_DOG_DEAD,15,NULL,NULL,&s_dogdead};


//
// officers
//

extern  statetype s_ofcstand;

extern  statetype s_ofcpath1;
extern  statetype s_ofcpath1s;
extern  statetype s_ofcpath2;
extern  statetype s_ofcpath3;
extern  statetype s_ofcpath3s;
extern  statetype s_ofcpath4;

extern  statetype s_ofcpain;
extern  statetype s_ofcpain1;

extern  statetype s_ofcgiveup;

extern  statetype s_ofcshoot1;
extern  statetype s_ofcshoot2;
extern  statetype s_ofcshoot3;
extern  statetype s_ofcshoot4;

extern  statetype s_ofcchase1;
extern  statetype s_ofcchase1s;
extern  statetype s_ofcchase2;
extern  statetype s_ofcchase3;
extern  statetype s_ofcchase3s;
extern  statetype s_ofcchase4;

extern  statetype s_ofcdie1;
extern  statetype s_ofcdie2;
extern  statetype s_ofcdie3;
extern  statetype s_ofcdie4;
extern  statetype s_ofcdie5;

extern  statetype s_ofcsplatter1;
extern  statetype s_ofcsplatter1d;
extern  statetype s_ofcsplatter2;
extern  statetype s_ofcsplatter3;
extern  statetype s_ofcsplatter4;
extern  statetype s_ofcsplatter5;
extern  statetype s_ofcsplatter6;
extern  statetype s_ofcsplatter7;
extern  statetype s_ofcsplatter8;

extern  statetype s_ofcburn1;
extern  statetype s_ofcburn1d;
extern  statetype s_ofcburn2;
extern  statetype s_ofcburn3;
extern  statetype s_ofcburn4;
extern  statetype s_ofcburn5;
extern  statetype s_ofcburn6;
extern  statetype s_ofcburn7;
extern  statetype s_ofcburn8;
extern  statetype s_ofcburn9;
extern  statetype s_ofcburn10;
extern  statetype s_ofcburn11;
extern  statetype s_ofcburn12;
extern  statetype s_ofcburn13;
extern  statetype s_ofcburn14;
extern  statetype s_ofcburn15;
extern  statetype s_ofcburn16;
extern  statetype s_ofcburn17;
extern  statetype s_ofcburn18;
extern  statetype s_ofcburn19;
extern  statetype s_ofcburn20;
extern  statetype s_ofcburn21;
extern  statetype s_ofcburn22;

statetype s_ofcburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_ofcburn2};
statetype s_ofcburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_ofcburn3};
statetype s_ofcburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_ofcburn4};
statetype s_ofcburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_ofcburn5};
statetype s_ofcburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_ofcburn6};
statetype s_ofcburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_ofcburn7};
statetype s_ofcburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_ofcburn8};
statetype s_ofcburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_ofcburn9};
statetype s_ofcburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_ofcburn10};
statetype s_ofcburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_ofcburn11};
statetype s_ofcburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_ofcburn12};
statetype s_ofcburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_ofcburn13};
statetype s_ofcburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_ofcburn14};
statetype s_ofcburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_ofcburn15};
statetype s_ofcburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_ofcburn16};
statetype s_ofcburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_ofcburn17};
statetype s_ofcburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_ofcburn18};
statetype s_ofcburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_ofcburn19};
statetype s_ofcburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_ofcburn20};
statetype s_ofcburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_ofcburn21};
statetype s_ofcburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_ofcburn22};
statetype s_ofcburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_ofcburn22};

statetype s_ofcsplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_ofcsplatter2};
statetype s_ofcsplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_ofcsplatter3};
statetype s_ofcsplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_ofcsplatter4};
statetype s_ofcsplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_ofcsplatter5};
statetype s_ofcsplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_ofcsplatter6};
statetype s_ofcsplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_ofcsplatter7};
statetype s_ofcsplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_ofcsplatter8};
statetype s_ofcsplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_ofcsplatter8};

statetype s_ofcstand            = {true,SPR_OFC_S_1,0,(statefunc)T_Stand,NULL,&s_ofcstand};

statetype s_ofcpath1            = {true,SPR_OFC_W1_1,20,(statefunc)T_Path,NULL,&s_ofcpath1s};
statetype s_ofcpath1s           = {true,SPR_OFC_W1_1,5,NULL,NULL,&s_ofcpath2};
statetype s_ofcpath2            = {true,SPR_OFC_W2_1,15,(statefunc)T_Path,NULL,&s_ofcpath3};
statetype s_ofcpath3            = {true,SPR_OFC_W3_1,20,(statefunc)T_Path,NULL,&s_ofcpath3s};
statetype s_ofcpath3s           = {true,SPR_OFC_W3_1,5,NULL,NULL,&s_ofcpath4};
statetype s_ofcpath4            = {true,SPR_OFC_W4_1,15,(statefunc)T_Path,NULL,&s_ofcpath1};

statetype s_ofcpain             = {2,SPR_OFC_PAIN_1,10,NULL,NULL,&s_ofcchase1};
statetype s_ofcpain1            = {2,SPR_OFC_PAIN_2,10,NULL,NULL,&s_ofcchase1};

statetype s_ofcshoot1           = {false,SPR_OFC_SHOOT1,6,NULL,NULL,&s_ofcshoot2};
statetype s_ofcshoot2           = {false,SPR_OFC_SHOOT2,20,NULL,(statefunc)T_Shoot,&s_ofcshoot3};
statetype s_ofcshoot3           = {false,SPR_OFC_SHOOT3,10,NULL,NULL,&s_ofcchase1};

statetype s_ofcchase1           = {true,SPR_OFC_W1_1,10,(statefunc)T_Chase,NULL,&s_ofcchase1s};
statetype s_ofcchase1s          = {true,SPR_OFC_W1_1,3,NULL,NULL,&s_ofcchase2};
statetype s_ofcchase2           = {true,SPR_OFC_W2_1,8,(statefunc)T_Chase,NULL,&s_ofcchase3};
statetype s_ofcchase3           = {true,SPR_OFC_W3_1,10,(statefunc)T_Chase,NULL,&s_ofcchase3s};
statetype s_ofcchase3s          = {true,SPR_OFC_W3_1,3,NULL,NULL,&s_ofcchase4};
statetype s_ofcchase4           = {true,SPR_OFC_W4_1,8,(statefunc)T_Chase,NULL,&s_ofcchase1};

statetype s_ofcdie1             = {false,SPR_OFC_DIE_1,11,NULL,(statefunc)A_DeathScream,&s_ofcdie2};
statetype s_ofcdie2             = {false,SPR_OFC_DIE_2,11,NULL,NULL,&s_ofcdie3};
statetype s_ofcdie3             = {false,SPR_OFC_DIE_3,11,NULL,NULL,&s_ofcdie4};
statetype s_ofcdie4             = {false,SPR_OFC_DIE_4,11,NULL,NULL,&s_ofcdie5};
statetype s_ofcdie5             = {false,SPR_OFC_DEAD,0,NULL,NULL,&s_ofcdie5};


//
// mutant
//

extern  statetype s_mutstand;

extern  statetype s_mutpath1;
extern  statetype s_mutpath1s;
extern  statetype s_mutpath2;
extern  statetype s_mutpath3;
extern  statetype s_mutpath3s;
extern  statetype s_mutpath4;

extern  statetype s_mutpain;
extern  statetype s_mutpain1;

extern  statetype s_mutgiveup;

extern  statetype s_mutshoot1;
extern  statetype s_mutshoot2;
extern  statetype s_mutshoot3;
extern  statetype s_mutshoot4;

extern  statetype s_mutchase1;
extern  statetype s_mutchase1s;
extern  statetype s_mutchase2;
extern  statetype s_mutchase3;
extern  statetype s_mutchase3s;
extern  statetype s_mutchase4;

extern  statetype s_mutdie1;
extern  statetype s_mutdie2;
extern  statetype s_mutdie3;
extern  statetype s_mutdie4;
extern  statetype s_mutdie5;

statetype s_mutstand            = {true,SPR_MUT_S_1,0,(statefunc)T_Stand,NULL,&s_mutstand};

statetype s_mutpath1            = {true,SPR_MUT_W1_1,20,(statefunc)T_Path,NULL,&s_mutpath1s};
statetype s_mutpath1s           = {true,SPR_MUT_W1_1,5,NULL,NULL,&s_mutpath2};
statetype s_mutpath2            = {true,SPR_MUT_W2_1,15,(statefunc)T_Path,NULL,&s_mutpath3};
statetype s_mutpath3            = {true,SPR_MUT_W3_1,20,(statefunc)T_Path,NULL,&s_mutpath3s};
statetype s_mutpath3s           = {true,SPR_MUT_W3_1,5,NULL,NULL,&s_mutpath4};
statetype s_mutpath4            = {true,SPR_MUT_W4_1,15,(statefunc)T_Path,NULL,&s_mutpath1};

statetype s_mutpain             = {2,SPR_MUT_PAIN_1,10,NULL,NULL,&s_mutchase1};
statetype s_mutpain1            = {2,SPR_MUT_PAIN_1,10,NULL,NULL,&s_mutchase1};

statetype s_mutshoot1           = {false,SPR_MUT_SHOOT1,6,NULL,NULL,&s_mutshoot2};
statetype s_mutshoot2           = {false,SPR_MUT_SHOOT2,20,NULL,(statefunc)T_Shadowball,&s_mutshoot3};
statetype s_mutshoot3           = {false,SPR_MUT_SHOOT3,10,NULL,NULL,&s_mutshoot4};
statetype s_mutshoot4           = {false,SPR_MUT_SHOOT4,20,NULL,NULL,&s_mutchase1};

statetype s_mutchase1           = {true,SPR_MUT_W1_1,10,(statefunc)T_Chase,NULL,&s_mutchase1s};
statetype s_mutchase1s          = {true,SPR_MUT_W1_1,3,NULL,NULL,&s_mutchase2};
statetype s_mutchase2           = {true,SPR_MUT_W2_1,8,(statefunc)T_Chase,NULL,&s_mutchase3};
statetype s_mutchase3           = {true,SPR_MUT_W3_1,10,(statefunc)T_Chase,NULL,&s_mutchase3s};
statetype s_mutchase3s          = {true,SPR_MUT_W3_1,3,NULL,NULL,&s_mutchase4};
statetype s_mutchase4           = {true,SPR_MUT_W4_1,8,(statefunc)T_Chase,NULL,&s_mutchase1};

statetype s_mutdie1             = {false,SPR_MUT_DIE_1,7,NULL,(statefunc)A_DeathScream,&s_mutdie2};
statetype s_mutdie2             = {false,SPR_MUT_DIE_2,7,NULL,NULL,&s_mutdie3};
statetype s_mutdie3             = {false,SPR_MUT_DIE_3,7,NULL,NULL,&s_mutdie4};
statetype s_mutdie4             = {false,SPR_MUT_DIE_4,7,NULL,NULL,&s_mutdie5};
statetype s_mutdie5             = {false,SPR_MUT_DEAD,0,NULL,NULL,&s_mutdie5};


//
// SS
//

extern  statetype s_ssstand;

extern  statetype s_sspath1;
extern  statetype s_sspath1s;
extern  statetype s_sspath2;
extern  statetype s_sspath3;
extern  statetype s_sspath3s;
extern  statetype s_sspath4;

extern  statetype s_sspain;
extern  statetype s_sspain1;

extern  statetype s_ssshoot1;
extern  statetype s_ssshoot2;
extern  statetype s_ssshoot3;
extern  statetype s_ssshoot4;
extern  statetype s_ssshoot5;
extern  statetype s_ssshoot6;
extern  statetype s_ssshoot7;
extern  statetype s_ssshoot8;
extern  statetype s_ssshoot9;
extern  statetype s_ssshoot10;
extern  statetype s_ssshoot11;
extern  statetype s_ssshoot12;
extern  statetype s_ssshoot13;
extern  statetype s_ssshoot14;
extern  statetype s_ssshoot15;

extern  statetype s_sschase1;
extern  statetype s_sschase1s;
extern  statetype s_sschase2;
extern  statetype s_sschase3;
extern  statetype s_sschase3s;
extern  statetype s_sschase4;

extern  statetype s_ssdie1;
extern  statetype s_ssdie2;
extern  statetype s_ssdie3;
extern  statetype s_ssdie4;
extern  statetype s_ssdie5;
extern  statetype s_ssdie6;
extern  statetype s_ssdie7;

extern  statetype s_sssplatter1;
extern  statetype s_sssplatter1d;
extern  statetype s_sssplatter2;
extern  statetype s_sssplatter3;
extern  statetype s_sssplatter4;
extern  statetype s_sssplatter5;
extern  statetype s_sssplatter6;
extern  statetype s_sssplatter7;
extern  statetype s_sssplatter8;

extern  statetype s_ssburn1;
extern  statetype s_sstburn1d;
extern  statetype s_ssburn2;
extern  statetype s_ssburn3;
extern  statetype s_ssburn4;
extern  statetype s_ssburn5;
extern  statetype s_ssburn6;
extern  statetype s_ssburn7;
extern  statetype s_ssburn8;
extern  statetype s_ssburn9;
extern  statetype s_ssburn10;
extern  statetype s_ssburn11;
extern  statetype s_ssburn12;
extern  statetype s_ssburn13;
extern  statetype s_ssburn14;
extern  statetype s_ssburn15;
extern  statetype s_ssburn16;
extern  statetype s_ssburn17;
extern  statetype s_ssburn18;
extern  statetype s_ssburn19;
extern  statetype s_ssburn20;
extern  statetype s_ssburn21;
extern  statetype s_ssburn22;

statetype s_ssburn1 = {false,SPR_BURN_1,9,NULL,(statefunc)A_Burn,&s_ssburn2};
statetype s_ssburn2 = {false,SPR_BURN_2,9,NULL,NULL,&s_ssburn3};
statetype s_ssburn3 = {false,SPR_BURN_3,9,NULL,NULL,&s_ssburn4};
statetype s_ssburn4 = {false,SPR_BURN_4,9,NULL,NULL,&s_ssburn5};
statetype s_ssburn5 = {false,SPR_BURN_5,9,NULL,NULL,&s_ssburn6};
statetype s_ssburn6 = {false,SPR_BURN_6,9,NULL,NULL,&s_ssburn7};
statetype s_ssburn7 = {false,SPR_BURN_7,9,NULL,NULL,&s_ssburn8};
statetype s_ssburn8 = {false,SPR_BURN_8,9,NULL,NULL,&s_ssburn9};
statetype s_ssburn9 = {false,SPR_BURN_9,9,NULL,NULL,&s_ssburn10};
statetype s_ssburn10 = {false,SPR_BURN_10,9,NULL,NULL,&s_ssburn11};
statetype s_ssburn11 = {false,SPR_BURN_11,9,NULL,NULL,&s_ssburn12};
statetype s_ssburn12 = {false,SPR_BURN_12,9,NULL,NULL,&s_ssburn13};
statetype s_ssburn13 = {false,SPR_BURN_13,9,NULL,NULL,&s_ssburn14};
statetype s_ssburn14 = {false,SPR_BURN_14,9,NULL,NULL,&s_ssburn15};
statetype s_ssburn15 = {false,SPR_BURN_15,9,NULL,NULL,&s_ssburn16};
statetype s_ssburn16 = {false,SPR_BURN_16,9,NULL,NULL,&s_ssburn17};
statetype s_ssburn17 = {false,SPR_BURN_17,9,NULL,NULL,&s_ssburn18};
statetype s_ssburn18 = {false,SPR_BURN_18,9,NULL,NULL,&s_ssburn19};
statetype s_ssburn19 = {false,SPR_BURN_19,9,NULL,NULL,&s_ssburn20};
statetype s_ssburn20 = {false,SPR_BURN_20,9,NULL,NULL,&s_ssburn21};
statetype s_ssburn21 = {false,SPR_BURN_21,9,NULL,NULL,&s_ssburn22};
statetype s_ssburn22 = {false,SPR_BURN_22,0,NULL,NULL,&s_ssburn22};

statetype s_sssplatter1 = {false,SPR_SPLAT_1,9,NULL,(statefunc)A_Slurpie,&s_sssplatter2};
statetype s_sssplatter2 = {false,SPR_SPLAT_2,9,NULL,NULL,&s_sssplatter3};
statetype s_sssplatter3 = {false,SPR_SPLAT_3,9,NULL,NULL,&s_sssplatter4};
statetype s_sssplatter4 = {false,SPR_SPLAT_4,9,NULL,NULL,&s_sssplatter5};
statetype s_sssplatter5 = {false,SPR_SPLAT_5,9,NULL,NULL,&s_sssplatter6};
statetype s_sssplatter6 = {false,SPR_SPLAT_6,9,NULL,NULL,&s_sssplatter7};
statetype s_sssplatter7 = {false,SPR_SPLAT_7,9,NULL,NULL,&s_sssplatter8};
statetype s_sssplatter8 = {false,SPR_SPLAT_8,0,NULL,NULL,&s_sssplatter8};

statetype s_ssstand             = {true,SPR_SS_S_1,0,(statefunc)T_Stand,NULL,&s_ssstand};

statetype s_sspath1             = {true,SPR_SS_W1_1,20,(statefunc)T_Path,NULL,&s_sspath1s};
statetype s_sspath1s            = {true,SPR_SS_W1_1,5,NULL,NULL,&s_sspath2};
statetype s_sspath2             = {true,SPR_SS_W2_1,15,(statefunc)T_Path,NULL,&s_sspath3};
statetype s_sspath3             = {true,SPR_SS_W3_1,20,(statefunc)T_Path,NULL,&s_sspath3s};
statetype s_sspath3s            = {true,SPR_SS_W3_1,5,NULL,NULL,&s_sspath4};
statetype s_sspath4             = {true,SPR_SS_W4_1,15,(statefunc)T_Path,NULL,&s_sspath1};

statetype s_sspain              = {2,SPR_SS_PAIN_1,10,NULL,NULL,&s_sschase1};
statetype s_sspain1             = {2,SPR_SS_PAIN_1,10,NULL,NULL,&s_sschase1};

statetype s_ssshoot1            = {false,SPR_SS_SHOOT1,10,NULL,NULL,&s_ssshoot2};
statetype s_ssshoot2            = {false,SPR_SS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_ssshoot3};
statetype s_ssshoot3            = {false,SPR_SS_SHOOT3,5,NULL,NULL,&s_ssshoot4};
statetype s_ssshoot4            = {false,SPR_SS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_ssshoot5};
statetype s_ssshoot5            = {false,SPR_SS_SHOOT3,5,NULL,NULL,&s_ssshoot6};
statetype s_ssshoot6            = {false,SPR_SS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_ssshoot7};
statetype s_ssshoot7            = {false,SPR_SS_SHOOT3,5,NULL,NULL,&s_ssshoot8};
statetype s_ssshoot8            = {false,SPR_SS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_ssshoot9};
statetype s_ssshoot9            = {false,SPR_SS_SHOOT3,5,NULL,NULL,&s_ssshoot10};
statetype s_ssshoot10            = {false,SPR_SS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_ssshoot11};
statetype s_ssshoot11            = {false,SPR_SS_SHOOT3,5,NULL,NULL,&s_ssshoot12};
statetype s_ssshoot12            = {false,SPR_SS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_ssshoot13};
statetype s_ssshoot13            = {false,SPR_SS_SHOOT3,5,NULL,NULL,&s_ssshoot14};
statetype s_ssshoot14           = {false,SPR_SS_SHOOT2,5,NULL,(statefunc)T_Shoot,&s_ssshoot15};
statetype s_ssshoot15           = {false,SPR_SS_SHOOT3,5,NULL,NULL,&s_sschase1};

statetype s_sschase1            = {true,SPR_SS_W1_1,10,(statefunc)T_Chase,NULL,&s_sschase1s};
statetype s_sschase1s           = {true,SPR_SS_W1_1,3,NULL,NULL,&s_sschase2};
statetype s_sschase2            = {true,SPR_SS_W2_1,8,(statefunc)T_Chase,NULL,&s_sschase3};
statetype s_sschase3            = {true,SPR_SS_W3_1,10,(statefunc)T_Chase,NULL,&s_sschase3s};
statetype s_sschase3s           = {true,SPR_SS_W3_1,3,NULL,NULL,&s_sschase4};
statetype s_sschase4            = {true,SPR_SS_W4_1,8,(statefunc)T_Chase,NULL,&s_sschase1};

statetype s_ssdie1              = {false,SPR_SS_DIE_1,5,NULL,(statefunc)A_DeathScream,&s_ssdie2};
statetype s_ssdie2              = {false,SPR_SS_DIE_2,5,NULL,NULL,&s_ssdie3};
statetype s_ssdie3              = {false,SPR_SS_DIE_3,5,NULL,NULL,&s_ssdie4};
statetype s_ssdie4              = {false,SPR_SS_DIE_4,5,NULL,NULL,&s_ssdie5};
statetype s_ssdie5              = {false,SPR_SS_DIE_5,5,NULL,NULL,&s_ssdie6};
statetype s_ssdie6              = {false,SPR_SS_DIE_6,5,NULL,NULL,&s_ssdie7};
statetype s_ssdie7              = {false,SPR_SS_DEAD,0,NULL,NULL,&s_ssdie7};


#ifndef SPEAR
//
// hans
//
extern  statetype s_bossstand;

extern  statetype s_bosschase1;
extern  statetype s_bosschase1s;
extern  statetype s_bosschase2;
extern  statetype s_bosschase3;
extern  statetype s_bosschase3s;
extern  statetype s_bosschase4;

extern  statetype s_bossdie1;
extern  statetype s_bossdie2;
extern  statetype s_bossdie3;
extern  statetype s_bossdie4;

extern  statetype s_bossshoot1;
extern  statetype s_bossshoot2;
extern  statetype s_bossshoot3;
extern  statetype s_bossshoot4;
extern  statetype s_bossshoot5;
extern  statetype s_bossshoot6;
extern  statetype s_bossshoot7;
extern  statetype s_bossshoot8;


statetype s_bossstand           = {false,SPR_BOSS_W1,0,(statefunc)T_Stand,NULL,&s_bossstand};

statetype s_bosschase1          = {false,SPR_BOSS_W1,10,(statefunc)T_Chase,NULL,&s_bosschase1s};
statetype s_bosschase1s         = {false,SPR_BOSS_W1,3,NULL,NULL,&s_bosschase2};
statetype s_bosschase2          = {false,SPR_BOSS_W2,8,(statefunc)T_Chase,NULL,&s_bosschase3};
statetype s_bosschase3          = {false,SPR_BOSS_W3,10,(statefunc)T_Chase,NULL,&s_bosschase3s};
statetype s_bosschase3s         = {false,SPR_BOSS_W3,3,NULL,NULL,&s_bosschase4};
statetype s_bosschase4          = {false,SPR_BOSS_W4,8,(statefunc)T_Chase,NULL,&s_bosschase1};

statetype s_bossdie1            = {false,SPR_BOSS_DIE1,15,NULL,(statefunc)A_DeathScream,&s_bossdie2};
statetype s_bossdie2            = {false,SPR_BOSS_DIE2,15,NULL,NULL,&s_bossdie3};
statetype s_bossdie3            = {false,SPR_BOSS_DIE3,15,NULL,NULL,&s_bossdie4};
statetype s_bossdie4            = {false,SPR_BOSS_DEAD,0,NULL,NULL,&s_bossdie4};

statetype s_bossshoot1          = {false,SPR_BOSS_SHOOT1,30,NULL,NULL,&s_bossshoot2};
statetype s_bossshoot2          = {false,SPR_BOSS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_bossshoot3};
statetype s_bossshoot3          = {false,SPR_BOSS_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_bossshoot4};
statetype s_bossshoot4          = {false,SPR_BOSS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_bossshoot5};
statetype s_bossshoot5          = {false,SPR_BOSS_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_bossshoot6};
statetype s_bossshoot6          = {false,SPR_BOSS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_bossshoot7};
statetype s_bossshoot7          = {false,SPR_BOSS_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_bossshoot8};
statetype s_bossshoot8          = {false,SPR_BOSS_SHOOT1,10,NULL,NULL,&s_bosschase1};


//
// gretel
//
extern  statetype s_gretelstand;

extern  statetype s_gretelchase1;
extern  statetype s_gretelchase1s;
extern  statetype s_gretelchase2;
extern  statetype s_gretelchase3;
extern  statetype s_gretelchase3s;
extern  statetype s_gretelchase4;

extern  statetype s_greteldie1;
extern  statetype s_greteldie2;
extern  statetype s_greteldie3;
extern  statetype s_greteldie4;

extern  statetype s_gretelshoot1;
extern  statetype s_gretelshoot2;
extern  statetype s_gretelshoot3;
extern  statetype s_gretelshoot4;
extern  statetype s_gretelshoot5;
extern  statetype s_gretelshoot6;
extern  statetype s_gretelshoot7;
extern  statetype s_gretelshoot8;


statetype s_gretelstand         = {false,SPR_GRETEL_W1,0,(statefunc)T_Stand,NULL,&s_gretelstand};

statetype s_gretelchase1        = {false,SPR_GRETEL_W1,10,(statefunc)T_Chase,NULL,&s_gretelchase1s};
statetype s_gretelchase1s       = {false,SPR_GRETEL_W1,3,NULL,NULL,&s_gretelchase2};
statetype s_gretelchase2        = {false,SPR_GRETEL_W2,8,(statefunc)T_Chase,NULL,&s_gretelchase3};
statetype s_gretelchase3        = {false,SPR_GRETEL_W3,10,(statefunc)T_Chase,NULL,&s_gretelchase3s};
statetype s_gretelchase3s       = {false,SPR_GRETEL_W3,3,NULL,NULL,&s_gretelchase4};
statetype s_gretelchase4        = {false,SPR_GRETEL_W4,8,(statefunc)T_Chase,NULL,&s_gretelchase1};

statetype s_greteldie1          = {false,SPR_GRETEL_DIE1,15,NULL,(statefunc)A_DeathScream,&s_greteldie2};
statetype s_greteldie2          = {false,SPR_GRETEL_DIE2,15,NULL,NULL,&s_greteldie3};
statetype s_greteldie3          = {false,SPR_GRETEL_DIE3,15,NULL,NULL,&s_greteldie4};
statetype s_greteldie4          = {false,SPR_GRETEL_DEAD,0,NULL,NULL,&s_greteldie4};

statetype s_gretelshoot1        = {false,SPR_GRETEL_SHOOT1,30,NULL,NULL,&s_gretelshoot2};
statetype s_gretelshoot2        = {false,SPR_GRETEL_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_gretelshoot3};
statetype s_gretelshoot3        = {false,SPR_GRETEL_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_gretelshoot4};
statetype s_gretelshoot4        = {false,SPR_GRETEL_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_gretelshoot5};
statetype s_gretelshoot5        = {false,SPR_GRETEL_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_gretelshoot6};
statetype s_gretelshoot6        = {false,SPR_GRETEL_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_gretelshoot7};
statetype s_gretelshoot7        = {false,SPR_GRETEL_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_gretelshoot8};
statetype s_gretelshoot8        = {false,SPR_GRETEL_SHOOT1,10,NULL,NULL,&s_gretelchase1};
#endif

/*
===============
=
= T_Done
=
===============
*/

void T_Done (objtype *)
{
    playstate = ex_victorious;                              // exit castle tile
}

/*
===============
=
= SpawnStand
=
===============
*/

void SpawnStand (enemy_t which, int tilex, int tiley, int dir)
{
    word *map;
    word tile;

    switch (which)
    {
        case en_guard:
            SpawnNewObj (tilex,tiley,&s_grdstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_tropper:
            SpawnNewObj (tilex,tiley,&s_grd2stand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_aflamer:
            SpawnNewObj (tilex,tiley,&s_afustand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_space:
            SpawnNewObj (tilex,tiley,&s_spcstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_slavegirl:
            SpawnNewObj (tilex,tiley,&s_slvstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
         case en_cult:
            SpawnNewObj (tilex,tiley,&s_culstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break; 
            
        case en_slorga:
            SpawnNewObj (tilex,tiley,&s_srastand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break; 
            
        case en_bflamer:
            SpawnNewObj (tilex,tiley,&s_bfustand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;  
            
          case en_sniper:
            SpawnNewObj (tilex,tiley,&s_snistand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break; 
            
        case en_hunter:
            SpawnNewObj (tilex,tiley,&s_shastand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break; 
            
        case en_reaper:
            SpawnNewObj (tilex,tiley,&s_rprstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_stealth:
            SpawnNewObj (tilex,tiley,&s_sthstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_rocketunit:
            SpawnNewObj (tilex,tiley,&s_rktstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_soulless:
            SpawnNewObj (tilex,tiley,&s_soustand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_shot:
            SpawnNewObj (tilex,tiley,&s_shtstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;

        case en_officer:
            SpawnNewObj (tilex,tiley,&s_ofcstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_vofficer:
            SpawnNewObj (tilex,tiley,&s_vofcstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;    

        case en_mutant:
            SpawnNewObj (tilex,tiley,&s_mutstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;

        case en_ss:
            SpawnNewObj (tilex,tiley,&s_ssstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_striker:
            SpawnNewObj (tilex,tiley,&s_sksstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }


    map = mapsegs[0]+(tiley<<mapshift)+tilex;
    tile = *map;
    if (tile == AMBUSHTILE)
    {
        tilemap[tilex][tiley] = 0;

        if (*(map+1) >= AREATILE)
            tile = *(map+1);
        if (*(map-mapwidth) >= AREATILE)
            tile = *(map-mapwidth);
        if (*(map+mapwidth) >= AREATILE)
            tile = *(map+mapwidth);
        if ( *(map-1) >= AREATILE)
            tile = *(map-1);

        *map = tile;
        newobj->areanumber = tile-AREATILE;

        newobj->flags |= FL_AMBUSH;
    }

    newobj->obclass = (classtype)(guardobj + which);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][which];
    newobj->dir = (dirtype)(dir * 2);
    newobj->flags |= FL_SHOOTABLE;
}



/*
===============
=
= SpawnDeadGuard
=
===============
*/

void SpawnDeadGuard (int tilex, int tiley)
{
    SpawnNewObj (tilex,tiley,&s_grddie4);
    DEMOIF_SDL
    {
        newobj->flags |= FL_NONMARK;    // walk through moving enemy fix
    }
    newobj->obclass = inertobj;
}



#ifndef SPEAR
/*
===============
=
= SpawnBoss
=
===============
*/

void SpawnBoss (int tilex, int tiley)
{
    SpawnNewObj (tilex,tiley,&s_bossstand);
    newobj->speed = SPDPATROL;

    newobj->obclass = bossobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_boss];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
        
}

/*
===============
=
= SpawnTropper
=
===============
*/

void SpawnTropper (enemy_t which, int tilex, int tiley, int dir)
{
    word *map;
    word tile;

    switch (which)
    {          
        case en_tropper:
            SpawnNewObj (tilex,tiley,&s_grd2stand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }


    map = mapsegs[0]+(tiley<<mapshift)+tilex;
    tile = *map;
    if (tile == AMBUSHTILE)
    {
        tilemap[tilex][tiley] = 0;

        if (*(map+1) >= AREATILE)
            tile = *(map+1);
        if (*(map-mapwidth) >= AREATILE)
            tile = *(map-mapwidth);
        if (*(map+mapwidth) >= AREATILE)
            tile = *(map+mapwidth);
        if ( *(map-1) >= AREATILE)
            tile = *(map-1);

        *map = tile;
        newobj->areanumber = tile-AREATILE;

        newobj->flags |= FL_AMBUSH;
    }

    newobj->obclass = (classtype)(tropperobj);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_tropper];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE;
}

/*
===============
=
= SpawnStriker
=
===============
*/

void SpawnStriker (enemy_t which, int tilex, int tiley, int dir)
{
    word *map;
    word tile;

    switch (which)
    {          
        case en_striker:
            SpawnNewObj (tilex,tiley,&s_sksstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }


    map = mapsegs[0]+(tiley<<mapshift)+tilex;
    tile = *map;
    if (tile == AMBUSHTILE)
    {
        tilemap[tilex][tiley] = 0;

        if (*(map+1) >= AREATILE)
            tile = *(map+1);
        if (*(map-mapwidth) >= AREATILE)
            tile = *(map-mapwidth);
        if (*(map+mapwidth) >= AREATILE)
            tile = *(map+mapwidth);
        if ( *(map-1) >= AREATILE)
            tile = *(map-1);

        *map = tile;
        newobj->areanumber = tile-AREATILE;

        newobj->flags |= FL_AMBUSH;
    }

    newobj->obclass = (classtype)(strikerobj);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_striker];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE;
}

/*
===============
=
= SpawnBFlamer
=
===============
*/

void SpawnBFlamer (enemy_t which, int tilex, int tiley, int dir)
{
    word *map;
    word tile;

    switch (which)
    {          
        case en_bflamer:
            SpawnNewObj (tilex,tiley,&s_bfustand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }


    map = mapsegs[0]+(tiley<<mapshift)+tilex;
    tile = *map;
    if (tile == AMBUSHTILE)
    {
        tilemap[tilex][tiley] = 0;

        if (*(map+1) >= AREATILE)
            tile = *(map+1);
        if (*(map-mapwidth) >= AREATILE)
            tile = *(map-mapwidth);
        if (*(map+mapwidth) >= AREATILE)
            tile = *(map+mapwidth);
        if ( *(map-1) >= AREATILE)
            tile = *(map-1);

        *map = tile;
        newobj->areanumber = tile-AREATILE;

        newobj->flags |= FL_AMBUSH;
    }

    newobj->obclass = (classtype)(bflamerobj);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_bflamer];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE;
}

/*
===============
=
= SpawnSlave
=
===============
*/

void SpawnSlave (enemy_t which, int tilex, int tiley, int dir)
{
    word *map;
    word tile;

    switch (which)
    {          
        case en_slavegirl:
            SpawnNewObj (tilex,tiley,&s_slvstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }


    map = mapsegs[0]+(tiley<<mapshift)+tilex;
    tile = *map;
    if (tile == AMBUSHTILE)
    {
        tilemap[tilex][tiley] = 0;

        if (*(map+1) >= AREATILE)
            tile = *(map+1);
        if (*(map-mapwidth) >= AREATILE)
            tile = *(map-mapwidth);
        if (*(map+mapwidth) >= AREATILE)
            tile = *(map+mapwidth);
        if ( *(map-1) >= AREATILE)
            tile = *(map-1);

        *map = tile;
        newobj->areanumber = tile-AREATILE;

        newobj->flags |= FL_AMBUSH;
    }

    newobj->obclass = (classtype)(slavegirlobj);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_slavegirl];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE;
}

/*
===============
=
= SpawnOfficer
=
===============
*/

void SpawnOfficer (enemy_t which, int tilex, int tiley, int dir)
{
    word *map;
    word tile;

    switch (which)
    {          
        case en_vofficer:
            SpawnNewObj (tilex,tiley,&s_vofcstand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }


    map = mapsegs[0]+(tiley<<mapshift)+tilex;
    tile = *map;
    if (tile == AMBUSHTILE)
    {
        tilemap[tilex][tiley] = 0;

        if (*(map+1) >= AREATILE)
            tile = *(map+1);
        if (*(map-mapwidth) >= AREATILE)
            tile = *(map-mapwidth);
        if (*(map+mapwidth) >= AREATILE)
            tile = *(map+mapwidth);
        if ( *(map-1) >= AREATILE)
            tile = *(map-1);

        *map = tile;
        newobj->areanumber = tile-AREATILE;

        newobj->flags |= FL_AMBUSH;
    }

    newobj->obclass = (classtype)(vofficerobj);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_vofficer];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE;
}

/*
===============
=
= SpawnAFlamer
=
===============
*/

void SpawnAFlamer (enemy_t which, int tilex, int tiley, int dir)
{
    word *map;
    word tile;

    switch (which)
    {          
        case en_aflamer:
            SpawnNewObj (tilex,tiley,&s_afustand);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }


    map = mapsegs[0]+(tiley<<mapshift)+tilex;
    tile = *map;
    if (tile == AMBUSHTILE)
    {
        tilemap[tilex][tiley] = 0;

        if (*(map+1) >= AREATILE)
            tile = *(map+1);
        if (*(map-mapwidth) >= AREATILE)
            tile = *(map-mapwidth);
        if (*(map+mapwidth) >= AREATILE)
            tile = *(map+mapwidth);
        if ( *(map-1) >= AREATILE)
            tile = *(map-1);

        *map = tile;
        newobj->areanumber = tile-AREATILE;

        newobj->flags |= FL_AMBUSH;
    }

    newobj->obclass = (classtype)(aflamerobj);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_aflamer];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE;
}

/*
===============
=
= SpawnGretel
=
===============
*/

void SpawnGretel (int tilex, int tiley)
{
    SpawnNewObj (tilex,tiley,&s_gretelstand);
    newobj->speed = SPDPATROL;

    newobj->obclass = gretelobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_gretel];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}
#endif

/*
===============
=
= SpawnPatrol
=
===============
*/

void SpawnPatrol (enemy_t which, int tilex, int tiley, int dir)
{
    switch (which)
    {
        case en_guard:
            SpawnNewObj (tilex,tiley,&s_grdpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_tropper:
            SpawnNewObj (tilex,tiley,&s_grd2path1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_cult:
            SpawnNewObj (tilex,tiley,&s_culpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;  
            
         case en_sniper:
            SpawnNewObj (tilex,tiley,&s_snipath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_slavegirl:
            SpawnNewObj (tilex,tiley,&s_slvpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_bflamer:
            SpawnNewObj (tilex,tiley,&s_bfupath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_aflamer:
            SpawnNewObj (tilex,tiley,&s_afupath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
         case en_hunter:
            SpawnNewObj (tilex,tiley,&s_shapath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_slorga:
            SpawnNewObj (tilex,tiley,&s_srapath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
          case en_reaper:
            SpawnNewObj (tilex,tiley,&s_rprpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
         case en_stealth:
            SpawnNewObj (tilex,tiley,&s_sthpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
        case en_rocketunit:
            SpawnNewObj (tilex,tiley,&s_rktpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
            
            case en_soulless:
            SpawnNewObj (tilex,tiley,&s_soupath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;
        
        case en_space:
            SpawnNewObj (tilex,tiley,&s_spcpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;

        case en_shot:
            SpawnNewObj (tilex,tiley,&s_shtpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
               gamestate.killtotal++;
            break;

        case en_officer:
            SpawnNewObj (tilex,tiley,&s_ofcpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_vofficer:
            SpawnNewObj (tilex,tiley,&s_vofcpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;

        case en_ss:
            SpawnNewObj (tilex,tiley,&s_sspath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
            
        case en_striker:
            SpawnNewObj (tilex,tiley,&s_skspath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;

        case en_mutant:
            SpawnNewObj (tilex,tiley,&s_mutpath1);
            newobj->speed = SPDPATROL;
            if (!loadedgame)
                gamestate.killtotal++;
            break;

        case en_dog:
            SpawnNewObj (tilex,tiley,&s_dogpath1);
            newobj->speed = SPDDOG;
            if (!loadedgame)
                gamestate.killtotal++;
            break;
    }

    newobj->obclass = (classtype)(guardobj+which);
    newobj->dir = (dirtype)(dir*2);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][which];
    newobj->distance = TILEGLOBAL;
    newobj->flags |= FL_SHOOTABLE;
    newobj->active = ac_yes;

    actorat[newobj->tilex][newobj->tiley] = NULL;           // don't use original spot

    switch (dir)
    {
        case 0:
            newobj->tilex++;
            break;
        case 1:
            newobj->tiley--;
            break;
        case 2:
            newobj->tilex--;
            break;
        case 3:
            newobj->tiley++;
            break;
    }

    actorat[newobj->tilex][newobj->tiley] = newobj;
}



/*
==================
=
= A_DeathScream
=
==================
*/

void A_DeathScream (objtype *ob)
{
#ifndef UPLOAD
#ifndef SPEAR
    if (mapon==9 && !US_RndT())
#else
    if ((mapon==18 || mapon==19) && !US_RndT())
#endif
    {
        switch(ob->obclass)
        {
            case mutantobj:
            case guardobj:
            case officerobj:
            case ssobj:
            case dogobj:
                PlaySoundLocActor(DEATHSCREAM6SND,ob);
                return;
        }
    }
#endif

    switch (ob->obclass)
    {
        case mutantobj:
            PlaySoundLocActor(AHHHGSND,ob);
            break;
            
            case spaceobj:
            PlaySoundLocActor(SHOTGUNDEATHSND,ob);
            break;

        case guardobj:
        {
            int sounds[9]={ DEATHSCREAM1SND,
                DEATHSCREAM2SND,
                DEATHSCREAM3SND,
#ifndef APOGEE_1_0
                DEATHSCREAM4SND,
                DEATHSCREAM5SND,
                DEATHSCREAM7SND,
                DEATHSCREAM8SND,
                DEATHSCREAM9SND
#endif
            };

#ifndef UPLOAD
            PlaySoundLocActor(sounds[US_RndT()%8],ob);
#else
            PlaySoundLocActor(sounds[US_RndT()%2],ob);
#endif
            break;
        }
            
             case tropperobj:
        {
            int sounds[9]={ DEATHSCREAM1SND,
                DEATHSCREAM2SND,
                DEATHSCREAM3SND,
#ifndef APOGEE_1_0
                DEATHSCREAM4SND,
                DEATHSCREAM5SND,
                DEATHSCREAM7SND,
                DEATHSCREAM8SND,
                DEATHSCREAM9SND
#endif
            };

#ifndef UPLOAD
            PlaySoundLocActor(sounds[US_RndT()%8],ob);
#else
            PlaySoundLocActor(sounds[US_RndT()%2],ob);
#endif
            break;
        }
            
        case slavegirlobj:
        {
            int sounds[7]={ SLAVEGIRLSCREAM1SND,
                SLAVEGIRLSCREAM2SND,
                SLAVEGIRLSCREAM3SND,
                SLAVEGIRLSCREAM4SND,
                SLAVEGIRLSCREAM5SND,
                SLAVEGIRLSCREAM6SND,
                SLAVEGIRLSCREAM7SND
            };

            PlaySoundLocActor(sounds[US_RndT()%6],ob);
            break;
        }
            
        case officerobj:
             {
            int sounds[3]={ NEINSOVASSND,
                NEINSOVAS1SND,
                NEINSOVAS2SND
            };

            PlaySoundLocActor(sounds[US_RndT()%2],ob);
            break;
        }
        case ssobj:
              {
            int sounds[3]={ LEBENSND,
                LEBEN1SND,
                LEBEN2SND
            };

            PlaySoundLocActor(sounds[US_RndT()%2],ob);
            break;
        }
        case vofficerobj:
              {
            int sounds[3]={ LEBENSND,
                LEBEN1SND,
                LEBEN2SND
            };

            PlaySoundLocActor(sounds[US_RndT()%2],ob);
            break;
        }
        case sniperobj:
              {
            int sounds[3]={ SNIDEATHSND,
                SNIDEATH1SND,
                SNIDEATH2SND
            };

            PlaySoundLocActor(sounds[US_RndT()%2],ob);
            break;
        }
        case dogobj:
            PlaySoundLocActor(DOGDEATHSND,ob);      // JAB
            break;
        case shotobj:
            PlaySoundLocActor(SHOTDEATHSND,ob);      // JAB
            break;
        case hunterobj:
            PlaySoundLocActor(HUNTERDEATHSND,ob);      // JAB
            break;
        case soullessobj:
            PlaySoundLocActor(SOULLESSDEATHSND,ob);      // JAB
            break;
        case stealthobj:
            PlaySoundLocActor(STEALTHDEATHSND,ob);      // JAB
            break;
        case bflamerobj:
            PlaySoundLocActor(BFLAMERDEATHSND,ob);      // JAB
            break;
        case rocketunitobj:
             {
            int sounds[3]={ ROCKETDEATH1SND,
                ROCKETDEATH2SND,
                ROCKETDEATH3SND
            };

            PlaySoundLocActor(sounds[US_RndT()%2],ob);
            break;
        }   
        case reaperobj:
             {
            int sounds[2]={ REAPERDEATH1SND,
                REAPERDEATH2SND
            };

            PlaySoundLocActor(sounds[US_RndT()%1],ob);
            break;
        } 
        case slorgaobj:
             {
            int sounds[2]={ SLORGADEATH1SND,
                SLORGADEATH2SND
            };

            PlaySoundLocActor(sounds[US_RndT()%1],ob);
            break;
        }
        case aflamerobj:
        case strikerobj:
             {
            int sounds[2]={ STRIKERDEATH1SND,
                STRIKERDEATH2SND
            };

            PlaySoundLocActor(sounds[US_RndT()%1],ob);
            break;
        }
        case cultobj:
              {
            int sounds[4]={ CULTDEATH1SND,
                CULTDEATH2SND,
                CULTDEATH3SND,
                CULTDEATH4SND
            };

            PlaySoundLocActor(sounds[US_RndT()%3],ob);
            break;
        }
#ifndef SPEAR
        case bossobj:
            SD_PlaySound(MUTTISND);                         // JAB
            break;
        case schabbobj:
            SD_PlaySound(MEINGOTTSND);
            break;
        case fakeobj:
            SD_PlaySound(HITLERHASND);
            break;
        case mechahitlerobj:
            SD_PlaySound(SCHEISTSND);
            break;
        case realhitlerobj:
            SD_PlaySound(EVASND);
            break;
#ifndef APOGEE_1_0
        case gretelobj:
            SD_PlaySound(MEINSND);
            break;
        case giftobj:
            SD_PlaySound(DONNERSND);
            break;
        case fatobj:
            SD_PlaySound(ROSESND);
            break;
#endif
#else
        case spectreobj:
            SD_PlaySound(GHOSTFADESND);
            break;
        case angelobj:
            SD_PlaySound(ANGELDEATHSND);
            break;
        case transobj:
            SD_PlaySound(TRANSDEATHSND);
            break;
        case uberobj:
            SD_PlaySound(UBERDEATHSND);
            break;
        case willobj:
            SD_PlaySound(WILHELMDEATHSND);
            break;
        case deathobj:
            SD_PlaySound(KNIGHTDEATHSND);
            break;
#endif
    }
}


/*
=============================================================================

                                SPEAR ACTORS

=============================================================================
*/

#ifdef SPEAR

void T_Launch (objtype *ob);
void T_Will (objtype *ob);

extern  statetype s_angelshoot1;
extern  statetype s_deathshoot1;
extern  statetype s_spark1;

//
// trans
//
extern  statetype s_transstand;

extern  statetype s_transchase1;
extern  statetype s_transchase1s;
extern  statetype s_transchase2;
extern  statetype s_transchase3;
extern  statetype s_transchase3s;
extern  statetype s_transchase4;

extern  statetype s_transdie0;
extern  statetype s_transdie01;
extern  statetype s_transdie1;
extern  statetype s_transdie2;
extern  statetype s_transdie3;
extern  statetype s_transdie4;

extern  statetype s_transshoot1;
extern  statetype s_transshoot2;
extern  statetype s_transshoot3;
extern  statetype s_transshoot4;
extern  statetype s_transshoot5;
extern  statetype s_transshoot6;
extern  statetype s_transshoot7;
extern  statetype s_transshoot8;


statetype s_transstand          = {false,SPR_TRANS_W1,0,(statefunc)T_Stand,NULL,&s_transstand};

statetype s_transchase1         = {false,SPR_TRANS_W1,10,(statefunc)T_Chase,NULL,&s_transchase1s};
statetype s_transchase1s        = {false,SPR_TRANS_W1,3,NULL,NULL,&s_transchase2};
statetype s_transchase2         = {false,SPR_TRANS_W2,8,(statefunc)T_Chase,NULL,&s_transchase3};
statetype s_transchase3         = {false,SPR_TRANS_W3,10,(statefunc)T_Chase,NULL,&s_transchase3s};
statetype s_transchase3s        = {false,SPR_TRANS_W3,3,NULL,NULL,&s_transchase4};
statetype s_transchase4         = {false,SPR_TRANS_W4,8,(statefunc)T_Chase,NULL,&s_transchase1};

statetype s_transdie0           = {false,SPR_TRANS_W1,1,NULL,(statefunc)A_DeathScream,&s_transdie01};
statetype s_transdie01          = {false,SPR_TRANS_W1,1,NULL,NULL,&s_transdie1};
statetype s_transdie1           = {false,SPR_TRANS_DIE1,15,NULL,NULL,&s_transdie2};
statetype s_transdie2           = {false,SPR_TRANS_DIE2,15,NULL,NULL,&s_transdie3};
statetype s_transdie3           = {false,SPR_TRANS_DIE3,15,NULL,NULL,&s_transdie4};
statetype s_transdie4           = {false,SPR_TRANS_DEAD,0,NULL,NULL,&s_transdie4};

statetype s_transshoot1         = {false,SPR_TRANS_SHOOT1,30,NULL,NULL,&s_transshoot2};
statetype s_transshoot2         = {false,SPR_TRANS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_transshoot3};
statetype s_transshoot3         = {false,SPR_TRANS_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_transshoot4};
statetype s_transshoot4         = {false,SPR_TRANS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_transshoot5};
statetype s_transshoot5         = {false,SPR_TRANS_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_transshoot6};
statetype s_transshoot6         = {false,SPR_TRANS_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_transshoot7};
statetype s_transshoot7         = {false,SPR_TRANS_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_transshoot8};
statetype s_transshoot8         = {false,SPR_TRANS_SHOOT1,10,NULL,NULL,&s_transchase1};


/*
===============
=
= SpawnTrans
=
===============
*/

void SpawnTrans (int tilex, int tiley)
{
    //        word *map;
    //        word tile;

    if (SoundBlasterPresent && DigiMode != sds_Off)
        s_transdie01.tictime = 105;

    SpawnNewObj (tilex,tiley,&s_transstand);
    newobj->obclass = transobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_trans];
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


//
// uber
//
void T_UShoot (objtype *ob);

extern  statetype s_uberstand;

extern  statetype s_uberchase1;
extern  statetype s_uberchase1s;
extern  statetype s_uberchase2;
extern  statetype s_uberchase3;
extern  statetype s_uberchase3s;
extern  statetype s_uberchase4;

extern  statetype s_uberdie0;
extern  statetype s_uberdie01;
extern  statetype s_uberdie1;
extern  statetype s_uberdie2;
extern  statetype s_uberdie3;
extern  statetype s_uberdie4;
extern  statetype s_uberdie5;

extern  statetype s_ubershoot1;
extern  statetype s_ubershoot2;
extern  statetype s_ubershoot3;
extern  statetype s_ubershoot4;
extern  statetype s_ubershoot5;
extern  statetype s_ubershoot6;
extern  statetype s_ubershoot7;


statetype s_uberstand           = {false,SPR_UBER_W1,0,(statefunc)T_Stand,NULL,&s_uberstand};

statetype s_uberchase1          = {false,SPR_UBER_W1,10,(statefunc)T_Chase,NULL,&s_uberchase1s};
statetype s_uberchase1s         = {false,SPR_UBER_W1,3,NULL,NULL,&s_uberchase2};
statetype s_uberchase2          = {false,SPR_UBER_W2,8,(statefunc)T_Chase,NULL,&s_uberchase3};
statetype s_uberchase3          = {false,SPR_UBER_W3,10,(statefunc)T_Chase,NULL,&s_uberchase3s};
statetype s_uberchase3s         = {false,SPR_UBER_W3,3,NULL,NULL,&s_uberchase4};
statetype s_uberchase4          = {false,SPR_UBER_W4,8,(statefunc)T_Chase,NULL,&s_uberchase1};

statetype s_uberdie0            = {false,SPR_UBER_W1,1,NULL,(statefunc)A_DeathScream,&s_uberdie01};
statetype s_uberdie01           = {false,SPR_UBER_W1,1,NULL,NULL,&s_uberdie1};
statetype s_uberdie1            = {false,SPR_UBER_DIE1,15,NULL,NULL,&s_uberdie2};
statetype s_uberdie2            = {false,SPR_UBER_DIE2,15,NULL,NULL,&s_uberdie3};
statetype s_uberdie3            = {false,SPR_UBER_DIE3,15,NULL,NULL,&s_uberdie4};
statetype s_uberdie4            = {false,SPR_UBER_DIE4,15,NULL,NULL,&s_uberdie5};
statetype s_uberdie5            = {false,SPR_UBER_DEAD,0,NULL,NULL,&s_uberdie5};

statetype s_ubershoot1          = {false,SPR_UBER_SHOOT1,30,NULL,NULL,&s_ubershoot2};
statetype s_ubershoot2          = {false,SPR_UBER_SHOOT2,12,NULL,(statefunc)T_UShoot,&s_ubershoot3};
statetype s_ubershoot3          = {false,SPR_UBER_SHOOT3,12,NULL,(statefunc)T_UShoot,&s_ubershoot4};
statetype s_ubershoot4          = {false,SPR_UBER_SHOOT4,12,NULL,(statefunc)T_UShoot,&s_ubershoot5};
statetype s_ubershoot5          = {false,SPR_UBER_SHOOT3,12,NULL,(statefunc)T_UShoot,&s_ubershoot6};
statetype s_ubershoot6          = {false,SPR_UBER_SHOOT2,12,NULL,(statefunc)T_UShoot,&s_ubershoot7};
statetype s_ubershoot7          = {false,SPR_UBER_SHOOT1,12,NULL,NULL,&s_uberchase1};


/*
===============
=
= SpawnUber
=
===============
*/

void SpawnUber (int tilex, int tiley)
{
    if (SoundBlasterPresent && DigiMode != sds_Off)
        s_uberdie01.tictime = 70;

    SpawnNewObj (tilex,tiley,&s_uberstand);
    newobj->obclass = uberobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_uber];
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
===============
=
= T_UShoot
=
===============
*/

void T_UShoot (objtype *ob)
{
    int     dx,dy,dist;

    T_Shoot (ob);

    dx = abs(ob->tilex - player->tilex);
    dy = abs(ob->tiley - player->tiley);
    dist = dx>dy ? dx : dy;
    if (dist <= 1)
        TakeDamage (10,ob);
}


//
// will
//
extern  statetype s_willstand;

extern  statetype s_willchase1;
extern  statetype s_willchase1s;
extern  statetype s_willchase2;
extern  statetype s_willchase3;
extern  statetype s_willchase3s;
extern  statetype s_willchase4;

extern  statetype s_willdie1;
extern  statetype s_willdie2;
extern  statetype s_willdie3;
extern  statetype s_willdie4;
extern  statetype s_willdie5;
extern  statetype s_willdie6;

extern  statetype s_willshoot1;
extern  statetype s_willshoot2;
extern  statetype s_willshoot3;
extern  statetype s_willshoot4;
extern  statetype s_willshoot5;
extern  statetype s_willshoot6;


statetype s_willstand           = {false,SPR_WILL_W1,0,(statefunc)T_Stand,NULL,&s_willstand};

statetype s_willchase1          = {false,SPR_WILL_W1,10,(statefunc)T_Will,NULL,&s_willchase1s};
statetype s_willchase1s         = {false,SPR_WILL_W1,3,NULL,NULL,&s_willchase2};
statetype s_willchase2          = {false,SPR_WILL_W2,8,(statefunc)T_Will,NULL,&s_willchase3};
statetype s_willchase3          = {false,SPR_WILL_W3,10,(statefunc)T_Will,NULL,&s_willchase3s};
statetype s_willchase3s         = {false,SPR_WILL_W3,3,NULL,NULL,&s_willchase4};
statetype s_willchase4          = {false,SPR_WILL_W4,8,(statefunc)T_Will,NULL,&s_willchase1};

statetype s_willdeathcam        = {false,SPR_WILL_W1,1,NULL,NULL,&s_willdie1};

statetype s_willdie1            = {false,SPR_WILL_W1,1,NULL,(statefunc)A_DeathScream,&s_willdie2};
statetype s_willdie2            = {false,SPR_WILL_W1,10,NULL,NULL,&s_willdie3};
statetype s_willdie3            = {false,SPR_WILL_DIE1,10,NULL,NULL,&s_willdie4};
statetype s_willdie4            = {false,SPR_WILL_DIE2,10,NULL,NULL,&s_willdie5};
statetype s_willdie5            = {false,SPR_WILL_DIE3,10,NULL,NULL,&s_willdie6};
statetype s_willdie6            = {false,SPR_WILL_DEAD,20,NULL,NULL,&s_willdie6};

statetype s_willshoot1          = {false,SPR_WILL_SHOOT1,30,NULL,NULL,&s_willshoot2};
statetype s_willshoot2          = {false,SPR_WILL_SHOOT2,10,NULL,(statefunc)T_Launch,&s_willshoot3};
statetype s_willshoot3          = {false,SPR_WILL_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_willshoot4};
statetype s_willshoot4          = {false,SPR_WILL_SHOOT4,10,NULL,(statefunc)T_Shoot,&s_willshoot5};
statetype s_willshoot5          = {false,SPR_WILL_SHOOT3,10,NULL,(statefunc)T_Shoot,&s_willshoot6};
statetype s_willshoot6          = {false,SPR_WILL_SHOOT4,10,NULL,(statefunc)T_Shoot,&s_willchase1};


/*
===============
=
= SpawnWill
=
===============
*/

void SpawnWill (int tilex, int tiley)
{
    if (SoundBlasterPresent && DigiMode != sds_Off)
        s_willdie2.tictime = 70;

    SpawnNewObj (tilex,tiley,&s_willstand);
    newobj->obclass = willobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_will];
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
================
=
= T_Will
=
================
*/

void T_Will (objtype *ob)
{
    int32_t move;
    int     dx,dy,dist;
    boolean dodge;

    dodge = false;
    dx = abs(ob->tilex - player->tilex);
    dy = abs(ob->tiley - player->tiley);
    dist = dx>dy ? dx : dy;

    if (CheckLine(ob))                                              // got a shot at player?
    {
        ob->hidden = false;
        if ( (int) US_RndT() < (tics<<3) && objfreelist)
        {
            //
            // go into attack frame
            //
            if (ob->obclass == willobj)
                NewState (ob,&s_willshoot1);
            else if (ob->obclass == angelobj)
                NewState (ob,&s_angelshoot1);
            else
                NewState (ob,&s_deathshoot1);
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            TryWalk(ob);
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dist <4)
            SelectRunDir (ob);
        else if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

}


//
// death
//
extern  statetype s_deathstand;

extern  statetype s_deathchase1;
extern  statetype s_deathchase1s;
extern  statetype s_deathchase2;
extern  statetype s_deathchase3;
extern  statetype s_deathchase3s;
extern  statetype s_deathchase4;

extern  statetype s_deathdie1;
extern  statetype s_deathdie2;
extern  statetype s_deathdie3;
extern  statetype s_deathdie4;
extern  statetype s_deathdie5;
extern  statetype s_deathdie6;
extern  statetype s_deathdie7;
extern  statetype s_deathdie8;
extern  statetype s_deathdie9;

extern  statetype s_deathshoot1;
extern  statetype s_deathshoot2;
extern  statetype s_deathshoot3;
extern  statetype s_deathshoot4;
extern  statetype s_deathshoot5;


statetype s_deathstand          = {false,SPR_DEATH_W1,0,(statefunc)T_Stand,NULL,&s_deathstand};

statetype s_deathchase1         = {false,SPR_DEATH_W1,10,(statefunc)T_Will,NULL,&s_deathchase1s};
statetype s_deathchase1s        = {false,SPR_DEATH_W1,3,NULL,NULL,&s_deathchase2};
statetype s_deathchase2         = {false,SPR_DEATH_W2,8,(statefunc)T_Will,NULL,&s_deathchase3};
statetype s_deathchase3         = {false,SPR_DEATH_W3,10,(statefunc)T_Will,NULL,&s_deathchase3s};
statetype s_deathchase3s        = {false,SPR_DEATH_W3,3,NULL,NULL,&s_deathchase4};
statetype s_deathchase4         = {false,SPR_DEATH_W4,8,(statefunc)T_Will,NULL,&s_deathchase1};

statetype s_deathdeathcam       = {false,SPR_DEATH_W1,1,NULL,NULL,&s_deathdie1};

statetype s_deathdie1           = {false,SPR_DEATH_W1,1,NULL,(statefunc)A_DeathScream,&s_deathdie2};
statetype s_deathdie2           = {false,SPR_DEATH_W1,10,NULL,NULL,&s_deathdie3};
statetype s_deathdie3           = {false,SPR_DEATH_DIE1,10,NULL,NULL,&s_deathdie4};
statetype s_deathdie4           = {false,SPR_DEATH_DIE2,10,NULL,NULL,&s_deathdie5};
statetype s_deathdie5           = {false,SPR_DEATH_DIE3,10,NULL,NULL,&s_deathdie6};
statetype s_deathdie6           = {false,SPR_DEATH_DIE4,10,NULL,NULL,&s_deathdie7};
statetype s_deathdie7           = {false,SPR_DEATH_DIE5,10,NULL,NULL,&s_deathdie8};
statetype s_deathdie8           = {false,SPR_DEATH_DIE6,10,NULL,NULL,&s_deathdie9};
statetype s_deathdie9           = {false,SPR_DEATH_DEAD,0,NULL,NULL,&s_deathdie9};

statetype s_deathshoot1         = {false,SPR_DEATH_SHOOT1,30,NULL,NULL,&s_deathshoot2};
statetype s_deathshoot2         = {false,SPR_DEATH_SHOOT2,10,NULL,(statefunc)T_Launch,&s_deathshoot3};
statetype s_deathshoot3         = {false,SPR_DEATH_SHOOT4,10,NULL,(statefunc)T_Shoot,&s_deathshoot4};
statetype s_deathshoot4         = {false,SPR_DEATH_SHOOT3,10,NULL,(statefunc)T_Launch,&s_deathshoot5};
statetype s_deathshoot5         = {false,SPR_DEATH_SHOOT4,10,NULL,(statefunc)T_Shoot,&s_deathchase1};


/*
===============
=
= SpawnDeath
=
===============
*/

void SpawnDeath (int tilex, int tiley)
{
    if (SoundBlasterPresent && DigiMode != sds_Off)
        s_deathdie2.tictime = 105;

    SpawnNewObj (tilex,tiley,&s_deathstand);
    newobj->obclass = deathobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_death];
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}

/*
===============
=
= T_Launch
=
===============
*/

void T_Launch (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2 ((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);
    if (ob->obclass == deathobj)
    {
        T_Shoot (ob);
        if (ob->state == &s_deathshoot2)
        {
            iangle-=4;
            if (iangle<0)
                iangle+=ANGLES;
        }
        else
        {
            iangle+=4;
            if (iangle>=ANGLES)
                iangle-=ANGLES;
        }
    }

    GetNewActor ();
    newobj->state = &s_rocket;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = rocketobj;
    switch(ob->obclass)
    {
        case soullessobj:
            newobj->state = &s_hrocket;
            newobj->obclass = hrocketobj;
            PlaySoundLocActor (SOULLESSBALLSND,newobj);
            break;
        default:
            PlaySoundLocActor (MISSILEFIRESND,newobj);
    }

    newobj->dir = nodir;
    newobj->angle = iangle;
    newobj->speed = 0x2000l;
    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;
}



//
// angel
//
void A_Relaunch (objtype *ob);
void A_Victory (objtype *ob);
void A_StartAttack (objtype *ob);
void A_Breathing (objtype *ob);

extern  statetype s_angelstand;

extern  statetype s_angelchase1;
extern  statetype s_angelchase1s;
extern  statetype s_angelchase2;
extern  statetype s_angelchase3;
extern  statetype s_angelchase3s;
extern  statetype s_angelchase4;

extern  statetype s_angeldie1;
extern  statetype s_angeldie11;
extern  statetype s_angeldie2;
extern  statetype s_angeldie3;
extern  statetype s_angeldie4;
extern  statetype s_angeldie5;
extern  statetype s_angeldie6;
extern  statetype s_angeldie7;
extern  statetype s_angeldie8;
extern  statetype s_angeldie9;

extern  statetype s_angelshoot1;
extern  statetype s_angelshoot2;
extern  statetype s_angelshoot3;
extern  statetype s_angelshoot4;
extern  statetype s_angelshoot5;
extern  statetype s_angelshoot6;

extern  statetype s_angeltired;
extern  statetype s_angeltired2;
extern  statetype s_angeltired3;
extern  statetype s_angeltired4;
extern  statetype s_angeltired5;
extern  statetype s_angeltired6;
extern  statetype s_angeltired7;

extern  statetype s_spark1;
extern  statetype s_spark2;
extern  statetype s_spark3;
extern  statetype s_spark4;


statetype s_angelstand          = {false,SPR_ANGEL_W1,0,(statefunc)T_Stand,NULL,&s_angelstand};

statetype s_angelchase1         = {false,SPR_ANGEL_W1,10,(statefunc)T_Will,NULL,&s_angelchase1s};
statetype s_angelchase1s        = {false,SPR_ANGEL_W1,3,NULL,NULL,&s_angelchase2};
statetype s_angelchase2         = {false,SPR_ANGEL_W2,8,(statefunc)T_Will,NULL,&s_angelchase3};
statetype s_angelchase3         = {false,SPR_ANGEL_W3,10,(statefunc)T_Will,NULL,&s_angelchase3s};
statetype s_angelchase3s        = {false,SPR_ANGEL_W3,3,NULL,NULL,&s_angelchase4};
statetype s_angelchase4         = {false,SPR_ANGEL_W4,8,(statefunc)T_Will,NULL,&s_angelchase1};

statetype s_angeldie1           = {false,SPR_ANGEL_W1,1,NULL,null,&s_angeldie2};
statetype s_angeldie11          = {false,SPR_ANGEL_W1,1,NULL,NULL,&s_angeldie2};
statetype s_angeldie2           = {false,SPR_ANGEL_DIE1,10,NULL,(statefunc)A_Slurpie2,&s_angeldie3};
statetype s_angeldie3           = {false,SPR_ANGEL_DIE2,10,NULL,(statefunc)A_StartAttack,&s_angeldie4};
statetype s_angeldie4           = {false,SPR_ANGEL_DIE3,10,NULL,NULL,&s_angeldie5};
statetype s_angeldie5           = {false,SPR_ANGEL_DIE4,10,NULL,NULL,&s_angeldie6};
statetype s_angeldie6           = {false,SPR_ANGEL_DIE5,10,NULL,NULL,&s_angeldie7};
statetype s_angeldie7           = {false,SPR_ANGEL_DIE6,10,NULL,NULL,&s_angeldie8};
statetype s_angeldie8           = {false,SPR_ANGEL_DIE7,10,NULL,NULL,&s_angeldie9};
statetype s_angeldie9           = {false,SPR_ANGEL_DEAD,130,NULL,NULL,&s_angeldie9};

statetype s_angelshoot1         = {false,SPR_ANGEL_SHOOT1,10,NULL,(statefunc)A_StartAttack,&s_angelshoot2};
statetype s_angelshoot2         = {false,SPR_ANGEL_SHOOT2,20,NULL,(statefunc)T_Launch,&s_angelshoot3};
statetype s_angelshoot3         = {false,SPR_ANGEL_SHOOT1,10,NULL,(statefunc)A_Relaunch,&s_angelshoot2};

statetype s_angeltired          = {false,SPR_ANGEL_TIRED1,40,NULL,(statefunc)A_Breathing,&s_angeltired2};
statetype s_angeltired2         = {false,SPR_ANGEL_TIRED2,40,NULL,NULL,&s_angeltired3};
statetype s_angeltired3         = {false,SPR_ANGEL_TIRED1,40,NULL,(statefunc)A_Breathing,&s_angeltired4};
statetype s_angeltired4         = {false,SPR_ANGEL_TIRED2,40,NULL,NULL,&s_angeltired5};
statetype s_angeltired5         = {false,SPR_ANGEL_TIRED1,40,NULL,(statefunc)A_Breathing,&s_angeltired6};
statetype s_angeltired6         = {false,SPR_ANGEL_TIRED2,40,NULL,NULL,&s_angeltired7};
statetype s_angeltired7         = {false,SPR_ANGEL_TIRED1,40,NULL,(statefunc)A_Breathing,&s_angelchase1};

statetype s_spark1              = {false,SPR_SPARK1,6,(statefunc)T_Projectile,NULL,&s_spark2};
statetype s_spark2              = {false,SPR_SPARK2,6,(statefunc)T_Projectile,NULL,&s_spark3};
statetype s_spark3              = {false,SPR_SPARK3,6,(statefunc)T_Projectile,NULL,&s_spark4};
statetype s_spark4              = {false,SPR_SPARK4,6,(statefunc)T_Projectile,NULL,&s_spark1};

#pragma argsused
void A_Slurpie (objtype *)
{
    SD_PlaySound(SLURPIESND);
}

#pragma argsused
void A_Burn (objtype *)
{
            SD_PlaySound(BURNSND);
}

#pragma argsused
void A_Slurpie2 (objtype *)
{
    SD_PlaySound(MISSILEHITSND);
}

#pragma argsused
void A_Breathing (objtype *)
{
    SD_PlaySound(ANGELTIREDSND);
}

/*
===============
=
= SpawnAngel
=
===============
*/

void SpawnAngel (int tilex, int tiley)
{
    if (SoundBlasterPresent && DigiMode != sds_Off)
        s_angeldie11.tictime = 105;

    SpawnNewObj (tilex,tiley,&s_angelstand);
    newobj->obclass = angelobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_angel];
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
//    if (!loadedgame)
//        gamestate.killtotal++;
}


/*
=================
=
= A_Victory
=
=================
*/

void A_Victory (objtype *)
{
    playstate = ex_victorious;
}

/*
=================
=
= A_Relaunch
=
=================
*/

void A_Relaunch (objtype *ob)
{
    if (++ob->temp1 == 3)
    {
        NewState (ob,&s_angeltired);
        return;
    }

    if (US_RndT()&1)
    {
        NewState (ob,&s_angelchase1);
        return;
    }
}




//
// spectre
//
void T_SpectreWait (objtype *ob);
void A_Dormant (objtype *ob);

extern  statetype s_spectrewait1;
extern  statetype s_spectrewait2;
extern  statetype s_spectrewait3;
extern  statetype s_spectrewait4;

extern  statetype s_spectrechase1;
extern  statetype s_spectrechase2;
extern  statetype s_spectrechase3;
extern  statetype s_spectrechase4;

extern  statetype s_spectredie1;
extern  statetype s_spectredie2;
extern  statetype s_spectredie3;
extern  statetype s_spectredie4;

extern  statetype s_spectrewake;

statetype s_spectrewait1        = {false,SPR_SPECTRE_W1,10,(statefunc)T_Stand,NULL,&s_spectrewait2};
statetype s_spectrewait2        = {false,SPR_SPECTRE_W2,10,(statefunc)T_Stand,NULL,&s_spectrewait3};
statetype s_spectrewait3        = {false,SPR_SPECTRE_W3,10,(statefunc)T_Stand,NULL,&s_spectrewait4};
statetype s_spectrewait4        = {false,SPR_SPECTRE_W4,10,(statefunc)T_Stand,NULL,&s_spectrewait1};

statetype s_spectrechase1       = {false,SPR_SPECTRE_W1,10,(statefunc)T_Ghosts,NULL,&s_spectrechase2};
statetype s_spectrechase2       = {false,SPR_SPECTRE_W2,10,(statefunc)T_Ghosts,NULL,&s_spectrechase3};
statetype s_spectrechase3       = {false,SPR_SPECTRE_W3,10,(statefunc)T_Ghosts,NULL,&s_spectrechase4};
statetype s_spectrechase4       = {false,SPR_SPECTRE_W4,10,(statefunc)T_Ghosts,NULL,&s_spectrechase1};

statetype s_spectredie1         = {false,SPR_SPECTRE_F1,10,NULL,NULL,&s_spectredie2};
statetype s_spectredie2         = {false,SPR_SPECTRE_F2,10,NULL,NULL,&s_spectredie3};
statetype s_spectredie3         = {false,SPR_SPECTRE_F3,10,NULL,NULL,&s_spectredie4};
statetype s_spectredie4         = {false,SPR_SPECTRE_F4,300,NULL,NULL,&s_spectrewake};
statetype s_spectrewake         = {false,SPR_SPECTRE_F4,10,NULL,(statefunc)A_Dormant,&s_spectrewake};

/*
===============
=
= SpawnSpectre
=
===============
*/

void SpawnSpectre (int tilex, int tiley)
{
    SpawnNewObj (tilex,tiley,&s_spectrewait1);
    newobj->obclass = spectreobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_spectre];
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH|FL_BONUS; // |FL_NEVERMARK|FL_NONMARK;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
===============
=
= A_Dormant
=
===============
*/

void A_Dormant (objtype *ob)
{
    int32_t     deltax,deltay;
    int         xl,xh,yl,yh;
    int         x,y;
    uintptr_t   tile;

    deltax = ob->x - player->x;
    if (deltax < -MINACTORDIST || deltax > MINACTORDIST)
        goto moveok;
    deltay = ob->y - player->y;
    if (deltay < -MINACTORDIST || deltay > MINACTORDIST)
        goto moveok;

    return;
moveok:

    xl = (ob->x-MINDIST) >> TILESHIFT;
    xh = (ob->x+MINDIST) >> TILESHIFT;
    yl = (ob->y-MINDIST) >> TILESHIFT;
    yh = (ob->y+MINDIST) >> TILESHIFT;

    for (y=yl ; y<=yh ; y++)
        for (x=xl ; x<=xh ; x++)
        {
            tile = (uintptr_t)actorat[x][y];
            if (!tile)
                continue;
            if (!ISPOINTER(tile))
                return;
            if (((objtype *)tile)->flags&FL_SHOOTABLE)
                return;
        }

        ob->flags |= FL_AMBUSH | FL_SHOOTABLE;
        ob->flags &= ~FL_ATTACKMODE;
        ob->flags &= ~FL_NONMARK;      // stuck bugfix 1
        ob->dir = nodir;
        NewState (ob,&s_spectrewait1);
}


#endif

/*
=============================================================================

                            SCHABBS / GIFT / FAT

=============================================================================
*/

#ifndef SPEAR
/*
===============
=
= SpawnGhosts
=
===============
*/

void SpawnGhosts (int which, int tilex, int tiley)
{
    switch(which)
    {
        case en_blinky:
            SpawnNewObj (tilex,tiley,&s_blinkychase1);
            break;
        case en_clyde:
            SpawnNewObj (tilex,tiley,&s_clydechase1);
            break;
        case en_pinky:
            SpawnNewObj (tilex,tiley,&s_pinkychase1);
            break;
        case en_inky:
            SpawnNewObj (tilex,tiley,&s_inkychase1);
            break;
    }

    newobj->obclass = ghostobj;
    newobj->speed = SPDDOG;

    newobj->dir = east;
    newobj->flags |= FL_AMBUSH;
    if (!loadedgame)
    {
        gamestate.killtotal++;
        gamestate.killcount++;
    }
}



void    T_Gift (objtype *ob);
void    T_GiftThrow (objtype *ob);
void    T_GiftThrow2 (objtype *ob);

void    T_Fat (objtype *ob);
void    T_FatThrow (objtype *ob);

//
// schabb
//
extern  statetype s_schabbstand;

extern  statetype s_schabbchase1;
extern  statetype s_schabbchase1s;
extern  statetype s_schabbchase2;
extern  statetype s_schabbchase3;
extern  statetype s_schabbchase3s;
extern  statetype s_schabbchase4;

extern  statetype s_schabbdie1;
extern  statetype s_schabbdie2;
extern  statetype s_schabbdie3;
extern  statetype s_schabbdie4;
extern  statetype s_schabbdie5;
extern  statetype s_schabbdie6;

extern  statetype s_schabbshoot1;
extern  statetype s_schabbshoot2;
extern  statetype s_schabbshoot3;
extern  statetype s_schabbshoot4;
extern  statetype s_schabbshoot5;
extern  statetype s_schabbshoot6;
extern  statetype s_schabbshoot7;

extern  statetype s_needle1;
extern  statetype s_needle2;
extern  statetype s_needle3;
extern  statetype s_needle4;

extern  statetype s_schabbdeathcam;


statetype s_schabbstand         = {false,SPR_SCHABB_W1,0,(statefunc)T_Stand,NULL,&s_schabbstand};

statetype s_schabbchase1        = {false,SPR_SCHABB_W1,10,(statefunc)T_Schabb,NULL,&s_schabbchase1s};
statetype s_schabbchase1s       = {false,SPR_SCHABB_W1,3,NULL,NULL,&s_schabbchase2};
statetype s_schabbchase2        = {false,SPR_SCHABB_W2,8,(statefunc)T_Schabb,NULL,&s_schabbchase3};
statetype s_schabbchase3        = {false,SPR_SCHABB_W3,10,(statefunc)T_Schabb,NULL,&s_schabbchase3s};
statetype s_schabbchase3s       = {false,SPR_SCHABB_W3,3,NULL,NULL,&s_schabbchase4};
statetype s_schabbchase4        = {false,SPR_SCHABB_W4,8,(statefunc)T_Schabb,NULL,&s_schabbchase1};

statetype s_schabbdeathcam      = {false,SPR_SCHABB_W1,1,NULL,NULL,&s_schabbdie1};

statetype s_schabbdie1          = {false,SPR_SCHABB_W1,10,NULL,(statefunc)A_DeathScream,&s_schabbdie2};
statetype s_schabbdie2          = {false,SPR_SCHABB_W1,10,NULL,NULL,&s_schabbdie3};
statetype s_schabbdie3          = {false,SPR_SCHABB_DIE1,10,NULL,NULL,&s_schabbdie4};
statetype s_schabbdie4          = {false,SPR_SCHABB_DIE2,10,NULL,NULL,&s_schabbdie5};
statetype s_schabbdie5          = {false,SPR_SCHABB_DIE3,10,NULL,NULL,&s_schabbdie6};
statetype s_schabbdie6          = {false,SPR_SCHABB_DEAD,20,NULL,NULL,&s_schabbdie6};

statetype s_schabbshoot1        = {false,SPR_SCHABB_W1,30,NULL,NULL,&s_schabbshoot2};
statetype s_schabbshoot2        = {false,SPR_SCHABB_SHOOT1,10,NULL,(statefunc)T_Shoot,&s_schabbshoot3};
statetype s_schabbshoot3        = {false,SPR_SCHABB_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_schabbshoot4};
statetype s_schabbshoot4        = {false,SPR_SCHABB_SHOOT1,10,NULL,(statefunc)T_Shoot,&s_schabbshoot5};
statetype s_schabbshoot5        = {false,SPR_SCHABB_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_schabbshoot6};
statetype s_schabbshoot6        = {false,SPR_SCHABB_SHOOT1,10,NULL,(statefunc)T_Shoot,&s_schabbshoot7};
statetype s_schabbshoot7        = {false,SPR_SCHABB_SHOOT2,10,NULL,(statefunc)T_Shoot,&s_schabbchase1};

statetype s_needle1             = {false,SPR_HYPO1,6,(statefunc)T_Projectile,NULL,&s_needle2};
statetype s_needle2             = {false,SPR_HYPO2,6,(statefunc)T_Projectile,NULL,&s_needle3};
statetype s_needle3             = {false,SPR_HYPO3,6,(statefunc)T_Projectile,NULL,&s_needle4};
statetype s_needle4             = {false,SPR_HYPO4,6,(statefunc)T_Projectile,NULL,&s_needle1};



//
// gift
//
extern  statetype s_giftstand;

extern  statetype s_giftchase1;
extern  statetype s_giftchase1s;
extern  statetype s_giftchase2;
extern  statetype s_giftchase3;
extern  statetype s_giftchase3s;
extern  statetype s_giftchase4;

extern  statetype s_giftdie1;
extern  statetype s_giftdie2;
extern  statetype s_giftdie3;
extern  statetype s_giftdie4;
extern  statetype s_giftdie5;
extern  statetype s_giftdie6;

extern  statetype s_giftshoot1;
extern  statetype s_giftshoot2;

extern  statetype s_needle1;
extern  statetype s_needle2;
extern  statetype s_needle3;
extern  statetype s_needle4;

extern  statetype s_giftdeathcam;

extern  statetype s_boom1;
extern  statetype s_boom2;
extern  statetype s_boom3;

extern  statetype s_dboom1;
extern  statetype s_dboom2;
extern  statetype s_dboom3;

extern  statetype s_boom11;
extern  statetype s_boom12;
extern  statetype s_boom13;
extern  statetype s_boom14;

extern  statetype s_boom21;
extern  statetype s_boom22;
extern  statetype s_boom23;

extern  statetype s_boom31;
extern  statetype s_boom32;
extern  statetype s_boom33;

extern  statetype s_boom41;
extern  statetype s_boom42;
extern  statetype s_boom43;
extern  statetype s_boom44;


statetype s_giftstand           = {false,SPR_GIFT_W1,0,(statefunc)T_Stand,NULL,&s_giftstand};

statetype s_giftchase1          = {false,SPR_GIFT_W1,10,(statefunc)T_Gift,NULL,&s_giftchase1s};
statetype s_giftchase1s         = {false,SPR_GIFT_W1,3,NULL,NULL,&s_giftchase2};
statetype s_giftchase2          = {false,SPR_GIFT_W2,8,(statefunc)T_Gift,NULL,&s_giftchase3};
statetype s_giftchase3          = {false,SPR_GIFT_W3,10,(statefunc)T_Gift,NULL,&s_giftchase3s};
statetype s_giftchase3s         = {false,SPR_GIFT_W3,3,NULL,NULL,&s_giftchase4};
statetype s_giftchase4          = {false,SPR_GIFT_W4,8,(statefunc)T_Gift,NULL,&s_giftchase1};

statetype s_giftdeathcam        = {false,SPR_GIFT_W1,1,NULL,NULL,&s_giftdie1};

statetype s_giftdie1            = {false,SPR_GIFT_W1,1,NULL,(statefunc)A_DeathScream,&s_giftdie2};
statetype s_giftdie2            = {false,SPR_GIFT_W1,10,NULL,NULL,&s_giftdie3};
statetype s_giftdie3            = {false,SPR_GIFT_DIE1,10,NULL,NULL,&s_giftdie4};
statetype s_giftdie4            = {false,SPR_GIFT_DIE2,10,NULL,NULL,&s_giftdie5};
statetype s_giftdie5            = {false,SPR_GIFT_DIE3,10,NULL,NULL,&s_giftdie6};
statetype s_giftdie6            = {false,SPR_GIFT_DEAD,20,NULL,NULL,&s_giftdie6};

statetype s_giftshoot1          = {false,SPR_GIFT_SHOOT1,30,NULL,NULL,&s_giftshoot2};
statetype s_giftshoot2          = {false,SPR_GIFT_SHOOT2,10,NULL,(statefunc)T_GiftThrow2,&s_giftchase1};


//
// fat
//
extern  statetype s_fatstand;

extern  statetype s_fatchase1;
extern  statetype s_fatchase1s;
extern  statetype s_fatchase2;
extern  statetype s_fatchase3;
extern  statetype s_fatchase3s;
extern  statetype s_fatchase4;

extern  statetype s_fatdie1;
extern  statetype s_fatdie2;
extern  statetype s_fatdie3;
extern  statetype s_fatdie4;
extern  statetype s_fatdie5;
extern  statetype s_fatdie6;

extern  statetype s_fatshoot1;
extern  statetype s_fatshoot2;
extern  statetype s_fatshoot3;
extern  statetype s_fatshoot4;
extern  statetype s_fatshoot5;
extern  statetype s_fatshoot6;

extern  statetype s_needle1;
extern  statetype s_needle2;
extern  statetype s_needle3;
extern  statetype s_needle4;

extern  statetype s_fatdeathcam;


statetype s_fatstand            = {false,SPR_FAT_W1,0,(statefunc)T_Stand,NULL,&s_fatstand};

statetype s_fatchase1           = {false,SPR_FAT_W1,10,(statefunc)T_Fat,NULL,&s_fatchase1s};
statetype s_fatchase1s          = {false,SPR_FAT_W1,3,NULL,NULL,&s_fatchase2};
statetype s_fatchase2           = {false,SPR_FAT_W2,8,(statefunc)T_Fat,NULL,&s_fatchase3};
statetype s_fatchase3           = {false,SPR_FAT_W3,10,(statefunc)T_Fat,NULL,&s_fatchase3s};
statetype s_fatchase3s          = {false,SPR_FAT_W3,3,NULL,NULL,&s_fatchase4};
statetype s_fatchase4           = {false,SPR_FAT_W4,8,(statefunc)T_Fat,NULL,&s_fatchase1};

statetype s_fatdeathcam         = {false,SPR_FAT_W1,1,NULL,NULL,&s_fatdie1};

statetype s_fatdie1             = {false,SPR_FAT_W1,1,NULL,(statefunc)A_DeathScream,&s_fatdie2};
statetype s_fatdie2             = {false,SPR_FAT_W1,10,NULL,NULL,&s_fatdie3};
statetype s_fatdie3             = {false,SPR_FAT_DIE1,10,NULL,NULL,&s_fatdie4};
statetype s_fatdie4             = {false,SPR_FAT_DIE2,10,NULL,NULL,&s_fatdie5};
statetype s_fatdie5             = {false,SPR_FAT_DIE3,10,NULL,NULL,&s_fatdie6};
statetype s_fatdie6             = {false,SPR_FAT_DEAD,20,NULL,NULL,&s_fatdie6};

statetype s_fatshoot1           = {false,SPR_FAT_SHOOT1,30,NULL,NULL,&s_fatshoot2};
statetype s_fatshoot2           = {false,SPR_FAT_SHOOT2,10,NULL,(statefunc)T_Ball,&s_fatshoot3};
statetype s_fatshoot3           = {false,SPR_FAT_SHOOT3,10,NULL,(statefunc)T_Ball,&s_fatshoot4};
statetype s_fatshoot4           = {false,SPR_FAT_SHOOT4,10,NULL,(statefunc)T_Ball,&s_fatshoot5};
statetype s_fatshoot5           = {false,SPR_FAT_SHOOT3,10,NULL,(statefunc)T_Ball,&s_fatshoot6};
statetype s_fatshoot6           = {false,SPR_FAT_SHOOT4,10,NULL,(statefunc)T_Ball,&s_fatchase1};


/*
===============
=
= SpawnSchabbs
=
===============
*/

void SpawnSchabbs (int tilex, int tiley)
{
        s_schabbdie2.tictime = 1;

    SpawnNewObj (tilex,tiley,&s_schabbstand);
    newobj->speed = SPDPATROL;

    newobj->obclass = schabbobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_schabbs];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
===============
=
= SpawnGift
=
===============
*/

void SpawnGift (int tilex, int tiley)
{
        s_giftdie2.tictime = 1;

    SpawnNewObj (tilex,tiley,&s_giftstand);
    newobj->speed = SPDPATROL;

    newobj->obclass = giftobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_gift];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
===============
=
= SpawnFat
=
===============
*/

void SpawnFat (int tilex, int tiley)
{
        s_fatdie2.tictime = 1;

    SpawnNewObj (tilex,tiley,&s_fatstand);
    newobj->speed = SPDPATROL;

    newobj->obclass = fatobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_fat];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
=================
=
= T_SchabbThrow
=
=================
*/

void T_SchabbThrow (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);

    GetNewActor ();
    newobj->state = &s_needle1;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = needleobj;
    newobj->dir = nodir;
    newobj->angle = iangle;
    newobj->speed = 0x2000l;

    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;

    PlaySoundLocActor (SCHABBSTHROWSND,newobj);
}


/*
=================
=
= T_GiftThrow
=
=================
*/

void T_GiftThrow (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);

    GetNewActor ();
    newobj->state = &s_rocket;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = rocketobj;
    newobj->dir = nodir;
    newobj->angle = iangle;
    newobj->speed = 0x2000l;
    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;

#ifndef APOGEE_1_0          // T_GiftThrow will never be called in shareware v1.0
    PlaySoundLocActor (ATKBIZONSND,newobj);
#endif
}

/*
=================
=
= T_GiftThrow2
=
=================
*/

void T_GiftThrow2 (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);

    GetNewActor ();
    newobj->state = &s_drocket;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = drocketobj;
    newobj->dir = nodir;
    newobj->angle = iangle;
    newobj->speed = 0x2000l;
    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;

#ifndef APOGEE_1_0          // T_GiftThrow will never be called in shareware v1.0
    PlaySoundLocActor (ATKBIZONSND,newobj);
#endif
}

/*
=================
=
= T_Gasball
=
=================
*/

void T_Gasball (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);

    GetNewActor ();
    newobj->state = &s_gasball;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->obclass = gasballobj;
    newobj->dir = nodir;
    newobj->angle = iangle;
    newobj->speed = 0x2000l;
    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;

#ifndef APOGEE_1_0          // T_GiftThrow will never be called in shareware v1.0
    PlaySoundLocActor (GASBALLSND,newobj);
#endif
}


/*
=================
=
= T_Schabb
=
=================
*/

void T_Schabb (objtype *ob)
{
    int32_t move;
    int     dx,dy,dist;
    boolean dodge;

    dodge = false;
    dx = abs(ob->tilex - player->tilex);
    dy = abs(ob->tiley - player->tiley);
    dist = dx>dy ? dx : dy;

    if (CheckLine(ob))                                              // got a shot at player?
    {
        ob->hidden = false;
        if ( (int) US_RndT() < (tics<<3) && objfreelist)
        {
            //
            // go into attack frame
            //
            NewState (ob,&s_schabbshoot1);
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            TryWalk(ob);
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dist <4)
            SelectRunDir (ob);
        else if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}


/*
=================
=
= T_Gift
=
=================
*/

void T_Gift (objtype *ob)
{
    int32_t move;
    int     dx,dy,dist;
    boolean dodge;

    dodge = false;
    dx = abs(ob->tilex - player->tilex);
    dy = abs(ob->tiley - player->tiley);
    dist = dx>dy ? dx : dy;

    if (CheckLine(ob))                                              // got a shot at player?
    {
        ob->hidden = false;
        if ( (int) US_RndT() < (tics<<3) && objfreelist)
        {
            //
            // go into attack frame
            //
            NewState (ob,&s_giftshoot1);
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            TryWalk(ob);
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dist <4)
            SelectRunDir (ob);
        else if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}


/*
=================
=
= T_Fat
=
=================
*/

void T_Fat (objtype *ob)
{
    int32_t move;
    int     dx,dy,dist;
    boolean dodge;

    dodge = false;
    dx = abs(ob->tilex - player->tilex);
    dy = abs(ob->tiley - player->tiley);
    dist = dx>dy ? dx : dy;

    if (CheckLine(ob))                                              // got a shot at player?
    {
        ob->hidden = false;
        if ( (int) US_RndT() < (tics<<3) && objfreelist)
        {
            //
            // go into attack frame
            //
            NewState (ob,&s_fatshoot1);
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            TryWalk(ob);
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dist <4)
            SelectRunDir (ob);
        else if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}


/*
=============================================================================

                                    HITLERS

=============================================================================
*/


//
// fake
//
extern  statetype s_fakestand;

extern  statetype s_fakechase1;
extern  statetype s_fakechase1s;
extern  statetype s_fakechase2;
extern  statetype s_fakechase3;
extern  statetype s_fakechase3s;
extern  statetype s_fakechase4;

extern  statetype s_fakedie1;
extern  statetype s_fakedie2;
extern  statetype s_fakedie3;
extern  statetype s_fakedie4;
extern  statetype s_fakedie5;
extern  statetype s_fakedie6;

extern  statetype s_fakeshoot1;
extern  statetype s_fakeshoot2;
extern  statetype s_fakeshoot3;
extern  statetype s_fakeshoot4;
extern  statetype s_fakeshoot5;
extern  statetype s_fakeshoot6;
extern  statetype s_fakeshoot7;
extern  statetype s_fakeshoot8;
extern  statetype s_fakeshoot9;

extern  statetype s_fakeshoot11;
extern  statetype s_fakeshoot12;
extern  statetype s_fakeshoot13;
extern  statetype s_fakeshoot14;
extern  statetype s_fakeshoot15;
extern  statetype s_fakeshoot16;
extern  statetype s_fakeshoot17;
extern  statetype s_fakeshoot18;
extern  statetype s_fakeshoot19;

extern  statetype s_fakeshoot21;
extern  statetype s_fakeshoot22;
extern  statetype s_fakeshoot23;
extern  statetype s_fakeshoot24;
extern  statetype s_fakeshoot25;
extern  statetype s_fakeshoot26;
extern  statetype s_fakeshoot27;
extern  statetype s_fakeshoot28;
extern  statetype s_fakeshoot29;

extern  statetype s_fire1;
extern  statetype s_fire2;

statetype s_fakestand           = {false,SPR_FAKE_W1,0,(statefunc)T_Stand,NULL,&s_fakestand};

statetype s_fakechase1          = {false,SPR_FAKE_W1,10,(statefunc)T_Fake,NULL,&s_fakechase1s};
statetype s_fakechase1s         = {false,SPR_FAKE_W1,3,(statefunc)T_Fake1,NULL,&s_fakechase2};
statetype s_fakechase2          = {false,SPR_FAKE_W2,8,(statefunc)T_Fake2,NULL,&s_fakechase3};
statetype s_fakechase3          = {false,SPR_FAKE_W3,10,(statefunc)T_Fake,NULL,&s_fakechase3s};
statetype s_fakechase3s         = {false,SPR_FAKE_W3,3,(statefunc)T_Fake1,NULL,&s_fakechase4};
statetype s_fakechase4          = {false,SPR_FAKE_W4,8,(statefunc)T_Fake2,NULL,&s_fakechase1};

statetype s_fakedie1            = {false,SPR_FAKE_DIE1,10,NULL,(statefunc)A_DeathScream,&s_fakedie2};
statetype s_fakedie2            = {false,SPR_FAKE_DIE2,10,NULL,NULL,&s_fakedie3};
statetype s_fakedie3            = {false,SPR_FAKE_DIE3,10,NULL,NULL,&s_fakedie4};
statetype s_fakedie4            = {false,SPR_FAKE_DIE4,10,NULL,NULL,&s_fakedie5};
statetype s_fakedie5            = {false,SPR_FAKE_DIE5,10,NULL,NULL,&s_fakedie6};
statetype s_fakedie6            = {false,SPR_FAKE_DEAD,0,NULL,NULL,&s_fakedie6};

statetype s_fakeshoot1          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot2};
statetype s_fakeshoot2          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot3};
statetype s_fakeshoot3          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot4};
statetype s_fakeshoot4          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot5};
statetype s_fakeshoot5          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot6};
statetype s_fakeshoot6          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot7};
statetype s_fakeshoot7          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot8};
statetype s_fakeshoot8          = {false,SPR_FAKE_SHOOT,8,NULL,(statefunc)T_FakeFire,&s_fakeshoot9};
statetype s_fakeshoot9          = {false,SPR_FAKE_SHOOT,8,NULL,NULL,&s_fakechase1};

statetype s_fakeshoot11          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot12};
statetype s_fakeshoot12          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot13};
statetype s_fakeshoot13          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot14};
statetype s_fakeshoot14          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot15};
statetype s_fakeshoot15          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot16};
statetype s_fakeshoot16          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot17};
statetype s_fakeshoot17          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot18};
statetype s_fakeshoot18          = {false,SPR_FAKE_SHOOT1,8,NULL,(statefunc)T_Shadowball,&s_fakeshoot19};
statetype s_fakeshoot19          = {false,SPR_FAKE_SHOOT1,8,NULL,NULL,&s_fakechase1};

statetype s_fakeshoot21          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot22};
statetype s_fakeshoot22          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot23};
statetype s_fakeshoot23          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot24};
statetype s_fakeshoot24          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot25};
statetype s_fakeshoot25          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot26};
statetype s_fakeshoot26          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot27};
statetype s_fakeshoot27          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot28};
statetype s_fakeshoot28          = {false,SPR_FAKE_SHOOT2,8,NULL,(statefunc)T_Shadowball3,&s_fakeshoot29};
statetype s_fakeshoot29          = {false,SPR_FAKE_SHOOT2,8,NULL,NULL,&s_fakechase1};

statetype s_fire1               = {false,SPR_FIRE1,6,NULL,(statefunc)T_Projectile,&s_fire2};
statetype s_fire2               = {false,SPR_FIRE2,6,NULL,(statefunc)T_Projectile,&s_fire1};

//
// hitler
//
extern  statetype s_mechachase1;
extern  statetype s_mechachase1s;
extern  statetype s_mechachase2;
extern  statetype s_mechachase3;
extern  statetype s_mechachase3s;
extern  statetype s_mechachase4;

extern  statetype s_mechadie1;
extern  statetype s_mechadie2;
extern  statetype s_mechadie3;
extern  statetype s_mechadie4;

extern  statetype s_mechashoot1;
extern  statetype s_mechashoot2;
extern  statetype s_mechashoot3;
extern  statetype s_mechashoot4;
extern  statetype s_mechashoot5;
extern  statetype s_mechashoot6;
extern  statetype s_mechashoot7;
extern  statetype s_mechashoot8;
extern  statetype s_mechashoot9;
extern  statetype s_mechashoot10;

extern  statetype s_mechashoot11;
extern  statetype s_mechashoot12;
extern  statetype s_mechashoot13;
extern  statetype s_mechashoot14;
extern  statetype s_mechashoot15;
extern  statetype s_mechashoot16;
extern  statetype s_mechashoot17;
extern  statetype s_mechashoot18;
extern  statetype s_mechashoot19;
extern  statetype s_mechashoot20;

extern  statetype s_hitlerchase1;
extern  statetype s_hitlerchase1s;
extern  statetype s_hitlerchase2;
extern  statetype s_hitlerchase3;
extern  statetype s_hitlerchase3s;
extern  statetype s_hitlerchase4;

extern  statetype s_hitlerdie1;
extern  statetype s_hitlerdie2;
extern  statetype s_hitlerdie3;
extern  statetype s_hitlerdie4;
extern  statetype s_hitlerdie5;
extern  statetype s_hitlerdie6;
extern  statetype s_hitlerdie7;
extern  statetype s_hitlerdie8;
extern  statetype s_hitlerdie9;
extern  statetype s_hitlerdie10;

extern  statetype s_hitlershoot1;
extern  statetype s_hitlershoot2;
extern  statetype s_hitlershoot3;
extern  statetype s_hitlershoot4;
extern  statetype s_hitlershoot5;
extern  statetype s_hitlershoot6;
extern  statetype s_hitlershoot7;
extern  statetype s_hitlershoot8;
extern  statetype s_hitlershoot9;
extern  statetype s_hitlershoot10;

extern  statetype s_hitlershoot11;
extern  statetype s_hitlershoot12;
extern  statetype s_hitlershoot13;
extern  statetype s_hitlershoot14;
extern  statetype s_hitlershoot15;
extern  statetype s_hitlershoot16;
extern  statetype s_hitlershoot17;
extern  statetype s_hitlershoot18;
extern  statetype s_hitlershoot19;
extern  statetype s_hitlershoot20;

extern  statetype s_hitlerdeathcam;

statetype s_mechastand          = {false,SPR_MECHA_W1,0,(statefunc)T_Stand,NULL,&s_mechastand};

statetype s_mechachase1         = {false,SPR_MECHA_W1,10,(statefunc)T_Chase,NULL,&s_mechachase1s};
statetype s_mechachase1s        = {false,SPR_MECHA_W1,6,(statefunc)T_DraculaChase,NULL,&s_mechachase2};
statetype s_mechachase2         = {false,SPR_MECHA_W2,8,(statefunc)T_Chase,NULL,&s_mechachase3};
statetype s_mechachase3         = {false,SPR_MECHA_W3,10,(statefunc)T_DraculaChase,NULL,&s_mechachase3s};
statetype s_mechachase3s        = {false,SPR_MECHA_W3,6,(statefunc)T_Chase,NULL,&s_mechachase4};
statetype s_mechachase4         = {false,SPR_MECHA_W4,8,(statefunc)T_DraculaChase,NULL,&s_mechachase1};

statetype s_mechadie1           = {false,SPR_MECHA_DIE1,10,NULL,(statefunc)A_DeathScream,&s_mechadie2};
statetype s_mechadie2           = {false,SPR_MECHA_DIE2,10,NULL,NULL,&s_mechadie3};
statetype s_mechadie3           = {false,SPR_MECHA_DIE3,10,NULL,(statefunc)A_HitlerMorph,&s_mechadie4};
statetype s_mechadie4           = {false,SPR_MECHA_DEAD,0,NULL,NULL,&s_mechadie4};

statetype s_mechashoot1         = {false,SPR_MECHA_SHOOT1,30,NULL,NULL,&s_mechashoot2};
statetype s_mechashoot2         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot3};
statetype s_mechashoot3         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot4};
statetype s_mechashoot4         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot5};
statetype s_mechashoot5         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot6};
statetype s_mechashoot6         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot7};
statetype s_mechashoot7         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot8};
statetype s_mechashoot8         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot9};
statetype s_mechashoot9         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Shadowball2,&s_mechashoot10};
statetype s_mechashoot10         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Shadowball2,&s_mechachase1};

statetype s_mechashoot11         = {false,SPR_MECHA_SHOOT1,30,NULL,NULL,&s_mechashoot12};
statetype s_mechashoot12         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Launch,&s_mechashoot13};
statetype s_mechashoot13         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Launch,&s_mechashoot14};
statetype s_mechashoot14         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Launch,&s_mechashoot15};
statetype s_mechashoot15         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Launch,&s_mechashoot16};
statetype s_mechashoot16         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Launch,&s_mechashoot17};
statetype s_mechashoot17         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Launch,&s_mechashoot18};
statetype s_mechashoot18         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Launch,&s_mechashoot19};
statetype s_mechashoot19         = {false,SPR_MECHA_SHOOT3,10,NULL,(statefunc)T_Launch,&s_mechashoot20};
statetype s_mechashoot20         = {false,SPR_MECHA_SHOOT2,10,NULL,(statefunc)T_Launch,&s_mechachase1};


statetype s_hitlerchase1        = {false,SPR_HITLER_W1,6,(statefunc)T_Chase,NULL,&s_hitlerchase1s};
statetype s_hitlerchase1s       = {false,SPR_HITLER_W1,4,(statefunc)T_DeathChase,NULL,&s_hitlerchase2};
statetype s_hitlerchase2        = {false,SPR_HITLER_W2,2,(statefunc)T_Chase,NULL,&s_hitlerchase3};
statetype s_hitlerchase3        = {false,SPR_HITLER_W3,6,(statefunc)T_DeathChase,NULL,&s_hitlerchase3s};
statetype s_hitlerchase3s       = {false,SPR_HITLER_W3,4,(statefunc)T_Chase,NULL,&s_hitlerchase4};
statetype s_hitlerchase4        = {false,SPR_HITLER_W4,2,(statefunc)T_DeathChase,NULL,&s_hitlerchase1};

statetype s_hitlerdeathcam      = {false,SPR_HITLER_W1,10,NULL,NULL,&s_hitlerdie1};

statetype s_hitlerdie1          = {false,SPR_HITLER_W1,1,NULL,(statefunc)A_DeathScream,&s_hitlerdie2};
statetype s_hitlerdie2          = {false,SPR_HITLER_W1,10,NULL,NULL,&s_hitlerdie3};
statetype s_hitlerdie3          = {false,SPR_HITLER_DIE1,10,NULL,NULL,&s_hitlerdie4};
statetype s_hitlerdie4          = {false,SPR_HITLER_DIE2,10,NULL,NULL,&s_hitlerdie5};
statetype s_hitlerdie5          = {false,SPR_HITLER_DIE3,10,NULL,NULL,&s_hitlerdie6};
statetype s_hitlerdie6          = {false,SPR_HITLER_DIE4,10,NULL,NULL,&s_hitlerdie7};
statetype s_hitlerdie7          = {false,SPR_HITLER_DIE5,10,NULL,NULL,&s_hitlerdie8};
statetype s_hitlerdie8          = {false,SPR_HITLER_DIE6,10,NULL,NULL,&s_hitlerdie9};
statetype s_hitlerdie9          = {false,SPR_HITLER_DIE7,10,NULL,NULL,&s_hitlerdie10};
statetype s_hitlerdie10         = {false,SPR_HITLER_DEAD,0,NULL,NULL,&s_hitlerdie10};

statetype s_hitlershoot1        = {false,SPR_HITLER_SHOOT1,30,NULL,NULL,&s_hitlershoot2};
statetype s_hitlershoot2        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Gasball,&s_hitlershoot3};
statetype s_hitlershoot3        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Gasball,&s_hitlershoot4};
statetype s_hitlershoot4        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Gasball,&s_hitlershoot5};
statetype s_hitlershoot5        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Gasball,&s_hitlershoot6};
statetype s_hitlershoot6        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Gasball,&s_hitlershoot7};
statetype s_hitlershoot7        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Gasball,&s_hitlershoot8};
statetype s_hitlershoot8        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Gasball,&s_hitlershoot9};
statetype s_hitlershoot9        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Gasball,&s_hitlershoot10};
statetype s_hitlershoot10        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Gasball,&s_hitlerchase1};

statetype s_hitlershoot11        = {false,SPR_HITLER_SHOOT1,30,NULL,NULL,&s_hitlershoot12};
statetype s_hitlershoot12        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Shadowball,&s_hitlershoot13};
statetype s_hitlershoot13        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Shadowball2,&s_hitlershoot14};
statetype s_hitlershoot14        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Shadowball3,&s_hitlershoot15};
statetype s_hitlershoot15        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Shadowball,&s_hitlershoot16};
statetype s_hitlershoot16        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Shadowball2,&s_hitlershoot17};
statetype s_hitlershoot17        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Shadowball3,&s_hitlershoot18};
statetype s_hitlershoot18        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Shadowball,&s_hitlershoot19};
statetype s_hitlershoot19        = {false,SPR_HITLER_SHOOT3,10,NULL,(statefunc)T_Shadowball2,&s_hitlershoot20};
statetype s_hitlershoot20        = {false,SPR_HITLER_SHOOT2,10,NULL,(statefunc)T_Shadowball3,&s_hitlerchase1};



/*
===============
=
= SpawnFakeHitler
=
===============
*/

void SpawnFakeHitler (int tilex, int tiley)
{
        s_hitlerdie2.tictime = 5;

    SpawnNewObj (tilex,tiley,&s_fakestand);
    newobj->speed = SPDPATROL;

    newobj->obclass = fakeobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_fake];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
===============
=
= SpawnHitler
=
===============
*/

void SpawnHitler (int tilex, int tiley)
{

        s_hitlerdie2.tictime = 5;


    SpawnNewObj (tilex,tiley,&s_mechastand);
    newobj->speed = SPDPATROL;

    newobj->obclass = mechahitlerobj;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][en_hitler];
    newobj->dir = nodir;
    newobj->flags |= FL_SHOOTABLE|FL_AMBUSH;
    if (!loadedgame)
        gamestate.killtotal++;
}


/*
===============
=
= A_HitlerMorph
=
===============
*/

void A_HitlerMorph (objtype *ob)
{
    short hitpoints[4]={6500,6700,6800,6900};

    SpawnNewObj (ob->tilex,ob->tiley,&s_hitlerchase1);
    newobj->speed = SPDPATROL*5;

    newobj->x = ob->x;
    newobj->y = ob->y;

    newobj->distance = ob->distance;
    newobj->dir = ob->dir;
    newobj->flags = ob->flags | FL_SHOOTABLE;
    newobj->flags &= ~FL_NONMARK;   // hitler stuck with nodir fix

    newobj->obclass = realhitlerobj;
    newobj->hitpoints = hitpoints[gamestate.difficulty];
}


////////////////////////////////////////////////////////
//
// A_MechaSound
// A_Slurpie
//
////////////////////////////////////////////////////////
void A_MechaSound (objtype *ob)
{
    if (areabyplayer[ob->areanumber])
        PlaySoundLocActor (MECHSTEPSND,ob);
}

void A_Slurpie (objtype *)
{
    SD_PlaySound(SLURPIESND);
}

void A_Burn (objtype *)
{
    SD_PlaySound(BURNSND);
}

void A_Slurpie2 (objtype *)
{
    SD_PlaySound(MISSILEHITSND);
}

/*
=================
=
= T_FakeFire
=
=================
*/

void T_FakeFire (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    if (!objfreelist)       // stop shooting if over MAXACTORS
    {      
        NewState (ob,&s_fakechase1);
        return;
    }

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float)(M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);

    GetNewActor ();
    newobj->state = &s_fire1;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->dir = nodir;
    newobj->angle = iangle;
    newobj->obclass = fireobj;
    newobj->speed = 0x2000l;
    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;

    PlaySoundLocActor (FLAMETHROWERSND,newobj);
}



/*
=================
=
= T_Fake
=
=================
*/

void T_Fake (objtype *ob)
{
    int32_t move;

    if (CheckLine(ob))                      // got a shot at player?
    {
        ob->hidden = false;
        if ( (int) US_RndT() < (tics<<1) && objfreelist)
        {
            NewState (ob,&s_fakeshoot1);

        }
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        SelectDodgeDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        SelectDodgeDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

/*
=================
=
= T_Fake1
=
=================
*/

void T_Fake1 (objtype *ob)
{
    int32_t move;

    if (CheckLine(ob))                      // got a shot at player?
    {
        ob->hidden = false;
        if ( (int) US_RndT() < (tics<<1) && objfreelist)
        {
            NewState (ob,&s_fakeshoot11);

        }
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        SelectDodgeDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        SelectDodgeDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

/*
=================
=
= T_Fake2
=
=================
*/

void T_Fake2 (objtype *ob)
{
    int32_t move;

    if (CheckLine(ob))                      // got a shot at player?
    {
        ob->hidden = false;
        if ( (int) US_RndT() < (tics<<1) && objfreelist)
        {
            NewState (ob,&s_fakeshoot21);

        }
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        SelectDodgeDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        SelectDodgeDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

#endif
/*
============================================================================

STAND

============================================================================
*/


/*
===============
=
= T_Stand
=
===============
*/

void T_Stand (objtype *ob)
{
    SightPlayer (ob);
}


/*
============================================================================

CHASE

============================================================================
*/

/*
=================
=
= T_DraculaChase
=
=================
*/

void T_DraculaChase (objtype *ob)
{
    int32_t move,target;
    int     dx,dy,dist,chance;
    boolean dodge;

    if (gamestate.victoryflag)
        return;

    dodge = false;
    if (CheckLine(ob))      // got a shot at player?
    {
        ob->hidden = false;
        dx = abs(ob->tilex - player->tilex);
        dy = abs(ob->tiley - player->tiley);
        dist = dx>dy ? dx : dy;

#ifdef PLAYDEMOLIKEORIGINAL
        if(DEMOCOND_ORIG)
        {
            if(!dist || (dist == 1 && ob->distance < 0x4000))
                chance = 300;
            else
                chance = (tics<<4)/dist;
        }
        else
#endif
        {
            if (dist)
                chance = (tics<<4)/dist;
            else
                chance = 300;

            if (dist == 1)
            {
                target = abs(ob->x - player->x);
                if (target < 0x14000l)
                {
                    target = abs(ob->y - player->y);
                    if (target < 0x14000l)
                        chance = 300;
                }
            }
        }

        if ( US_RndT()<chance)
        {
            switch (ob->obclass)
            {
                case mechahitlerobj:
                    NewState (ob,&s_mechashoot11);
                    break;
            }
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            DEMOIF_SDL
            {
                TryWalk(ob);
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

/*
=================
=
= T_DeathChase
=
=================
*/

void T_DeathChase (objtype *ob)
{
    int32_t move,target;
    int     dx,dy,dist,chance;
    boolean dodge;

    if (gamestate.victoryflag)
        return;

    dodge = false;
    if (CheckLine(ob))      // got a shot at player?
    {
        ob->hidden = false;
        dx = abs(ob->tilex - player->tilex);
        dy = abs(ob->tiley - player->tiley);
        dist = dx>dy ? dx : dy;

#ifdef PLAYDEMOLIKEORIGINAL
        if(DEMOCOND_ORIG)
        {
            if(!dist || (dist == 1 && ob->distance < 0x4000))
                chance = 300;
            else
                chance = (tics<<4)/dist;
        }
        else
#endif
        {
            if (dist)
                chance = (tics<<4)/dist;
            else
                chance = 300;

            if (dist == 1)
            {
                target = abs(ob->x - player->x);
                if (target < 0x14000l)
                {
                    target = abs(ob->y - player->y);
                    if (target < 0x14000l)
                        chance = 300;
                }
            }
        }

        if ( US_RndT()<chance)
        {
            switch (ob->obclass)
            {
                case realhitlerobj:
                    NewState (ob,&s_hitlershoot11);
                    break;
            }
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            DEMOIF_SDL
            {
                TryWalk(ob);
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

/*
=================
=
= T_Chase
=
=================
*/

void T_Chase (objtype *ob)
{
    int32_t move,target;
    int     dx,dy,dist,chance;
    boolean dodge;

    if (gamestate.victoryflag)
        return;

    dodge = false;
    if (CheckLine(ob))      // got a shot at player?
    {
        ob->hidden = false;
        dx = abs(ob->tilex - player->tilex);
        dy = abs(ob->tiley - player->tiley);
        dist = dx>dy ? dx : dy;

#ifdef PLAYDEMOLIKEORIGINAL
        if(DEMOCOND_ORIG)
        {
            if(!dist || (dist == 1 && ob->distance < 0x4000))
                chance = 300;
            else
                chance = (tics<<4)/dist;
        }
        else
#endif
        {
            if (dist)
                chance = (tics<<4)/dist;
            else
                chance = 300;

            if (dist == 1)
            {
                target = abs(ob->x - player->x);
                if (target < 0x14000l)
                {
                    target = abs(ob->y - player->y);
                    if (target < 0x14000l)
                        chance = 300;
                }
            }
        }

        if ( US_RndT()<chance)
        {
            //
            // go into attack frame
            //
            switch (ob->obclass)
            {
                case guardobj:
                    NewState (ob,&s_grdshoot1);
                    break;
                case officerobj:
                    NewState (ob,&s_ofcshoot1);
                    break;
                case vofficerobj:
                    NewState (ob,&s_vofcshoot1);
                    break;
                case mutantobj:
                    NewState (ob,&s_mutshoot1);
                    break;
                case spaceobj:
                    NewState (ob,&s_spcshoot1);
                    break;
                case shotobj:
                    NewState (ob,&s_shtshoot1);
                    break;
                case cultobj:
                    NewState (ob,&s_culshoot1);
                    break;
                case sniperobj:
                    NewState (ob,&s_snishoot1);
                    break;
                case hunterobj: 
                    NewState (ob,&s_shashoot1);
                   break; 
                case reaperobj: 
                    NewState (ob,&s_rprshoot1);
                   break; 
                case stealthobj: 
                    NewState (ob,&s_sthshoot1);
                   break; 
                case rocketunitobj: 
                    NewState (ob,&s_rktshoot1);
                   break; 
                case soullessobj: 
                    NewState (ob,&s_soushoot1);
                   break; 
                case ssobj:
                    NewState (ob,&s_ssshoot1);
                    break;
                case slorgaobj:
                    NewState (ob,&s_srashoot1);
                    break;
                case strikerobj:
                    NewState (ob,&s_sksshoot1);
                    break;
                case bflamerobj:
                    NewState (ob,&s_bfushoot1);
                    break;
                case aflamerobj:
                    NewState (ob,&s_afushoot1);
                    break;
                case slavegirlobj:
                    NewState (ob,&s_slvshoot1);
                    break;
                case tropperobj:
                    NewState (ob,&s_grd2shoot1);
                    break;
#ifndef SPEAR
                case bossobj:
                    NewState (ob,&s_bossshoot1);
                    break;
                case gretelobj:
                    NewState (ob,&s_gretelshoot1);
                    break;
                case mechahitlerobj:
                    NewState (ob,&s_mechashoot1);
                    break;
                case realhitlerobj:
                    NewState (ob,&s_hitlershoot1);
                    break;
#else
                case angelobj:
                    NewState (ob,&s_angelshoot1);
                    break;
                case transobj:
                    NewState (ob,&s_transshoot1);
                    break;
                case uberobj:
                    NewState (ob,&s_ubershoot1);
                    break;
                case willobj:
                    NewState (ob,&s_willshoot1);
                    break;
                case deathobj:
                    NewState (ob,&s_deathshoot1);
                    break;
#endif
            }
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            DEMOIF_SDL
            {
                TryWalk(ob);
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

/*
=================
=
= T_HunterChase
=
=================
*/

void T_HunterChase (objtype *ob)
{
    int32_t move,target;
    int     dx,dy,dist,chance;
    boolean dodge;

    if (gamestate.victoryflag)
        return;

    dodge = false;
    if (CheckLine(ob))      // got a shot at player?
    {
        ob->hidden = false;
        dx = abs(ob->tilex - player->tilex);
        dy = abs(ob->tiley - player->tiley);
        dist = dx>dy ? dx : dy;

#ifdef PLAYDEMOLIKEORIGINAL
        if(DEMOCOND_ORIG)
        {
            if(!dist || (dist == 1 && ob->distance < 0x4000))
                chance = 300;
            else
                chance = (tics<<4)/dist;
        }
        else
#endif
        {
            if (dist)
                chance = (tics<<4)/dist;
            else
                chance = 300;

            if (dist == 1)
            {
                target = abs(ob->x - player->x);
                if (target < 0x14000l)
                {
                    target = abs(ob->y - player->y);
                    if (target < 0x14000l)
                        chance = 300;
                }
            }
        }

        if ( US_RndT()<chance)
        {
            //
            // go into attack frame
            //
            switch (ob->obclass)
            {
                case hunterobj: 
                NewState (ob,&s_shaball1); break;
                break; 
            
            }
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            DEMOIF_SDL
            {
                TryWalk(ob);
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}


/*
=================
=
= T_Ghosts
=
=================
*/

void T_Ghosts (objtype *ob)
{
    int32_t move;

    if (ob->dir == nodir)
    {
        SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

/*
=================
=
= T_DogChase
=
=================
*/

void T_DogChase (objtype *ob)
{
    int32_t    move;
    int32_t    dx,dy;


    if (ob->dir == nodir)
    {
        SelectDodgeDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        //
        // check for byte range
        //
        dx = player->x - ob->x;
        if (dx<0)
            dx = -dx;
        dx -= move;
        if (dx <= MINACTORDIST)
        {
            dy = player->y - ob->y;
            if (dy<0)
                dy = -dy;
            dy -= move;
            if (dy <= MINACTORDIST)
            {
                NewState (ob,&s_dogjump1);
                return;
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        SelectDodgeDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}



/*
============================================================================

                                    PATH

============================================================================
*/


/*
===============
=
= SelectPathDir
=
===============
*/

void SelectPathDir (objtype *ob)
{
    unsigned spot;

    spot = MAPSPOT(ob->tilex,ob->tiley,1)-ICONARROWS;

    if (spot<8)
    {
        // new direction
        ob->dir = (dirtype)(spot);
    }

    ob->distance = TILEGLOBAL;

    if (!TryWalk (ob))
        ob->dir = nodir;
}


/*
===============
=
= T_Path
=
===============
*/

void T_Path (objtype *ob)
{
    int32_t    move;

    if (SightPlayer (ob))
        return;

    if (ob->dir == nodir)
    {
        SelectPathDir (ob);
        if (ob->dir == nodir)
            return;                                 // all movement is blocked
    }


    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            DEMOIF_SDL
            {
                TryWalk(ob);
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        if (ob->tilex>MAPSIZE || ob->tiley>MAPSIZE)
        {
            sprintf (str, "T_Path hit a wall at %u,%u, dir %u",
                ob->tilex,ob->tiley,ob->dir);
            Quit (str);
        }

        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;
        move -= ob->distance;

        SelectPathDir (ob);

        if (ob->dir == nodir)
            return;                                 // all movement is blocked
    }
}


/*
=============================================================================

                                    FIGHT

=============================================================================
*/


/*
===============
=
= T_Shoot
=
= Try to damage the player, based on skill level and player's speed
=
===============
*/

void T_Shoot (objtype *ob)
{
    int     dx,dy,dist;
    int     hitchance,damage;

    hitchance = 128;

    if (!areabyplayer[ob->areanumber])
        return;

    if (CheckLine (ob))                    // player is not behind a wall
    {
        dx = abs(ob->tilex - player->tilex);
        dy = abs(ob->tiley - player->tiley);
        dist = dx>dy ? dx:dy;

        if (ob->obclass == ssobj || ob->obclass == bossobj)
            dist = dist*2/3;                                        // ss are better shots

        if (thrustspeed >= RUNSPEED)
        {
            if (ob->flags&FL_VISABLE)
                hitchance = 160-dist*16;                // player can see to dodge
            else
                hitchance = 160-dist*8;
        }
        else
        {
            if (ob->flags&FL_VISABLE)
                hitchance = 256-dist*16;                // player can see to dodge
            else
                hitchance = 256-dist*8;
        }

        // see if the shot was a hit

        if (US_RndT()<hitchance)
        {
            if (dist<2)
                damage = US_RndT()>>2;
            else if (dist<4)
                damage = US_RndT()>>3;
            else
                damage = US_RndT()>>4;

            TakeDamage (damage,ob);
        }
    }

    switch(ob->obclass)
    {
        case vofficerobj:
            PlaySoundLocActor(ATKLR3000SND,ob);
            break;
        case stealthobj:
        case ssobj:
            PlaySoundLocActor(SSFIRESND,ob);
            break;
#ifndef SPEAR
#ifndef APOGEE_1_0
        case giftobj:
        case fatobj:
            PlaySoundLocActor(MISSILEFIRESND,ob);
            break;
#endif
        case mechahitlerobj:
        case realhitlerobj:
        case bossobj:
            PlaySoundLocActor(BOSSFIRESND,ob);
            break;
        case schabbobj:
            PlaySoundLocActor(SCHABBSTHROWSND,ob);
            break;
        case tropperobj:
            PlaySoundLocActor(ATKTYPE79SND,ob);
            break;
        case spaceobj:
             PlaySoundLocActor(ATKDSHOTGUNSND,ob);
             break;
        case shotobj:
             PlaySoundLocActor(ATKSHOTSND,ob);
             break;
        case cultobj:
             PlaySoundLocActor(ATKMP5SND,ob);
             break;
        case sniperobj:
             PlaySoundLocActor(ATKL46SND,ob);
             break;
        case fakeobj:
            PlaySoundLocActor(FLAMETHROWERSND,ob);
            break;
        case strikerobj:
            PlaySoundLocActor(ATKGATLINGSND,ob);
            break;
        case officerobj:
            PlaySoundLocActor(ATKBERETTASND,ob);
            break;
        case aflamerobj:
        case bflamerobj:
            PlaySoundLocActor(ATKAK47SND,ob);
            break;
#endif
        default:
            PlaySoundLocActor(NAZIFIRESND,ob);
    }
}


/*
===============
=
= T_Bite
=
===============
*/

void T_Bite (objtype *ob)
{
    int32_t    dx,dy;

    PlaySoundLocActor(DOGATTACKSND,ob);     // JAB

    dx = player->x - ob->x;
    if (dx<0)
        dx = -dx;
    dx -= TILEGLOBAL;
    if (dx <= MINACTORDIST)
    {
        dy = player->y - ob->y;
        if (dy<0)
            dy = -dy;
        dy -= TILEGLOBAL;
        if (dy <= MINACTORDIST)
        {
            if (US_RndT()<180)
            {
                TakeDamage (US_RndT()>>4,ob);
                return;
            }
        }
    }
}


#ifndef SPEAR
/*
============================================================================

                                    BJ VICTORY

============================================================================
*/


//
// BJ victory
//

void T_BJRun (objtype *ob);
void T_BJJump (objtype *ob);
void T_BJDone (objtype *ob);
void T_BJYell (objtype *ob);

void T_DeathCam (objtype *ob);

extern  statetype s_bjrun1;
extern  statetype s_bjrun1s;
extern  statetype s_bjrun2;
extern  statetype s_bjrun3;
extern  statetype s_bjrun3s;
extern  statetype s_bjrun4;

extern  statetype s_bjjump1;
extern  statetype s_bjjump2;
extern  statetype s_bjjump3;
extern  statetype s_bjjump4;


statetype s_bjrun1              = {false,SPR_BJ_W1,12,(statefunc)T_BJRun,NULL,&s_bjrun1s};
statetype s_bjrun1s             = {false,SPR_BJ_W1,3, NULL,NULL,&s_bjrun2};
statetype s_bjrun2              = {false,SPR_BJ_W2,8,(statefunc)T_BJRun,NULL,&s_bjrun3};
statetype s_bjrun3              = {false,SPR_BJ_W3,12,(statefunc)T_BJRun,NULL,&s_bjrun3s};
statetype s_bjrun3s             = {false,SPR_BJ_W3,3, NULL,NULL,&s_bjrun4};
statetype s_bjrun4              = {false,SPR_BJ_W4,8,(statefunc)T_BJRun,NULL,&s_bjrun1};


statetype s_bjjump1             = {false,SPR_BJ_JUMP1,14,(statefunc)T_BJJump,NULL,&s_bjjump2};
statetype s_bjjump2             = {false,SPR_BJ_JUMP2,14,(statefunc)T_BJJump,(statefunc)T_BJYell,&s_bjjump3};
statetype s_bjjump3             = {false,SPR_BJ_JUMP3,14,(statefunc)T_BJJump,NULL,&s_bjjump4};
statetype s_bjjump4             = {false,SPR_BJ_JUMP4,300,NULL,(statefunc)T_BJDone,&s_bjjump4};


statetype s_deathcam            = {false,0,0,NULL,NULL,NULL};


/*
===============
=
= SpawnBJVictory
=
===============
*/

void SpawnBJVictory (void)
{
    SpawnNewObj (player->tilex,player->tiley+1,&s_bjrun1);
    newobj->x = player->x;
    newobj->y = player->y;
    newobj->obclass = bjobj;
    newobj->dir = north;
    newobj->temp1 = 6;                      // tiles to run forward
}



/*
===============
=
= T_BJRun
=
===============
*/

void T_BJRun (objtype *ob)
{
    int32_t    move;

    move = BJRUNSPEED*tics;

    while (move)
    {
        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }


        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;
        move -= ob->distance;

        SelectPathDir (ob);

        if ( !(--ob->temp1) )
        {
            NewState (ob,&s_bjjump1);
            return;
        }
    }
}


/*
===============
=
= T_BJJump
=
===============
*/

void T_BJJump (objtype *ob)
{
    int32_t    move;

    move = BJJUMPSPEED*tics;
    MoveObj (ob,move);
}


/*
===============
=
= T_BJYell
=
===============
*/

void T_BJYell (objtype *ob)
{
    PlaySoundLocActor(YEAHSND,ob);  // JAB
}


/*
===============
=
= T_BJDone
=
===============
*/

void T_BJDone (objtype *)
{
    playstate = ex_victorious;                              // exit castle tile
}



//===========================================================================


/*
===============
=
= CheckPosition
=
===============
*/

boolean CheckPosition (objtype *ob)
{
    int     x,y,xl,yl,xh,yh;
    objtype *check;

    xl = (ob->x-PLAYERSIZE) >> TILESHIFT;
    yl = (ob->y-PLAYERSIZE) >> TILESHIFT;

    xh = (ob->x+PLAYERSIZE) >> TILESHIFT;
    yh = (ob->y+PLAYERSIZE) >> TILESHIFT;

    //
    // check for solid walls
    //
    for (y=yl;y<=yh;y++)
    {
        for (x=xl;x<=xh;x++)
        {
            check = actorat[x][y];
            if (check && !ISPOINTER(check))
                return false;
        }
    }

    return true;
}


/*
===============
=
= A_StartDeathCam
=
===============
*/

void    A_StartDeathCam (objtype *ob)
{
    int32_t dx,dy;
    float   fangle;
    int32_t xmove,ymove;
    int32_t dist;

    FinishPaletteShifts ();

    VW_WaitVBL (100);

    if (gamestate.victoryflag)
    {
        playstate = ex_victorious;                              // exit castle tile
        return;
    }

    gamestate.victoryflag = true;
    unsigned fadeheight = viewsize != 21 ? screenHeight-scaleFactor*STATUSLINES : screenHeight;
    VL_BarScaledCoord (0, 0, screenWidth, fadeheight, bordercol);
    FizzleFade(screenBuffer, screen, 0, 0, screenWidth, fadeheight, 70, false);

    if (bordercol != VIEWCOLOR)
    {
        CA_CacheGrChunk (STARTFONT+1);
        fontnumber = 1;
        SETFONTCOLOR(15,bordercol);
        PrintX = 68; PrintY = 45;
        US_Print (STR_SEEAGAIN);
        UNCACHEGRCHUNK(STARTFONT+1);
    }
    else
    {
        CacheLump(LEVELEND_LUMP_START,LEVELEND_LUMP_END);
#ifdef JAPAN
#ifndef JAPDEMO
        CA_CacheScreen(C_LETSSEEPIC);
#endif
#else
        Write(0,7,STR_SEEAGAIN);
#endif
    }

    VW_UpdateScreen ();

    IN_UserInput(300);

    //
    // line angle up exactly
    //
    NewState (player,&s_deathcam);

    player->x = gamestate.killx;
    player->y = gamestate.killy;

    dx = ob->x - player->x;
    dy = player->y - ob->y;

    fangle = (float) atan2((float) dy, (float) dx);          // returns -pi to pi
    if (fangle<0)
        fangle = (float) (M_PI*2+fangle);

    player->angle = (short) (fangle/(M_PI*2)*ANGLES);

    //
    // try to position as close as possible without being in a wall
    //
    dist = 0x14000l;
    do
    {
        xmove = FixedMul(dist,costable[player->angle]);
        ymove = -FixedMul(dist,sintable[player->angle]);

        player->x = ob->x - xmove;
        player->y = ob->y - ymove;
        dist += 0x1000;

    } while (!CheckPosition (player));
    plux = (word)(player->x >> UNSIGNEDSHIFT);                      // scale to fit in unsigned
    pluy = (word)(player->y >> UNSIGNEDSHIFT);
    player->tilex = (word)(player->x >> TILESHIFT);         // scale to tile values
    player->tiley = (word)(player->y >> TILESHIFT);

    //
    // go back to the game
    //

    DrawPlayBorder ();

    fizzlein = true;

    switch (ob->obclass)
    {
#ifndef SPEAR
        case schabbobj:
            NewState (ob,&s_schabbdeathcam);
            break;
        case realhitlerobj:
            NewState (ob,&s_hitlerdeathcam);
            break;
        case giftobj:
            NewState (ob,&s_giftdeathcam);
            break;
        case fatobj:
            NewState (ob,&s_fatdeathcam);
            break;
#endif
    }
}

#endif
